import { CandidatesCollection } from 'antlr4-c3';
import { CharStream, CommonTokenStream, Token } from 'antlr4ng';
import { FlinkSqlLexer } from '../../lib/flink/FlinkSqlLexer';
import { FlinkSqlParser, ProgramContext } from '../../lib/flink/FlinkSqlParser';
import { CaretPosition, SemanticCollectOptions, Suggestions } from '../common/types';
import { BasicSQL } from '../common/basicSQL';
import { ErrorListener } from '../common/parseErrorListener';
import { FlinkEntityCollector } from './flinkEntityCollector';
import { FlinkErrorListener } from './flinkErrorListener';
import { FlinkSqlSplitListener } from './flinkSplitListener';
import { FlinkSemanticContextCollector } from './flinkSemanticContextCollector';
export { FlinkEntityCollector, FlinkSqlSplitListener };
export declare class FlinkSQL extends BasicSQL<FlinkSqlLexer, ProgramContext, FlinkSqlParser> {
    protected createLexerFromCharStream(charStreams: CharStream): FlinkSqlLexer;
    protected createParserFromTokenStream(tokenStream: CommonTokenStream): FlinkSqlParser;
    protected preferredRules: Set<number>;
    protected get splitListener(): FlinkSqlSplitListener;
    protected createErrorListener(_errorListener: ErrorListener): FlinkErrorListener;
    protected createEntityCollector(input: string, allTokens?: Token[], caretTokenIndex?: number): FlinkEntityCollector;
    protected createSemanticContextCollector(input: string, caretPosition: CaretPosition, allTokens: Token[], options?: SemanticCollectOptions): FlinkSemanticContextCollector;
    protected processCandidates(candidates: CandidatesCollection, allTokens: Token[], caretTokenIndex: number): Suggestions<Token>;
}
