import { CandidatesCollection } from 'antlr4-c3';
import { CharStream, CommonTokenStream, Token } from 'antlr4ng';
import { HiveSqlLexer } from '../../lib/hive/HiveSqlLexer';
import { HiveSqlParser, ProgramContext } from '../../lib/hive/HiveSqlParser';
import { BasicSQL } from '../common/basicSQL';
import { CaretPosition, SemanticCollectOptions, Suggestions } from '../common/types';
import { ErrorListener } from '../common/parseErrorListener';
import { HiveEntityCollector } from './hiveEntityCollector';
import { HiveErrorListener } from './hiveErrorListener';
import { HiveSqlSplitListener } from './hiveSplitListener';
import { HiveSemanticContextCollector } from './hiveSemanticContextCollector';
export { HiveEntityCollector, HiveSqlSplitListener };
export declare class HiveSQL extends BasicSQL<HiveSqlLexer, ProgramContext, HiveSqlParser> {
    protected createLexerFromCharStream(charStreams: CharStream): HiveSqlLexer;
    protected createParserFromTokenStream(tokenStream: CommonTokenStream): HiveSqlParser;
    protected preferredRules: Set<number>;
    protected get splitListener(): HiveSqlSplitListener;
    protected createErrorListener(_errorListener: ErrorListener): HiveErrorListener;
    protected createEntityCollector(input: string, allTokens?: Token[], caretTokenIndex?: number): HiveEntityCollector;
    protected createSemanticContextCollector(input: string, caretPosition: CaretPosition, allTokens: Token[], options?: SemanticCollectOptions): HiveSemanticContextCollector;
    protected processCandidates(candidates: CandidatesCollection, allTokens: Token[], caretTokenIndex: number): Suggestions<Token>;
}
