import { CandidatesCollection } from 'antlr4-c3';
import { CharStream, CommonTokenStream, Token } from 'antlr4ng';
import { MySqlLexer } from '../../lib/mysql/MySqlLexer';
import { MySqlParser, ProgramContext } from '../../lib/mysql/MySqlParser';
import { BasicSQL } from '../common/basicSQL';
import { Suggestions, CaretPosition, SemanticCollectOptions } from '../common/types';
import { ErrorListener } from '../common/parseErrorListener';
import { MySqlEntityCollector } from './mysqlEntityCollector';
import { MysqlErrorListener } from './mysqlErrorListener';
import { MysqlSplitListener } from './mysqlSplitListener';
import { MySqlSemanticContextCollector } from '../mysql/mysqlSemanticContextCollector';
export { MySqlEntityCollector, MysqlSplitListener };
export declare class MySQL extends BasicSQL<MySqlLexer, ProgramContext, MySqlParser> {
    protected createLexerFromCharStream(charStreams: CharStream): MySqlLexer;
    protected createParserFromTokenStream(tokenStream: CommonTokenStream): MySqlParser;
    protected preferredRules: Set<number>;
    protected get splitListener(): MysqlSplitListener;
    protected createErrorListener(_errorListener: ErrorListener): MysqlErrorListener;
    protected createEntityCollector(input: string, allTokens?: Token[], caretTokenIndex?: number): MySqlEntityCollector;
    protected createSemanticContextCollector(input: string, caretPosition: CaretPosition, allTokens: Token[], options?: SemanticCollectOptions): MySqlSemanticContextCollector;
    protected processCandidates(candidates: CandidatesCollection, allTokens: Token[], caretTokenIndex: number): Suggestions<Token>;
}
