import { CandidatesCollection } from 'antlr4-c3';
import { CharStream, CommonTokenStream, Token } from 'antlr4ng';
import { PostgreSqlLexer } from '../../lib/postgresql/PostgreSqlLexer';
import { PostgreSqlParser, ProgramContext } from '../../lib/postgresql/PostgreSqlParser';
import { CaretPosition, SemanticCollectOptions, Suggestions } from '../common/types';
import { BasicSQL } from '../common/basicSQL';
import { ErrorListener } from '../common/parseErrorListener';
import { PostgreSqlEntityCollector } from './postgreEntityCollector';
import { PostgreSqlErrorListener } from './postgreErrorListener';
import { PostgreSqlSplitListener } from './postgreSplitListener';
import { PostgreSemanticContextCollector } from './postgreSemanticContextCollector';
export { PostgreSqlEntityCollector, PostgreSqlSplitListener };
export declare class PostgreSQL extends BasicSQL<PostgreSqlLexer, ProgramContext, PostgreSqlParser> {
    protected createLexerFromCharStream(charStreams: CharStream): PostgreSqlLexer;
    protected createParserFromTokenStream(tokenStream: CommonTokenStream): PostgreSqlParser;
    protected preferredRules: Set<number>;
    protected get splitListener(): PostgreSqlSplitListener;
    protected createErrorListener(_errorListener: ErrorListener): PostgreSqlErrorListener;
    protected createEntityCollector(input: string, allTokens?: Token[], caretTokenIndex?: number): PostgreSqlEntityCollector;
    protected createSemanticContextCollector(input: string, caretPosition: CaretPosition, allTokens: Token[], options?: SemanticCollectOptions): PostgreSemanticContextCollector;
    protected processCandidates(candidates: CandidatesCollection, allTokens: Token[], caretTokenIndex: number): Suggestions<Token>;
}
