import * as antlr from "antlr4ng";
import { Token } from "antlr4ng";
import { PostgreSqlParserListener } from "./PostgreSqlParserListener.js";
import { PostgreSqlParserVisitor } from "./PostgreSqlParserVisitor.js";
import { SQLParserBase } from '../SQLParserBase';
export declare class PostgreSqlParser extends SQLParserBase {
    static readonly Dollar = 1;
    static readonly OPEN_PAREN = 2;
    static readonly CLOSE_PAREN = 3;
    static readonly OPEN_BRACKET = 4;
    static readonly CLOSE_BRACKET = 5;
    static readonly COMMA = 6;
    static readonly SEMI = 7;
    static readonly COLON = 8;
    static readonly STAR = 9;
    static readonly EQUAL = 10;
    static readonly DOT = 11;
    static readonly PLUS = 12;
    static readonly MINUS = 13;
    static readonly SLASH = 14;
    static readonly CARET = 15;
    static readonly LT = 16;
    static readonly GT = 17;
    static readonly LESS_LESS = 18;
    static readonly GREATER_GREATER = 19;
    static readonly COLON_EQUALS = 20;
    static readonly LESS_EQUALS = 21;
    static readonly EQUALS_GREATER = 22;
    static readonly GREATER_EQUALS = 23;
    static readonly DOT_DOT = 24;
    static readonly NOT_EQUALS = 25;
    static readonly TYPECAST = 26;
    static readonly PERCENT = 27;
    static readonly PARAM = 28;
    static readonly Operator = 29;
    static readonly KW_ALL = 30;
    static readonly KW_ANALYSE = 31;
    static readonly KW_ANALYZE = 32;
    static readonly KW_AND = 33;
    static readonly KW_ANY = 34;
    static readonly KW_ARRAY = 35;
    static readonly KW_AS = 36;
    static readonly KW_ASC = 37;
    static readonly KW_ASYMMETRIC = 38;
    static readonly KW_BOTH = 39;
    static readonly KW_CASE = 40;
    static readonly KW_CAST = 41;
    static readonly KW_CHECK = 42;
    static readonly KW_COLLATE = 43;
    static readonly KW_COLUMN = 44;
    static readonly KW_CONSTRAINT = 45;
    static readonly KW_CREATE = 46;
    static readonly KW_CURRENT_CATALOG = 47;
    static readonly KW_CURRENT_DATE = 48;
    static readonly KW_CURRENT_ROLE = 49;
    static readonly KW_CURRENT_TIME = 50;
    static readonly KW_CURRENT_TIMESTAMP = 51;
    static readonly KW_CURRENT_USER = 52;
    static readonly KW_DEFAULT = 53;
    static readonly KW_DEFERRABLE = 54;
    static readonly KW_DESC = 55;
    static readonly KW_DISTINCT = 56;
    static readonly KW_DO = 57;
    static readonly KW_ELSE = 58;
    static readonly KW_EXCEPT = 59;
    static readonly KW_FALSE = 60;
    static readonly KW_FETCH = 61;
    static readonly KW_FOR = 62;
    static readonly KW_FOREIGN = 63;
    static readonly KW_FROM = 64;
    static readonly KW_GRANT = 65;
    static readonly KW_GROUP = 66;
    static readonly KW_HAVING = 67;
    static readonly KW_IN = 68;
    static readonly KW_INITIALLY = 69;
    static readonly KW_INTERSECT = 70;
    static readonly KW_INTO = 71;
    static readonly KW_LATERAL = 72;
    static readonly KW_LEADING = 73;
    static readonly KW_LIMIT = 74;
    static readonly KW_LOCALTIME = 75;
    static readonly KW_LOCALTIMESTAMP = 76;
    static readonly KW_NOT = 77;
    static readonly KW_NULL = 78;
    static readonly KW_OFFSET = 79;
    static readonly KW_ON = 80;
    static readonly KW_ONLY = 81;
    static readonly KW_OR = 82;
    static readonly KW_ORDER = 83;
    static readonly KW_PLACING = 84;
    static readonly KW_PRIMARY = 85;
    static readonly KW_REFERENCES = 86;
    static readonly KW_RETURNING = 87;
    static readonly KW_SELECT = 88;
    static readonly KW_SESSION_USER = 89;
    static readonly KW_SOME = 90;
    static readonly KW_SYMMETRIC = 91;
    static readonly KW_TABLE = 92;
    static readonly KW_THEN = 93;
    static readonly KW_TO = 94;
    static readonly KW_TRAILING = 95;
    static readonly KW_TRUE = 96;
    static readonly KW_UNION = 97;
    static readonly KW_UNIQUE = 98;
    static readonly KW_USER = 99;
    static readonly KW_USING = 100;
    static readonly KW_VARIADIC = 101;
    static readonly KW_WHEN = 102;
    static readonly KW_WHERE = 103;
    static readonly KW_WINDOW = 104;
    static readonly KW_WITH = 105;
    static readonly KW_AUTHORIZATION = 106;
    static readonly KW_BINARY = 107;
    static readonly KW_COLLATION = 108;
    static readonly KW_CONCURRENTLY = 109;
    static readonly KW_CROSS = 110;
    static readonly KW_CURRENT_SCHEMA = 111;
    static readonly KW_FREEZE = 112;
    static readonly KW_FULL = 113;
    static readonly KW_ILIKE = 114;
    static readonly KW_INNER = 115;
    static readonly KW_IS = 116;
    static readonly KW_ISNULL = 117;
    static readonly KW_JOIN = 118;
    static readonly KW_LEFT = 119;
    static readonly KW_LIKE = 120;
    static readonly KW_NATURAL = 121;
    static readonly KW_NOTNULL = 122;
    static readonly KW_OUTER = 123;
    static readonly KW_OVER = 124;
    static readonly KW_OVERLAPS = 125;
    static readonly KW_RIGHT = 126;
    static readonly KW_SIMILAR = 127;
    static readonly KW_VERBOSE = 128;
    static readonly KW_ABORT = 129;
    static readonly KW_ABSOLUTE = 130;
    static readonly KW_ACCESS = 131;
    static readonly KW_ACTION = 132;
    static readonly KW_ADD = 133;
    static readonly KW_ADMIN = 134;
    static readonly KW_AFTER = 135;
    static readonly KW_AGGREGATE = 136;
    static readonly KW_ALSO = 137;
    static readonly KW_ALTER = 138;
    static readonly KW_ALWAYS = 139;
    static readonly KW_ASSERTION = 140;
    static readonly KW_ASSIGNMENT = 141;
    static readonly KW_AT = 142;
    static readonly KW_ATTRIBUTE = 143;
    static readonly KW_BACKWARD = 144;
    static readonly KW_BEFORE = 145;
    static readonly KW_BEGIN = 146;
    static readonly KW_BY = 147;
    static readonly KW_CACHE = 148;
    static readonly KW_CALLED = 149;
    static readonly KW_CASCADE = 150;
    static readonly KW_CASCADED = 151;
    static readonly KW_CATALOG = 152;
    static readonly KW_CHAIN = 153;
    static readonly KW_CHARACTERISTICS = 154;
    static readonly KW_CHECKPOINT = 155;
    static readonly KW_CLASS = 156;
    static readonly KW_CLOSE = 157;
    static readonly KW_CLUSTER = 158;
    static readonly KW_COMMENT = 159;
    static readonly KW_COMMENTS = 160;
    static readonly KW_COMMIT = 161;
    static readonly KW_COMMITTED = 162;
    static readonly KW_CONFIGURATION = 163;
    static readonly KW_CONNECTION = 164;
    static readonly KW_CONSTRAINTS = 165;
    static readonly KW_CONTENT = 166;
    static readonly KW_CONTINUE = 167;
    static readonly KW_CONVERSION = 168;
    static readonly KW_COPY = 169;
    static readonly KW_COST = 170;
    static readonly KW_CSV = 171;
    static readonly KW_CURSOR = 172;
    static readonly KW_CYCLE = 173;
    static readonly KW_DATA = 174;
    static readonly KW_DATABASE = 175;
    static readonly KW_DAY = 176;
    static readonly KW_DEALLOCATE = 177;
    static readonly KW_DECLARE = 178;
    static readonly KW_DEFAULTS = 179;
    static readonly KW_DEFERRED = 180;
    static readonly KW_DEFINER = 181;
    static readonly KW_DELETE = 182;
    static readonly KW_DELIMITER = 183;
    static readonly KW_DELIMITERS = 184;
    static readonly KW_DICTIONARY = 185;
    static readonly KW_DISABLE = 186;
    static readonly KW_DISCARD = 187;
    static readonly KW_DOCUMENT = 188;
    static readonly KW_DOMAIN = 189;
    static readonly KW_DOUBLE = 190;
    static readonly KW_DROP = 191;
    static readonly KW_EACH = 192;
    static readonly KW_ENABLE = 193;
    static readonly KW_ENCODING = 194;
    static readonly KW_ENCRYPTED = 195;
    static readonly KW_ENUM = 196;
    static readonly KW_ESCAPE = 197;
    static readonly KW_EVENT = 198;
    static readonly KW_EXCLUDE = 199;
    static readonly KW_EXCLUDING = 200;
    static readonly KW_EXCLUSIVE = 201;
    static readonly KW_EXECUTE = 202;
    static readonly KW_EXPLAIN = 203;
    static readonly KW_EXTENSION = 204;
    static readonly KW_EXTERNAL = 205;
    static readonly KW_FAMILY = 206;
    static readonly KW_FIRST = 207;
    static readonly KW_FOLLOWING = 208;
    static readonly KW_FORCE = 209;
    static readonly KW_FORWARD = 210;
    static readonly KW_FUNCTION = 211;
    static readonly KW_FUNCTIONS = 212;
    static readonly KW_GLOBAL = 213;
    static readonly KW_GRANTED = 214;
    static readonly KW_HANDLER = 215;
    static readonly KW_HEADER = 216;
    static readonly KW_HOLD = 217;
    static readonly KW_HOUR = 218;
    static readonly KW_IDENTITY = 219;
    static readonly KW_IF = 220;
    static readonly KW_IMMEDIATE = 221;
    static readonly KW_IMMUTABLE = 222;
    static readonly KW_IMPLICIT = 223;
    static readonly KW_INCLUDING = 224;
    static readonly KW_INCREMENT = 225;
    static readonly KW_INDEX = 226;
    static readonly KW_INDEXES = 227;
    static readonly KW_INHERIT = 228;
    static readonly KW_NOINHERIT = 229;
    static readonly KW_SUPERUSER = 230;
    static readonly KW_NOSUPERUSER = 231;
    static readonly KW_CREATEDB = 232;
    static readonly KW_NOCREATEDB = 233;
    static readonly KW_CREATEROLE = 234;
    static readonly KW_NOCREATEROLE = 235;
    static readonly KW_CREATEUSER = 236;
    static readonly KW_NOCREATEUSER = 237;
    static readonly KW_INHERITS = 238;
    static readonly KW_INLINE = 239;
    static readonly KW_INSENSITIVE = 240;
    static readonly KW_INSERT = 241;
    static readonly KW_INSTEAD = 242;
    static readonly KW_INVOKER = 243;
    static readonly KW_ISOLATION = 244;
    static readonly KW_KEY = 245;
    static readonly KW_LABEL = 246;
    static readonly KW_LANGUAGE = 247;
    static readonly KW_LARGE = 248;
    static readonly KW_LAST = 249;
    static readonly KW_LEAKPROOF = 250;
    static readonly KW_LEVEL = 251;
    static readonly KW_LISTEN = 252;
    static readonly KW_LOAD = 253;
    static readonly KW_LOCAL = 254;
    static readonly KW_LOCATION = 255;
    static readonly KW_LOCK = 256;
    static readonly KW_MAPPING = 257;
    static readonly KW_MATCH = 258;
    static readonly KW_MATERIALIZED = 259;
    static readonly KW_MAXVALUE = 260;
    static readonly KW_MINUTE = 261;
    static readonly KW_MINVALUE = 262;
    static readonly KW_MODE = 263;
    static readonly KW_MONTH = 264;
    static readonly KW_MOVE = 265;
    static readonly KW_NAME = 266;
    static readonly KW_NAMES = 267;
    static readonly KW_NEXT = 268;
    static readonly KW_NO = 269;
    static readonly KW_NOTHING = 270;
    static readonly KW_NOTIFY = 271;
    static readonly KW_NOWAIT = 272;
    static readonly KW_NULLS = 273;
    static readonly KW_OBJECT = 274;
    static readonly KW_OF = 275;
    static readonly KW_OFF = 276;
    static readonly KW_OIDS = 277;
    static readonly KW_OPERATOR = 278;
    static readonly KW_OPTION = 279;
    static readonly KW_OPTIONS = 280;
    static readonly KW_OWNED = 281;
    static readonly KW_OWNER = 282;
    static readonly KW_PARSER = 283;
    static readonly KW_PARTIAL = 284;
    static readonly KW_PARTITION = 285;
    static readonly KW_PASSING = 286;
    static readonly KW_PASSWORD = 287;
    static readonly KW_PLANS = 288;
    static readonly KW_PRECEDING = 289;
    static readonly KW_PREPARE = 290;
    static readonly KW_PREPARED = 291;
    static readonly KW_PRESERVE = 292;
    static readonly KW_PRIOR = 293;
    static readonly KW_PRIVILEGES = 294;
    static readonly KW_PROCEDURAL = 295;
    static readonly KW_PROCEDURE = 296;
    static readonly KW_PROGRAM = 297;
    static readonly KW_QUOTE = 298;
    static readonly KW_RANGE = 299;
    static readonly KW_READ = 300;
    static readonly KW_REASSIGN = 301;
    static readonly KW_RECHECK = 302;
    static readonly KW_RECURSIVE = 303;
    static readonly KW_REF = 304;
    static readonly KW_REFRESH = 305;
    static readonly KW_REINDEX = 306;
    static readonly KW_RELATIVE = 307;
    static readonly KW_RELEASE = 308;
    static readonly KW_RENAME = 309;
    static readonly KW_REPEATABLE = 310;
    static readonly KW_REPLACE = 311;
    static readonly KW_REPLICA = 312;
    static readonly KW_RESET = 313;
    static readonly KW_RESTART = 314;
    static readonly KW_RESTRICT = 315;
    static readonly KW_RETURNS = 316;
    static readonly KW_REVOKE = 317;
    static readonly KW_ROLE = 318;
    static readonly KW_ROLLBACK = 319;
    static readonly KW_ROWS = 320;
    static readonly KW_RULE = 321;
    static readonly KW_SAVEPOINT = 322;
    static readonly KW_SCHEMA = 323;
    static readonly KW_SCROLL = 324;
    static readonly KW_SEARCH = 325;
    static readonly KW_SECOND = 326;
    static readonly KW_SECURITY = 327;
    static readonly KW_SEQUENCE = 328;
    static readonly KW_SEQUENCES = 329;
    static readonly KW_SERIALIZABLE = 330;
    static readonly KW_SERVER = 331;
    static readonly KW_SESSION = 332;
    static readonly KW_SET = 333;
    static readonly KW_SHARE = 334;
    static readonly KW_SHOW = 335;
    static readonly KW_SIMPLE = 336;
    static readonly KW_SNAPSHOT = 337;
    static readonly KW_STABLE = 338;
    static readonly KW_STANDALONE = 339;
    static readonly KW_START = 340;
    static readonly KW_STATEMENT = 341;
    static readonly KW_STATISTICS = 342;
    static readonly KW_STDIN = 343;
    static readonly KW_STDOUT = 344;
    static readonly KW_STORAGE = 345;
    static readonly KW_STRICT = 346;
    static readonly KW_STRIP = 347;
    static readonly KW_SYSID = 348;
    static readonly KW_SYSTEM = 349;
    static readonly KW_TABLES = 350;
    static readonly KW_TABLESPACE = 351;
    static readonly KW_TEMP = 352;
    static readonly KW_TEMPLATE = 353;
    static readonly KW_TEMPORARY = 354;
    static readonly KW_TEXT = 355;
    static readonly KW_TRANSACTION = 356;
    static readonly KW_TRIGGER = 357;
    static readonly KW_TRUNCATE = 358;
    static readonly KW_TRUSTED = 359;
    static readonly KW_TYPE = 360;
    static readonly KW_TYPES = 361;
    static readonly KW_UNBOUNDED = 362;
    static readonly KW_UNCOMMITTED = 363;
    static readonly KW_UNENCRYPTED = 364;
    static readonly KW_UNKNOWN = 365;
    static readonly KW_UNLISTEN = 366;
    static readonly KW_UNLOGGED = 367;
    static readonly KW_UNTIL = 368;
    static readonly KW_UPDATE = 369;
    static readonly KW_VACUUM = 370;
    static readonly KW_VALID = 371;
    static readonly KW_VALIDATE = 372;
    static readonly KW_VALIDATOR = 373;
    static readonly KW_VARYING = 374;
    static readonly KW_VERSION = 375;
    static readonly KW_VIEW = 376;
    static readonly KW_VOLATILE = 377;
    static readonly KW_WHITESPACE = 378;
    static readonly KW_WITHOUT = 379;
    static readonly KW_WORK = 380;
    static readonly KW_WRAPPER = 381;
    static readonly KW_WRITE = 382;
    static readonly KW_XML = 383;
    static readonly KW_YEAR = 384;
    static readonly KW_YES = 385;
    static readonly KW_ZONE = 386;
    static readonly KW_BETWEEN = 387;
    static readonly KW_BIGINT = 388;
    static readonly KW_BIT = 389;
    static readonly KW_BOOLEAN = 390;
    static readonly KW_CHAR = 391;
    static readonly KW_CHARACTER = 392;
    static readonly KW_COALESCE = 393;
    static readonly KW_DEC = 394;
    static readonly KW_DECIMAL = 395;
    static readonly KW_EXISTS = 396;
    static readonly KW_EXTRACT = 397;
    static readonly KW_FLOAT = 398;
    static readonly KW_GREATEST = 399;
    static readonly KW_INOUT = 400;
    static readonly KW_INT = 401;
    static readonly KW_INTEGER = 402;
    static readonly KW_INTERVAL = 403;
    static readonly KW_LEAST = 404;
    static readonly KW_NATIONAL = 405;
    static readonly KW_NCHAR = 406;
    static readonly KW_NONE = 407;
    static readonly KW_NULLIF = 408;
    static readonly KW_NUMERIC = 409;
    static readonly KW_OVERLAY = 410;
    static readonly KW_POSITION = 411;
    static readonly KW_PRECISION = 412;
    static readonly KW_REAL = 413;
    static readonly KW_ROW = 414;
    static readonly KW_SETOF = 415;
    static readonly KW_SMALLINT = 416;
    static readonly KW_SUBSTRING = 417;
    static readonly KW_TIME = 418;
    static readonly KW_TIMESTAMP = 419;
    static readonly KW_TREAT = 420;
    static readonly KW_TRIM = 421;
    static readonly KW_VALUES = 422;
    static readonly KW_VARCHAR = 423;
    static readonly KW_XMLATTRIBUTES = 424;
    static readonly KW_XMLCONCAT = 425;
    static readonly KW_XMLELEMENT = 426;
    static readonly KW_XMLEXISTS = 427;
    static readonly KW_XMLFOREST = 428;
    static readonly KW_XMLPARSE = 429;
    static readonly KW_XMLPI = 430;
    static readonly KW_XMLROOT = 431;
    static readonly KW_XMLSERIALIZE = 432;
    static readonly KW_CALL = 433;
    static readonly KW_CURRENT = 434;
    static readonly KW_ATTACH = 435;
    static readonly KW_DETACH = 436;
    static readonly KW_EXPRESSION = 437;
    static readonly KW_GENERATED = 438;
    static readonly KW_LOGGED = 439;
    static readonly KW_STORED = 440;
    static readonly KW_INCLUDE = 441;
    static readonly KW_ROUTINE = 442;
    static readonly KW_TRANSFORM = 443;
    static readonly KW_IMPORT = 444;
    static readonly KW_POLICY = 445;
    static readonly KW_METHOD = 446;
    static readonly KW_REFERENCING = 447;
    static readonly KW_NEW = 448;
    static readonly KW_OLD = 449;
    static readonly KW_VALUE = 450;
    static readonly KW_SUBSCRIPTION = 451;
    static readonly KW_PUBLICATION = 452;
    static readonly KW_OUT = 453;
    static readonly KW_END = 454;
    static readonly KW_ROUTINES = 455;
    static readonly KW_SCHEMAS = 456;
    static readonly KW_PROCEDURES = 457;
    static readonly KW_INPUT = 458;
    static readonly KW_SUPPORT = 459;
    static readonly KW_PARALLEL = 460;
    static readonly KW_SQL = 461;
    static readonly KW_DEPENDS = 462;
    static readonly KW_OVERRIDING = 463;
    static readonly KW_CONFLICT = 464;
    static readonly KW_SKIP = 465;
    static readonly KW_LOCKED = 466;
    static readonly KW_TIES = 467;
    static readonly KW_ROLLUP = 468;
    static readonly KW_CUBE = 469;
    static readonly KW_GROUPING = 470;
    static readonly KW_SETS = 471;
    static readonly KW_TABLESAMPLE = 472;
    static readonly KW_ORDINALITY = 473;
    static readonly KW_XMLTABLE = 474;
    static readonly KW_COLUMNS = 475;
    static readonly KW_XMLNAMESPACES = 476;
    static readonly KW_ROWTYPE = 477;
    static readonly KW_NORMALIZED = 478;
    static readonly KW_WITHIN = 479;
    static readonly KW_FILTER = 480;
    static readonly KW_GROUPS = 481;
    static readonly KW_OTHERS = 482;
    static readonly KW_NFC = 483;
    static readonly KW_NFD = 484;
    static readonly KW_NFKC = 485;
    static readonly KW_NFKD = 486;
    static readonly KW_UESCAPE = 487;
    static readonly KW_VIEWS = 488;
    static readonly KW_NORMALIZE = 489;
    static readonly KW_DUMP = 490;
    static readonly KW_PRINT_STRICT_PARAMS = 491;
    static readonly KW_VARIABLE_CONFLICT = 492;
    static readonly KW_ERROR = 493;
    static readonly KW_USE_VARIABLE = 494;
    static readonly KW_USE_COLUMN = 495;
    static readonly KW_ALIAS = 496;
    static readonly KW_CONSTANT = 497;
    static readonly KW_PERFORM = 498;
    static readonly KW_GET = 499;
    static readonly KW_DIAGNOSTICS = 500;
    static readonly KW_STACKED = 501;
    static readonly KW_ELSIF = 502;
    static readonly KW_WHILE = 503;
    static readonly KW_REVERSE = 504;
    static readonly KW_FOREACH = 505;
    static readonly KW_SLICE = 506;
    static readonly KW_EXIT = 507;
    static readonly KW_RETURN = 508;
    static readonly KW_QUERY = 509;
    static readonly KW_RAISE = 510;
    static readonly KW_SQLSTATE = 511;
    static readonly KW_DEBUG = 512;
    static readonly KW_LOG = 513;
    static readonly KW_INFO = 514;
    static readonly KW_NOTICE = 515;
    static readonly KW_WARNING = 516;
    static readonly KW_EXCEPTION = 517;
    static readonly KW_ASSERT = 518;
    static readonly KW_LOOP = 519;
    static readonly KW_OPEN = 520;
    static readonly KW_PEFERENCES = 521;
    static readonly KW_USAGE = 522;
    static readonly KW_CONNECT = 523;
    static readonly KW_PUBLIC = 524;
    static readonly KW_MERGE = 525;
    static readonly KW_MATCHED = 526;
    static readonly KW_BREADTH = 527;
    static readonly KW_DEPTH = 528;
    static readonly KW_UNSAFE = 529;
    static readonly KW_RESTRICTED = 530;
    static readonly KW_SAFE = 531;
    static readonly KW_FINALIZE = 532;
    static readonly KW_MODULUS = 533;
    static readonly KW_REMAINDER = 534;
    static readonly KW_LOGIN = 535;
    static readonly KW_NOLOGIN = 536;
    static readonly KW_REPLICATION = 537;
    static readonly KW_NOREPLICATION = 538;
    static readonly KW_BYPASSRLS = 539;
    static readonly KW_NOBYPASSRLS = 540;
    static readonly KW_PERMISSIVE = 541;
    static readonly KW_RESTRICTIVE = 542;
    static readonly KW_COMPRESSION = 543;
    static readonly KW_PLAIN = 544;
    static readonly KW_EXTENDED = 545;
    static readonly KW_MAIN = 546;
    static readonly KW_SKIP_LOCKED = 547;
    static readonly KW_BUFFER_USAGE_LIMIT = 548;
    static readonly KW_FORCE_QUOTE = 549;
    static readonly KW_FORCE_NOT_NULL = 550;
    static readonly KW_FORCE_NULL = 551;
    static readonly Identifier = 552;
    static readonly QuotedIdentifier = 553;
    static readonly UnterminatedQuotedIdentifier = 554;
    static readonly InvalidQuotedIdentifier = 555;
    static readonly InvalidUnterminatedQuotedIdentifier = 556;
    static readonly UnicodeQuotedIdentifier = 557;
    static readonly UnterminatedUnicodeQuotedIdentifier = 558;
    static readonly InvalidUnicodeQuotedIdentifier = 559;
    static readonly InvalidUnterminatedUnicodeQuotedIdentifier = 560;
    static readonly StringConstant = 561;
    static readonly UnterminatedStringConstant = 562;
    static readonly UnicodeEscapeStringConstant = 563;
    static readonly UnterminatedUnicodeEscapeStringConstant = 564;
    static readonly BeginDollarStringConstant = 565;
    static readonly BinaryStringConstant = 566;
    static readonly UnterminatedBinaryStringConstant = 567;
    static readonly InvalidBinaryStringConstant = 568;
    static readonly InvalidUnterminatedBinaryStringConstant = 569;
    static readonly HexadecimalStringConstant = 570;
    static readonly UnterminatedHexadecimalStringConstant = 571;
    static readonly InvalidHexadecimalStringConstant = 572;
    static readonly InvalidUnterminatedHexadecimalStringConstant = 573;
    static readonly Integral = 574;
    static readonly NumericFail = 575;
    static readonly Numeric = 576;
    static readonly PLSQLVARIABLENAME = 577;
    static readonly PLSQLIDENTIFIER = 578;
    static readonly WHITE_SPACE = 579;
    static readonly LINE_COMMENT = 580;
    static readonly BRACKETED_COMMENT = 581;
    static readonly UnterminatedBlockComment = 582;
    static readonly MetaCommand = 583;
    static readonly EndMetaCommand = 584;
    static readonly ErrorCharacter = 585;
    static readonly EscapeStringConstant = 586;
    static readonly UnterminatedEscapeStringConstant = 587;
    static readonly InvalidEscapeStringConstant = 588;
    static readonly InvalidUnterminatedEscapeStringConstant = 589;
    static readonly DollarText = 590;
    static readonly EndDollarStringConstant = 591;
    static readonly AfterEscapeStringConstantWithNewlineMode_Continued = 592;
    static readonly RULE_program = 0;
    static readonly RULE_singleStmt = 1;
    static readonly RULE_stmt = 2;
    static readonly RULE_callStmt = 3;
    static readonly RULE_createRoleStmt = 4;
    static readonly RULE_alterOperatorRoleElem = 5;
    static readonly RULE_createOperatorRoleElem = 6;
    static readonly RULE_createUserStmt = 7;
    static readonly RULE_alterRoleStmt = 8;
    static readonly RULE_alterRoleSetStmt = 9;
    static readonly RULE_alterRoutineStmt = 10;
    static readonly RULE_alterRoutineClause = 11;
    static readonly RULE_routineAction = 12;
    static readonly RULE_createGroupStmt = 13;
    static readonly RULE_alterGroupStmt = 14;
    static readonly RULE_createSchemaStmt = 15;
    static readonly RULE_schemaNameCreate = 16;
    static readonly RULE_schemaStmt = 17;
    static readonly RULE_variableSetStmt = 18;
    static readonly RULE_setRest = 19;
    static readonly RULE_genericSet = 20;
    static readonly RULE_setRestMore = 21;
    static readonly RULE_varName = 22;
    static readonly RULE_varList = 23;
    static readonly RULE_varValue = 24;
    static readonly RULE_isoLevel = 25;
    static readonly RULE_optBooleanOrStringColumn = 26;
    static readonly RULE_booleanOrString = 27;
    static readonly RULE_zoneValue = 28;
    static readonly RULE_nonReservedWordOrStringConst = 29;
    static readonly RULE_variableResetStmt = 30;
    static readonly RULE_resetRest = 31;
    static readonly RULE_setOrResetClause = 32;
    static readonly RULE_functionSetOrResetClause = 33;
    static readonly RULE_variableShowStmt = 34;
    static readonly RULE_constraintsSetStmt = 35;
    static readonly RULE_checkPointStmt = 36;
    static readonly RULE_discardStmt = 37;
    static readonly RULE_alterTableStmt = 38;
    static readonly RULE_alterTableCmds = 39;
    static readonly RULE_partitionCmd = 40;
    static readonly RULE_indexPartitionCmd = 41;
    static readonly RULE_alterTableCmd = 42;
    static readonly RULE_alterColumnDefault = 43;
    static readonly RULE_optDropBehavior = 44;
    static readonly RULE_collateClause = 45;
    static readonly RULE_relOptions = 46;
    static readonly RULE_optRelOptions = 47;
    static readonly RULE_relOptionElem = 48;
    static readonly RULE_partitionBoundSpec = 49;
    static readonly RULE_alterCompositeTypeStmt = 50;
    static readonly RULE_alterTypeCmd = 51;
    static readonly RULE_closePortalStmt = 52;
    static readonly RULE_copyStmt = 53;
    static readonly RULE_copyOptionsNoparens = 54;
    static readonly RULE_copyOptions = 55;
    static readonly RULE_copyGenericOptElem = 56;
    static readonly RULE_createStmt = 57;
    static readonly RULE_optTemp = 58;
    static readonly RULE_optTypedTableElEmentList = 59;
    static readonly RULE_tableElementList = 60;
    static readonly RULE_tableElement = 61;
    static readonly RULE_typedTableElement = 62;
    static readonly RULE_column_def = 63;
    static readonly RULE_colConstraint = 64;
    static readonly RULE_colConstraintElem = 65;
    static readonly RULE_generatedWhen = 66;
    static readonly RULE_tableLikeOption = 67;
    static readonly RULE_constraintElem = 68;
    static readonly RULE_optColumnList = 69;
    static readonly RULE_columnListCreate = 70;
    static readonly RULE_columnList = 71;
    static readonly RULE_columnListInclude = 72;
    static readonly RULE_keyMatch = 73;
    static readonly RULE_exclusionConstraintElem = 74;
    static readonly RULE_keyActions = 75;
    static readonly RULE_keyUpdate = 76;
    static readonly RULE_keyDelete = 77;
    static readonly RULE_keyAction = 78;
    static readonly RULE_optInherit = 79;
    static readonly RULE_partitionSpec = 80;
    static readonly RULE_partElem = 81;
    static readonly RULE_tableAccessMethodClause = 82;
    static readonly RULE_optWith = 83;
    static readonly RULE_onCommitOption = 84;
    static readonly RULE_optTableSpace = 85;
    static readonly RULE_optConstableSpace = 86;
    static readonly RULE_existingIndex = 87;
    static readonly RULE_createStatsStmt = 88;
    static readonly RULE_alterStatsStmt = 89;
    static readonly RULE_createAsStmt = 90;
    static readonly RULE_createAsTarget = 91;
    static readonly RULE_optWithData = 92;
    static readonly RULE_createMaterializedViewStmt = 93;
    static readonly RULE_refreshMaterializedViewStmt = 94;
    static readonly RULE_createSeqStmt = 95;
    static readonly RULE_alterSeqStmt = 96;
    static readonly RULE_seqOptElem = 97;
    static readonly RULE_numericOnly = 98;
    static readonly RULE_createProceduralLangStmt = 99;
    static readonly RULE_createTableSpaceStmt = 100;
    static readonly RULE_createExtensionStmt = 101;
    static readonly RULE_alterExtensionStmt = 102;
    static readonly RULE_alterExtensionContentsStmt = 103;
    static readonly RULE_createFdwStmt = 104;
    static readonly RULE_fdwOption = 105;
    static readonly RULE_alterFdwStmt = 106;
    static readonly RULE_createGenericOptions = 107;
    static readonly RULE_alterGenericOptions = 108;
    static readonly RULE_alterGenericOptionElem = 109;
    static readonly RULE_genericOptionElem = 110;
    static readonly RULE_createForeignServerStmt = 111;
    static readonly RULE_foreignServerVersion = 112;
    static readonly RULE_alterForeignServerStmt = 113;
    static readonly RULE_createForeignTableStmt = 114;
    static readonly RULE_importForeignSchemaStmt = 115;
    static readonly RULE_createUserMappingStmt = 116;
    static readonly RULE_alterUserMappingStmt = 117;
    static readonly RULE_createPolicyStmt = 118;
    static readonly RULE_alterPolicyStmt = 119;
    static readonly RULE_alterProcedureStmt = 120;
    static readonly RULE_procedureAction = 121;
    static readonly RULE_rowSecurityOptionalExpr = 122;
    static readonly RULE_rowSecurityOptionalWithCheck = 123;
    static readonly RULE_createAccessMethodStmt = 124;
    static readonly RULE_createTrigStmt = 125;
    static readonly RULE_triggerActionTime = 126;
    static readonly RULE_triggerEvents = 127;
    static readonly RULE_triggerOneEvent = 128;
    static readonly RULE_triggerWhen = 129;
    static readonly RULE_functionOrProcedure = 130;
    static readonly RULE_triggerFuncArgs = 131;
    static readonly RULE_triggerFuncArg = 132;
    static readonly RULE_constraintAttributeElem = 133;
    static readonly RULE_createEventTrigStmt = 134;
    static readonly RULE_eventTriggerWhenItem = 135;
    static readonly RULE_alterEventTrigStmt = 136;
    static readonly RULE_createAssertionStmt = 137;
    static readonly RULE_defineStmt = 138;
    static readonly RULE_definition = 139;
    static readonly RULE_defElem = 140;
    static readonly RULE_defArg = 141;
    static readonly RULE_oldAggregateElem = 142;
    static readonly RULE_alterEnumStmt = 143;
    static readonly RULE_ifNotExists = 144;
    static readonly RULE_createOperatorClassStmt = 145;
    static readonly RULE_opClassItem = 146;
    static readonly RULE_createOperatorFamilyStmt = 147;
    static readonly RULE_alterOperatorFamilyStmt = 148;
    static readonly RULE_opClassDrop = 149;
    static readonly RULE_reassignOwnedStmt = 150;
    static readonly RULE_dropStmt = 151;
    static readonly RULE_objectTypeAnyName = 152;
    static readonly RULE_objectTypeName = 153;
    static readonly RULE_anyNameList = 154;
    static readonly RULE_anyName = 155;
    static readonly RULE_attrs = 156;
    static readonly RULE_truncateStmt = 157;
    static readonly RULE_truncateTable = 158;
    static readonly RULE_commentStmt = 159;
    static readonly RULE_secLabelStmt = 160;
    static readonly RULE_fetchStmt = 161;
    static readonly RULE_fetch_args = 162;
    static readonly RULE_fromIn = 163;
    static readonly RULE_grantStmt = 164;
    static readonly RULE_revokeStmt = 165;
    static readonly RULE_privileges = 166;
    static readonly RULE_beforePrivilegeSelect = 167;
    static readonly RULE_privilege = 168;
    static readonly RULE_privilegeTarget = 169;
    static readonly RULE_granteeList = 170;
    static readonly RULE_grantRoleStmt = 171;
    static readonly RULE_revokeRoleStmt = 172;
    static readonly RULE_alterDefaultPrivilegesStmt = 173;
    static readonly RULE_defaclaction = 174;
    static readonly RULE_defaclPrivilegeTarget = 175;
    static readonly RULE_indexStmt = 176;
    static readonly RULE_indexParams = 177;
    static readonly RULE_indexElem = 178;
    static readonly RULE_createFunctionStmt = 179;
    static readonly RULE_orReplaceOpt = 180;
    static readonly RULE_funcArgs = 181;
    static readonly RULE_funcArgsList = 182;
    static readonly RULE_routineWithArgTypesList = 183;
    static readonly RULE_routineWithArgTypes = 184;
    static readonly RULE_procedureWithArgTypesList = 185;
    static readonly RULE_procedureWithArgTypes = 186;
    static readonly RULE_functionWithArgTypesList = 187;
    static readonly RULE_functionWithArgTypes = 188;
    static readonly RULE_funcArg = 189;
    static readonly RULE_argClass = 190;
    static readonly RULE_funcType = 191;
    static readonly RULE_funcArgWithDefault = 192;
    static readonly RULE_aggregateArgs = 193;
    static readonly RULE_aggregateWithArgTypes = 194;
    static readonly RULE_commonFuncOptItem = 195;
    static readonly RULE_createFuncOptItem = 196;
    static readonly RULE_optDefinition = 197;
    static readonly RULE_tableFuncColumn = 198;
    static readonly RULE_alterFunctionStmt = 199;
    static readonly RULE_removeFuncStmt = 200;
    static readonly RULE_removeAggregateStmt = 201;
    static readonly RULE_removeOperatorStmt = 202;
    static readonly RULE_operatorArgTypes = 203;
    static readonly RULE_anyOperator = 204;
    static readonly RULE_operatorWithArgTypes = 205;
    static readonly RULE_doStmt = 206;
    static readonly RULE_createCastStmt = 207;
    static readonly RULE_ifExists = 208;
    static readonly RULE_createTransformStmt = 209;
    static readonly RULE_sqlWithFunction = 210;
    static readonly RULE_reindexStmt = 211;
    static readonly RULE_alterTblSpcStmt = 212;
    static readonly RULE_renameStmt = 213;
    static readonly RULE_alterObjectDependsStmt = 214;
    static readonly RULE_alterObjectSchemaStmt = 215;
    static readonly RULE_alterOperatorStmt = 216;
    static readonly RULE_operatorDefList = 217;
    static readonly RULE_operatorDefElem = 218;
    static readonly RULE_alterTypeStmt = 219;
    static readonly RULE_alterOwnerStmt = 220;
    static readonly RULE_createPublicationStmt = 221;
    static readonly RULE_alterPublicationStmt = 222;
    static readonly RULE_createSubscriptionStmt = 223;
    static readonly RULE_alterSubscriptionStmt = 224;
    static readonly RULE_ruleStmt = 225;
    static readonly RULE_ruleActionStmt = 226;
    static readonly RULE_notifyStmt = 227;
    static readonly RULE_notifyPayload = 228;
    static readonly RULE_listenStmt = 229;
    static readonly RULE_unListenStmt = 230;
    static readonly RULE_transactionStmt = 231;
    static readonly RULE_optTransaction = 232;
    static readonly RULE_transactionModeItem = 233;
    static readonly RULE_transactionModeList = 234;
    static readonly RULE_viewStmt = 235;
    static readonly RULE_loadStmt = 236;
    static readonly RULE_createDbStmt = 237;
    static readonly RULE_createDbOptItem = 238;
    static readonly RULE_alterDatabaseStmt = 239;
    static readonly RULE_alterDatabaseSetStmt = 240;
    static readonly RULE_alterCollationStmt = 241;
    static readonly RULE_alterSystemStmt = 242;
    static readonly RULE_createDomainStmt = 243;
    static readonly RULE_alterDomainStmt = 244;
    static readonly RULE_alterSearchDictionaryStmt = 245;
    static readonly RULE_alterSearchConfigurationStmt = 246;
    static readonly RULE_createConversionStmt = 247;
    static readonly RULE_clusterStmt = 248;
    static readonly RULE_vacuumStmt = 249;
    static readonly RULE_analyzeStmt = 250;
    static readonly RULE_analyzeKeyword = 251;
    static readonly RULE_vacAnalyzeOptionElem = 252;
    static readonly RULE_analyzeOptionElem = 253;
    static readonly RULE_optVerbose = 254;
    static readonly RULE_vacuumRelation = 255;
    static readonly RULE_vacuumRelationList = 256;
    static readonly RULE_explainStmt = 257;
    static readonly RULE_explainableStmt = 258;
    static readonly RULE_explainOptionList = 259;
    static readonly RULE_prepareStmt = 260;
    static readonly RULE_prepTypeClause = 261;
    static readonly RULE_preParableStmt = 262;
    static readonly RULE_executeStmt = 263;
    static readonly RULE_executeParamClause = 264;
    static readonly RULE_dealLocateStmt = 265;
    static readonly RULE_insertStmt = 266;
    static readonly RULE_insertRest = 267;
    static readonly RULE_insertColumnList = 268;
    static readonly RULE_insertColumnItem = 269;
    static readonly RULE_returningClause = 270;
    static readonly RULE_deleteStmt = 271;
    static readonly RULE_lockStmt = 272;
    static readonly RULE_updateStmt = 273;
    static readonly RULE_setClauseList = 274;
    static readonly RULE_setClause = 275;
    static readonly RULE_declareCursorStmt = 276;
    static readonly RULE_selectStmt = 277;
    static readonly RULE_selectWithParens = 278;
    static readonly RULE_selectNoParens = 279;
    static readonly RULE_selectClause = 280;
    static readonly RULE_simpleSelect = 281;
    static readonly RULE_setOperatorWithAllOrDistinct = 282;
    static readonly RULE_withClause = 283;
    static readonly RULE_commonTableExpr = 284;
    static readonly RULE_searchClause = 285;
    static readonly RULE_cycleClause = 286;
    static readonly RULE_intoClause = 287;
    static readonly RULE_optTempTableName = 288;
    static readonly RULE_distinctClause = 289;
    static readonly RULE_sortClause = 290;
    static readonly RULE_sortBy = 291;
    static readonly RULE_selectLimit = 292;
    static readonly RULE_limitClause = 293;
    static readonly RULE_fetchClause = 294;
    static readonly RULE_offsetClause = 295;
    static readonly RULE_selectFetchFirstValue = 296;
    static readonly RULE_groupClause = 297;
    static readonly RULE_groupByList = 298;
    static readonly RULE_groupByItem = 299;
    static readonly RULE_forLockingClause = 300;
    static readonly RULE_valuesClause = 301;
    static readonly RULE_fromClause = 302;
    static readonly RULE_fromList = 303;
    static readonly RULE_tableRef = 304;
    static readonly RULE_aliasClause = 305;
    static readonly RULE_funcAliasClause = 306;
    static readonly RULE_joinType = 307;
    static readonly RULE_joinQual = 308;
    static readonly RULE_relationExpr = 309;
    static readonly RULE_publicationRelationExpr = 310;
    static readonly RULE_relationExprList = 311;
    static readonly RULE_relationExprOptAlias = 312;
    static readonly RULE_tableSampleClause = 313;
    static readonly RULE_funcTable = 314;
    static readonly RULE_rowsFromItem = 315;
    static readonly RULE_whereClause = 316;
    static readonly RULE_whereOrCurrentClause = 317;
    static readonly RULE_tableFuncElementList = 318;
    static readonly RULE_tableFuncElement = 319;
    static readonly RULE_xmlTable = 320;
    static readonly RULE_xmlTableColumnEl = 321;
    static readonly RULE_xmlNamespaceEle = 322;
    static readonly RULE_typename = 323;
    static readonly RULE_simpleTypeName = 324;
    static readonly RULE_constTypeName = 325;
    static readonly RULE_numeric = 326;
    static readonly RULE_optFloat = 327;
    static readonly RULE_bit = 328;
    static readonly RULE_character = 329;
    static readonly RULE_constDatetime = 330;
    static readonly RULE_optInterval = 331;
    static readonly RULE_intervalSecond = 332;
    static readonly RULE_comparisonOperator = 333;
    static readonly RULE_expression = 334;
    static readonly RULE_booleanExpression = 335;
    static readonly RULE_predicate = 336;
    static readonly RULE_valueExpression = 337;
    static readonly RULE_primaryExpression = 338;
    static readonly RULE_funcApplication = 339;
    static readonly RULE_func_expr = 340;
    static readonly RULE_funcExprWindowless = 341;
    static readonly RULE_funcExprCommonSubExpr = 342;
    static readonly RULE_xmlAttributeList = 343;
    static readonly RULE_xmlAttributeEl = 344;
    static readonly RULE_documentOrContent = 345;
    static readonly RULE_xmlExistsArgument = 346;
    static readonly RULE_xmlPassingMech = 347;
    static readonly RULE_windowClause = 348;
    static readonly RULE_havingClause = 349;
    static readonly RULE_windowDefinition = 350;
    static readonly RULE_over_clause = 351;
    static readonly RULE_windowSpecification = 352;
    static readonly RULE_optFrameClause = 353;
    static readonly RULE_frameBound = 354;
    static readonly RULE_row = 355;
    static readonly RULE_explicitRow = 356;
    static readonly RULE_subType = 357;
    static readonly RULE_allOp = 358;
    static readonly RULE_mathOp = 359;
    static readonly RULE_qualOp = 360;
    static readonly RULE_qualAllOp = 361;
    static readonly RULE_subqueryOperator = 362;
    static readonly RULE_exprList = 363;
    static readonly RULE_columnExpr = 364;
    static readonly RULE_columnExprNoParen = 365;
    static readonly RULE_funcArgList = 366;
    static readonly RULE_funcArgExpr = 367;
    static readonly RULE_arrayExpr = 368;
    static readonly RULE_extractArg = 369;
    static readonly RULE_unicodeNormalForm = 370;
    static readonly RULE_substrList = 371;
    static readonly RULE_when_clause = 372;
    static readonly RULE_indirectionEl = 373;
    static readonly RULE_indirection = 374;
    static readonly RULE_optIndirection = 375;
    static readonly RULE_targetList = 376;
    static readonly RULE_targetEl = 377;
    static readonly RULE_qualifiedNameList = 378;
    static readonly RULE_tableNameList = 379;
    static readonly RULE_schemaNameList = 380;
    static readonly RULE_databaseNameList = 381;
    static readonly RULE_tableSpaceNameCreate = 382;
    static readonly RULE_tableSpaceName = 383;
    static readonly RULE_tableNameCreate = 384;
    static readonly RULE_tableName = 385;
    static readonly RULE_viewNameCreate = 386;
    static readonly RULE_viewName = 387;
    static readonly RULE_qualifiedName = 388;
    static readonly RULE_tableSpaceNameList = 389;
    static readonly RULE_nameList = 390;
    static readonly RULE_databaseNameCreate = 391;
    static readonly RULE_databaseName = 392;
    static readonly RULE_schemaName = 393;
    static readonly RULE_routineNameCreate = 394;
    static readonly RULE_routineName = 395;
    static readonly RULE_procedureName = 396;
    static readonly RULE_procedureNameCreate = 397;
    static readonly RULE_columnName = 398;
    static readonly RULE_columnNamePath = 399;
    static readonly RULE_columnNameCreate = 400;
    static readonly RULE_functionNameCreate = 401;
    static readonly RULE_functionName = 402;
    static readonly RULE_stringConst = 403;
    static readonly RULE_anysconst = 404;
    static readonly RULE_signedConst = 405;
    static readonly RULE_roleSpec = 406;
    static readonly RULE_roleList = 407;
    static readonly RULE_colId = 408;
    static readonly RULE_typeFunctionName = 409;
    static readonly RULE_nonReservedWord = 410;
    static readonly RULE_colLabel = 411;
    static readonly RULE_identifier = 412;
    static readonly RULE_unreservedKeyword = 413;
    static readonly RULE_colNameKeyword = 414;
    static readonly RULE_typeFuncNameKeyword = 415;
    static readonly RULE_reservedKeyword = 416;
    static readonly RULE_plBlock = 417;
    static readonly RULE_labelDecl = 418;
    static readonly RULE_declStatement = 419;
    static readonly RULE_declCursorArg = 420;
    static readonly RULE_assignOperator = 421;
    static readonly RULE_procStmt = 422;
    static readonly RULE_stmtPerform = 423;
    static readonly RULE_stmtCall = 424;
    static readonly RULE_stmtAssign = 425;
    static readonly RULE_stmtGetdiag = 426;
    static readonly RULE_getdiagListItem = 427;
    static readonly RULE_assignVar = 428;
    static readonly RULE_stmtIf = 429;
    static readonly RULE_stmtElse = 430;
    static readonly RULE_stmtCase = 431;
    static readonly RULE_stmtLoopWhileFor = 432;
    static readonly RULE_forControl = 433;
    static readonly RULE_stmtForeach = 434;
    static readonly RULE_stmtExit = 435;
    static readonly RULE_stmtReturn = 436;
    static readonly RULE_stmtRaise = 437;
    static readonly RULE_optRaiseUsingElem = 438;
    static readonly RULE_stmtAssert = 439;
    static readonly RULE_loopBody = 440;
    static readonly RULE_stmtExecsql = 441;
    static readonly RULE_stmtDynexecute = 442;
    static readonly RULE_optExecuteInto = 443;
    static readonly RULE_stmtOpen = 444;
    static readonly RULE_optOpenBoundListItem = 445;
    static readonly RULE_stmtFetch = 446;
    static readonly RULE_optFetchFirection = 447;
    static readonly RULE_stmtMove = 448;
    static readonly RULE_mergeStmt = 449;
    static readonly RULE_dataSource = 450;
    static readonly RULE_mergeWhenClause = 451;
    static readonly RULE_mergeInsert = 452;
    static readonly RULE_mergeUpdate = 453;
    static readonly RULE_defaultValuesOrValues = 454;
    static readonly RULE_exprofdefault = 455;
    static readonly RULE_stmtClose = 456;
    static readonly RULE_stmtNull = 457;
    static readonly RULE_stmtCommitOrRollback = 458;
    static readonly RULE_stmtSet = 459;
    static readonly RULE_cursorVariable = 460;
    static readonly RULE_exceptionSect = 461;
    static readonly RULE_procCondition = 462;
    static readonly RULE_anyIdentifier = 463;
    static readonly RULE_sqlExpression = 464;
    static readonly literalNames: (string | null)[];
    static readonly symbolicNames: (string | null)[];
    static readonly ruleNames: string[];
    get grammarFileName(): string;
    get literalNames(): (string | null)[];
    get symbolicNames(): (string | null)[];
    get ruleNames(): string[];
    get serializedATN(): number[];
    protected createFailedPredicateException(predicate?: string, message?: string): antlr.FailedPredicateException;
    constructor(input: antlr.TokenStream);
    program(): ProgramContext;
    singleStmt(): SingleStmtContext;
    stmt(): StmtContext;
    callStmt(): CallStmtContext;
    createRoleStmt(): CreateRoleStmtContext;
    alterOperatorRoleElem(): AlterOperatorRoleElemContext;
    createOperatorRoleElem(): CreateOperatorRoleElemContext;
    createUserStmt(): CreateUserStmtContext;
    alterRoleStmt(): AlterRoleStmtContext;
    alterRoleSetStmt(): AlterRoleSetStmtContext;
    alterRoutineStmt(): AlterRoutineStmtContext;
    alterRoutineClause(): AlterRoutineClauseContext;
    routineAction(): RoutineActionContext;
    createGroupStmt(): CreateGroupStmtContext;
    alterGroupStmt(): AlterGroupStmtContext;
    createSchemaStmt(): CreateSchemaStmtContext;
    schemaNameCreate(): SchemaNameCreateContext;
    schemaStmt(): SchemaStmtContext;
    variableSetStmt(): VariableSetStmtContext;
    setRest(): SetRestContext;
    genericSet(): GenericSetContext;
    setRestMore(): SetRestMoreContext;
    varName(): VarNameContext;
    varList(): VarListContext;
    varValue(): VarValueContext;
    isoLevel(): IsoLevelContext;
    optBooleanOrStringColumn(): OptBooleanOrStringColumnContext;
    booleanOrString(): BooleanOrStringContext;
    zoneValue(): ZoneValueContext;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext;
    variableResetStmt(): VariableResetStmtContext;
    resetRest(): ResetRestContext;
    setOrResetClause(): SetOrResetClauseContext;
    functionSetOrResetClause(): FunctionSetOrResetClauseContext;
    variableShowStmt(): VariableShowStmtContext;
    constraintsSetStmt(): ConstraintsSetStmtContext;
    checkPointStmt(): CheckPointStmtContext;
    discardStmt(): DiscardStmtContext;
    alterTableStmt(): AlterTableStmtContext;
    alterTableCmds(): AlterTableCmdsContext;
    partitionCmd(): PartitionCmdContext;
    indexPartitionCmd(): IndexPartitionCmdContext;
    alterTableCmd(): AlterTableCmdContext;
    alterColumnDefault(): AlterColumnDefaultContext;
    optDropBehavior(): OptDropBehaviorContext;
    collateClause(): CollateClauseContext;
    relOptions(): RelOptionsContext;
    optRelOptions(): OptRelOptionsContext;
    relOptionElem(): RelOptionElemContext;
    partitionBoundSpec(): PartitionBoundSpecContext;
    alterCompositeTypeStmt(): AlterCompositeTypeStmtContext;
    alterTypeCmd(): AlterTypeCmdContext;
    closePortalStmt(): ClosePortalStmtContext;
    copyStmt(): CopyStmtContext;
    copyOptionsNoparens(): CopyOptionsNoparensContext;
    copyOptions(): CopyOptionsContext;
    copyGenericOptElem(): CopyGenericOptElemContext;
    createStmt(): CreateStmtContext;
    optTemp(): OptTempContext;
    optTypedTableElEmentList(): OptTypedTableElEmentListContext;
    tableElementList(): TableElementListContext;
    tableElement(): TableElementContext;
    typedTableElement(): TypedTableElementContext;
    column_def(): Column_defContext;
    colConstraint(): ColConstraintContext;
    colConstraintElem(): ColConstraintElemContext;
    generatedWhen(): GeneratedWhenContext;
    tableLikeOption(): TableLikeOptionContext;
    constraintElem(): ConstraintElemContext;
    optColumnList(): OptColumnListContext;
    columnListCreate(): ColumnListCreateContext;
    columnList(): ColumnListContext;
    columnListInclude(): ColumnListIncludeContext;
    keyMatch(): KeyMatchContext;
    exclusionConstraintElem(): ExclusionConstraintElemContext;
    keyActions(): KeyActionsContext;
    keyUpdate(): KeyUpdateContext;
    keyDelete(): KeyDeleteContext;
    keyAction(): KeyActionContext;
    optInherit(): OptInheritContext;
    partitionSpec(): PartitionSpecContext;
    partElem(): PartElemContext;
    tableAccessMethodClause(): TableAccessMethodClauseContext;
    optWith(): OptWithContext;
    onCommitOption(): OnCommitOptionContext;
    optTableSpace(): OptTableSpaceContext;
    optConstableSpace(): OptConstableSpaceContext;
    existingIndex(): ExistingIndexContext;
    createStatsStmt(): CreateStatsStmtContext;
    alterStatsStmt(): AlterStatsStmtContext;
    createAsStmt(): CreateAsStmtContext;
    createAsTarget(): CreateAsTargetContext;
    optWithData(): OptWithDataContext;
    createMaterializedViewStmt(): CreateMaterializedViewStmtContext;
    refreshMaterializedViewStmt(): RefreshMaterializedViewStmtContext;
    createSeqStmt(): CreateSeqStmtContext;
    alterSeqStmt(): AlterSeqStmtContext;
    seqOptElem(): SeqOptElemContext;
    numericOnly(): NumericOnlyContext;
    createProceduralLangStmt(): CreateProceduralLangStmtContext;
    createTableSpaceStmt(): CreateTableSpaceStmtContext;
    createExtensionStmt(): CreateExtensionStmtContext;
    alterExtensionStmt(): AlterExtensionStmtContext;
    alterExtensionContentsStmt(): AlterExtensionContentsStmtContext;
    createFdwStmt(): CreateFdwStmtContext;
    fdwOption(): FdwOptionContext;
    alterFdwStmt(): AlterFdwStmtContext;
    createGenericOptions(): CreateGenericOptionsContext;
    alterGenericOptions(): AlterGenericOptionsContext;
    alterGenericOptionElem(): AlterGenericOptionElemContext;
    genericOptionElem(): GenericOptionElemContext;
    createForeignServerStmt(): CreateForeignServerStmtContext;
    foreignServerVersion(): ForeignServerVersionContext;
    alterForeignServerStmt(): AlterForeignServerStmtContext;
    createForeignTableStmt(): CreateForeignTableStmtContext;
    importForeignSchemaStmt(): ImportForeignSchemaStmtContext;
    createUserMappingStmt(): CreateUserMappingStmtContext;
    alterUserMappingStmt(): AlterUserMappingStmtContext;
    createPolicyStmt(): CreatePolicyStmtContext;
    alterPolicyStmt(): AlterPolicyStmtContext;
    alterProcedureStmt(): AlterProcedureStmtContext;
    procedureAction(): ProcedureActionContext;
    rowSecurityOptionalExpr(): RowSecurityOptionalExprContext;
    rowSecurityOptionalWithCheck(): RowSecurityOptionalWithCheckContext;
    createAccessMethodStmt(): CreateAccessMethodStmtContext;
    createTrigStmt(): CreateTrigStmtContext;
    triggerActionTime(): TriggerActionTimeContext;
    triggerEvents(): TriggerEventsContext;
    triggerOneEvent(): TriggerOneEventContext;
    triggerWhen(): TriggerWhenContext;
    functionOrProcedure(): FunctionOrProcedureContext;
    triggerFuncArgs(): TriggerFuncArgsContext;
    triggerFuncArg(): TriggerFuncArgContext;
    constraintAttributeElem(): ConstraintAttributeElemContext;
    createEventTrigStmt(): CreateEventTrigStmtContext;
    eventTriggerWhenItem(): EventTriggerWhenItemContext;
    alterEventTrigStmt(): AlterEventTrigStmtContext;
    createAssertionStmt(): CreateAssertionStmtContext;
    defineStmt(): DefineStmtContext;
    definition(): DefinitionContext;
    defElem(): DefElemContext;
    defArg(): DefArgContext;
    oldAggregateElem(): OldAggregateElemContext;
    alterEnumStmt(): AlterEnumStmtContext;
    ifNotExists(): IfNotExistsContext;
    createOperatorClassStmt(): CreateOperatorClassStmtContext;
    opClassItem(): OpClassItemContext;
    createOperatorFamilyStmt(): CreateOperatorFamilyStmtContext;
    alterOperatorFamilyStmt(): AlterOperatorFamilyStmtContext;
    opClassDrop(): OpClassDropContext;
    reassignOwnedStmt(): ReassignOwnedStmtContext;
    dropStmt(): DropStmtContext;
    objectTypeAnyName(): ObjectTypeAnyNameContext;
    objectTypeName(): ObjectTypeNameContext;
    anyNameList(): AnyNameListContext;
    anyName(): AnyNameContext;
    attrs(): AttrsContext;
    truncateStmt(): TruncateStmtContext;
    truncateTable(): TruncateTableContext;
    commentStmt(): CommentStmtContext;
    secLabelStmt(): SecLabelStmtContext;
    fetchStmt(): FetchStmtContext;
    fetch_args(): Fetch_argsContext;
    fromIn(): FromInContext;
    grantStmt(): GrantStmtContext;
    revokeStmt(): RevokeStmtContext;
    privileges(): PrivilegesContext;
    beforePrivilegeSelect(): BeforePrivilegeSelectContext;
    privilege(): PrivilegeContext;
    privilegeTarget(): PrivilegeTargetContext;
    granteeList(): GranteeListContext;
    grantRoleStmt(): GrantRoleStmtContext;
    revokeRoleStmt(): RevokeRoleStmtContext;
    alterDefaultPrivilegesStmt(): AlterDefaultPrivilegesStmtContext;
    defaclaction(): DefaclactionContext;
    defaclPrivilegeTarget(): DefaclPrivilegeTargetContext;
    indexStmt(): IndexStmtContext;
    indexParams(): IndexParamsContext;
    indexElem(): IndexElemContext;
    createFunctionStmt(): CreateFunctionStmtContext;
    orReplaceOpt(): OrReplaceOptContext;
    funcArgs(): FuncArgsContext;
    funcArgsList(): FuncArgsListContext;
    routineWithArgTypesList(): RoutineWithArgTypesListContext;
    routineWithArgTypes(): RoutineWithArgTypesContext;
    procedureWithArgTypesList(): ProcedureWithArgTypesListContext;
    procedureWithArgTypes(): ProcedureWithArgTypesContext;
    functionWithArgTypesList(): FunctionWithArgTypesListContext;
    functionWithArgTypes(): FunctionWithArgTypesContext;
    funcArg(): FuncArgContext;
    argClass(): ArgClassContext;
    funcType(): FuncTypeContext;
    funcArgWithDefault(): FuncArgWithDefaultContext;
    aggregateArgs(): AggregateArgsContext;
    aggregateWithArgTypes(): AggregateWithArgTypesContext;
    commonFuncOptItem(): CommonFuncOptItemContext;
    createFuncOptItem(): CreateFuncOptItemContext;
    optDefinition(): OptDefinitionContext;
    tableFuncColumn(): TableFuncColumnContext;
    alterFunctionStmt(): AlterFunctionStmtContext;
    removeFuncStmt(): RemoveFuncStmtContext;
    removeAggregateStmt(): RemoveAggregateStmtContext;
    removeOperatorStmt(): RemoveOperatorStmtContext;
    operatorArgTypes(): OperatorArgTypesContext;
    anyOperator(): AnyOperatorContext;
    operatorWithArgTypes(): OperatorWithArgTypesContext;
    doStmt(): DoStmtContext;
    createCastStmt(): CreateCastStmtContext;
    ifExists(): IfExistsContext;
    createTransformStmt(): CreateTransformStmtContext;
    sqlWithFunction(): SqlWithFunctionContext;
    reindexStmt(): ReindexStmtContext;
    alterTblSpcStmt(): AlterTblSpcStmtContext;
    renameStmt(): RenameStmtContext;
    alterObjectDependsStmt(): AlterObjectDependsStmtContext;
    alterObjectSchemaStmt(): AlterObjectSchemaStmtContext;
    alterOperatorStmt(): AlterOperatorStmtContext;
    operatorDefList(): OperatorDefListContext;
    operatorDefElem(): OperatorDefElemContext;
    alterTypeStmt(): AlterTypeStmtContext;
    alterOwnerStmt(): AlterOwnerStmtContext;
    createPublicationStmt(): CreatePublicationStmtContext;
    alterPublicationStmt(): AlterPublicationStmtContext;
    createSubscriptionStmt(): CreateSubscriptionStmtContext;
    alterSubscriptionStmt(): AlterSubscriptionStmtContext;
    ruleStmt(): RuleStmtContext;
    ruleActionStmt(): RuleActionStmtContext;
    notifyStmt(): NotifyStmtContext;
    notifyPayload(): NotifyPayloadContext;
    listenStmt(): ListenStmtContext;
    unListenStmt(): UnListenStmtContext;
    transactionStmt(): TransactionStmtContext;
    optTransaction(): OptTransactionContext;
    transactionModeItem(): TransactionModeItemContext;
    transactionModeList(): TransactionModeListContext;
    viewStmt(): ViewStmtContext;
    loadStmt(): LoadStmtContext;
    createDbStmt(): CreateDbStmtContext;
    createDbOptItem(): CreateDbOptItemContext;
    alterDatabaseStmt(): AlterDatabaseStmtContext;
    alterDatabaseSetStmt(): AlterDatabaseSetStmtContext;
    alterCollationStmt(): AlterCollationStmtContext;
    alterSystemStmt(): AlterSystemStmtContext;
    createDomainStmt(): CreateDomainStmtContext;
    alterDomainStmt(): AlterDomainStmtContext;
    alterSearchDictionaryStmt(): AlterSearchDictionaryStmtContext;
    alterSearchConfigurationStmt(): AlterSearchConfigurationStmtContext;
    createConversionStmt(): CreateConversionStmtContext;
    clusterStmt(): ClusterStmtContext;
    vacuumStmt(): VacuumStmtContext;
    analyzeStmt(): AnalyzeStmtContext;
    analyzeKeyword(): AnalyzeKeywordContext;
    vacAnalyzeOptionElem(): VacAnalyzeOptionElemContext;
    analyzeOptionElem(): AnalyzeOptionElemContext;
    optVerbose(): OptVerboseContext;
    vacuumRelation(): VacuumRelationContext;
    vacuumRelationList(): VacuumRelationListContext;
    explainStmt(): ExplainStmtContext;
    explainableStmt(): ExplainableStmtContext;
    explainOptionList(): ExplainOptionListContext;
    prepareStmt(): PrepareStmtContext;
    prepTypeClause(): PrepTypeClauseContext;
    preParableStmt(): PreParableStmtContext;
    executeStmt(): ExecuteStmtContext;
    executeParamClause(): ExecuteParamClauseContext;
    dealLocateStmt(): DealLocateStmtContext;
    insertStmt(): InsertStmtContext;
    insertRest(): InsertRestContext;
    insertColumnList(): InsertColumnListContext;
    insertColumnItem(): InsertColumnItemContext;
    returningClause(): ReturningClauseContext;
    deleteStmt(): DeleteStmtContext;
    lockStmt(): LockStmtContext;
    updateStmt(): UpdateStmtContext;
    setClauseList(): SetClauseListContext;
    setClause(): SetClauseContext;
    declareCursorStmt(): DeclareCursorStmtContext;
    selectStmt(): SelectStmtContext;
    selectWithParens(): SelectWithParensContext;
    selectNoParens(): SelectNoParensContext;
    selectClause(): SelectClauseContext;
    simpleSelect(): SimpleSelectContext;
    setOperatorWithAllOrDistinct(): SetOperatorWithAllOrDistinctContext;
    withClause(): WithClauseContext;
    commonTableExpr(): CommonTableExprContext;
    searchClause(): SearchClauseContext;
    cycleClause(): CycleClauseContext;
    intoClause(): IntoClauseContext;
    optTempTableName(): OptTempTableNameContext;
    distinctClause(): DistinctClauseContext;
    sortClause(): SortClauseContext;
    sortBy(): SortByContext;
    selectLimit(): SelectLimitContext;
    limitClause(): LimitClauseContext;
    fetchClause(): FetchClauseContext;
    offsetClause(): OffsetClauseContext;
    selectFetchFirstValue(): SelectFetchFirstValueContext;
    groupClause(): GroupClauseContext;
    groupByList(): GroupByListContext;
    groupByItem(): GroupByItemContext;
    forLockingClause(): ForLockingClauseContext;
    valuesClause(): ValuesClauseContext;
    fromClause(): FromClauseContext;
    fromList(): FromListContext;
    tableRef(): TableRefContext;
    aliasClause(): AliasClauseContext;
    funcAliasClause(): FuncAliasClauseContext;
    joinType(): JoinTypeContext;
    joinQual(): JoinQualContext;
    relationExpr(): RelationExprContext;
    publicationRelationExpr(): PublicationRelationExprContext;
    relationExprList(): RelationExprListContext;
    relationExprOptAlias(): RelationExprOptAliasContext;
    tableSampleClause(): TableSampleClauseContext;
    funcTable(): FuncTableContext;
    rowsFromItem(): RowsFromItemContext;
    whereClause(): WhereClauseContext;
    whereOrCurrentClause(): WhereOrCurrentClauseContext;
    tableFuncElementList(): TableFuncElementListContext;
    tableFuncElement(): TableFuncElementContext;
    xmlTable(): XmlTableContext;
    xmlTableColumnEl(): XmlTableColumnElContext;
    xmlNamespaceEle(): XmlNamespaceEleContext;
    typename(): TypenameContext;
    simpleTypeName(): SimpleTypeNameContext;
    constTypeName(): ConstTypeNameContext;
    numeric(): NumericContext;
    optFloat(): OptFloatContext;
    bit(): BitContext;
    character(): CharacterContext;
    constDatetime(): ConstDatetimeContext;
    optInterval(): OptIntervalContext;
    intervalSecond(): IntervalSecondContext;
    comparisonOperator(): ComparisonOperatorContext;
    expression(): ExpressionContext;
    booleanExpression(): BooleanExpressionContext;
    booleanExpression(_p: number): BooleanExpressionContext;
    predicate(value: antlr.ParserRuleContext): PredicateContext;
    valueExpression(): ValueExpressionContext;
    valueExpression(_p: number): ValueExpressionContext;
    primaryExpression(): PrimaryExpressionContext;
    primaryExpression(_p: number): PrimaryExpressionContext;
    funcApplication(): FuncApplicationContext;
    func_expr(): Func_exprContext;
    funcExprWindowless(): FuncExprWindowlessContext;
    funcExprCommonSubExpr(): FuncExprCommonSubExprContext;
    xmlAttributeList(): XmlAttributeListContext;
    xmlAttributeEl(): XmlAttributeElContext;
    documentOrContent(): DocumentOrContentContext;
    xmlExistsArgument(): XmlExistsArgumentContext;
    xmlPassingMech(): XmlPassingMechContext;
    windowClause(): WindowClauseContext;
    havingClause(): HavingClauseContext;
    windowDefinition(): WindowDefinitionContext;
    over_clause(): Over_clauseContext;
    windowSpecification(): WindowSpecificationContext;
    optFrameClause(): OptFrameClauseContext;
    frameBound(): FrameBoundContext;
    row(): RowContext;
    explicitRow(): ExplicitRowContext;
    subType(): SubTypeContext;
    allOp(): AllOpContext;
    mathOp(): MathOpContext;
    qualOp(): QualOpContext;
    qualAllOp(): QualAllOpContext;
    subqueryOperator(): SubqueryOperatorContext;
    exprList(): ExprListContext;
    columnExpr(): ColumnExprContext;
    columnExprNoParen(): ColumnExprNoParenContext;
    funcArgList(): FuncArgListContext;
    funcArgExpr(): FuncArgExprContext;
    arrayExpr(): ArrayExprContext;
    extractArg(): ExtractArgContext;
    unicodeNormalForm(): UnicodeNormalFormContext;
    substrList(): SubstrListContext;
    when_clause(): When_clauseContext;
    indirectionEl(): IndirectionElContext;
    indirection(): IndirectionContext;
    optIndirection(): OptIndirectionContext;
    targetList(): TargetListContext;
    targetEl(): TargetElContext;
    qualifiedNameList(): QualifiedNameListContext;
    tableNameList(): TableNameListContext;
    schemaNameList(): SchemaNameListContext;
    databaseNameList(): DatabaseNameListContext;
    tableSpaceNameCreate(): TableSpaceNameCreateContext;
    tableSpaceName(): TableSpaceNameContext;
    tableNameCreate(): TableNameCreateContext;
    tableName(): TableNameContext;
    viewNameCreate(): ViewNameCreateContext;
    viewName(): ViewNameContext;
    qualifiedName(): QualifiedNameContext;
    tableSpaceNameList(): TableSpaceNameListContext;
    nameList(): NameListContext;
    databaseNameCreate(): DatabaseNameCreateContext;
    databaseName(): DatabaseNameContext;
    schemaName(): SchemaNameContext;
    routineNameCreate(): RoutineNameCreateContext;
    routineName(): RoutineNameContext;
    procedureName(): ProcedureNameContext;
    procedureNameCreate(): ProcedureNameCreateContext;
    columnName(): ColumnNameContext;
    columnNamePath(): ColumnNamePathContext;
    columnNameCreate(): ColumnNameCreateContext;
    functionNameCreate(): FunctionNameCreateContext;
    functionName(): FunctionNameContext;
    stringConst(): StringConstContext;
    anysconst(): AnysconstContext;
    signedConst(): SignedConstContext;
    roleSpec(): RoleSpecContext;
    roleList(): RoleListContext;
    colId(): ColIdContext;
    typeFunctionName(): TypeFunctionNameContext;
    nonReservedWord(): NonReservedWordContext;
    colLabel(): ColLabelContext;
    identifier(): IdentifierContext;
    unreservedKeyword(): UnreservedKeywordContext;
    colNameKeyword(): ColNameKeywordContext;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext;
    reservedKeyword(): ReservedKeywordContext;
    plBlock(): PlBlockContext;
    labelDecl(): LabelDeclContext;
    declStatement(): DeclStatementContext;
    declCursorArg(): DeclCursorArgContext;
    assignOperator(): AssignOperatorContext;
    procStmt(): ProcStmtContext;
    stmtPerform(): StmtPerformContext;
    stmtCall(): StmtCallContext;
    stmtAssign(): StmtAssignContext;
    stmtGetdiag(): StmtGetdiagContext;
    getdiagListItem(): GetdiagListItemContext;
    assignVar(): AssignVarContext;
    stmtIf(): StmtIfContext;
    stmtElse(): StmtElseContext;
    stmtCase(): StmtCaseContext;
    stmtLoopWhileFor(): StmtLoopWhileForContext;
    forControl(): ForControlContext;
    stmtForeach(): StmtForeachContext;
    stmtExit(): StmtExitContext;
    stmtReturn(): StmtReturnContext;
    stmtRaise(): StmtRaiseContext;
    optRaiseUsingElem(): OptRaiseUsingElemContext;
    stmtAssert(): StmtAssertContext;
    loopBody(): LoopBodyContext;
    stmtExecsql(): StmtExecsqlContext;
    stmtDynexecute(): StmtDynexecuteContext;
    optExecuteInto(): OptExecuteIntoContext;
    stmtOpen(): StmtOpenContext;
    optOpenBoundListItem(): OptOpenBoundListItemContext;
    stmtFetch(): StmtFetchContext;
    optFetchFirection(): OptFetchFirectionContext;
    stmtMove(): StmtMoveContext;
    mergeStmt(): MergeStmtContext;
    dataSource(): DataSourceContext;
    mergeWhenClause(): MergeWhenClauseContext;
    mergeInsert(): MergeInsertContext;
    mergeUpdate(): MergeUpdateContext;
    defaultValuesOrValues(): DefaultValuesOrValuesContext;
    exprofdefault(): ExprofdefaultContext;
    stmtClose(): StmtCloseContext;
    stmtNull(): StmtNullContext;
    stmtCommitOrRollback(): StmtCommitOrRollbackContext;
    stmtSet(): StmtSetContext;
    cursorVariable(): CursorVariableContext;
    exceptionSect(): ExceptionSectContext;
    procCondition(): ProcConditionContext;
    anyIdentifier(): AnyIdentifierContext;
    sqlExpression(): SqlExpressionContext;
    sempred(localContext: antlr.RuleContext | null, ruleIndex: number, predIndex: number): boolean;
    private booleanExpression_sempred;
    private valueExpression_sempred;
    private primaryExpression_sempred;
    private columnName_sempred;
    static readonly _serializedATN: number[];
    private static __ATN;
    static get _ATN(): antlr.ATN;
    private static readonly vocabulary;
    get vocabulary(): antlr.Vocabulary;
    private static readonly decisionsToDFA;
}
export declare class ProgramContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    EOF(): antlr.TerminalNode;
    singleStmt(): SingleStmtContext[];
    singleStmt(i: number): SingleStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SingleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    stmt(): StmtContext;
    SEMI(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    alterEventTrigStmt(): AlterEventTrigStmtContext | null;
    alterCollationStmt(): AlterCollationStmtContext | null;
    alterDatabaseStmt(): AlterDatabaseStmtContext | null;
    alterDatabaseSetStmt(): AlterDatabaseSetStmtContext | null;
    alterDefaultPrivilegesStmt(): AlterDefaultPrivilegesStmtContext | null;
    alterDomainStmt(): AlterDomainStmtContext | null;
    alterEnumStmt(): AlterEnumStmtContext | null;
    alterExtensionStmt(): AlterExtensionStmtContext | null;
    alterExtensionContentsStmt(): AlterExtensionContentsStmtContext | null;
    alterFdwStmt(): AlterFdwStmtContext | null;
    alterForeignServerStmt(): AlterForeignServerStmtContext | null;
    alterFunctionStmt(): AlterFunctionStmtContext | null;
    alterGroupStmt(): AlterGroupStmtContext | null;
    alterObjectDependsStmt(): AlterObjectDependsStmtContext | null;
    alterObjectSchemaStmt(): AlterObjectSchemaStmtContext | null;
    alterOwnerStmt(): AlterOwnerStmtContext | null;
    alterOperatorStmt(): AlterOperatorStmtContext | null;
    alterTypeStmt(): AlterTypeStmtContext | null;
    alterPolicyStmt(): AlterPolicyStmtContext | null;
    alterProcedureStmt(): AlterProcedureStmtContext | null;
    alterSeqStmt(): AlterSeqStmtContext | null;
    alterSystemStmt(): AlterSystemStmtContext | null;
    alterTableStmt(): AlterTableStmtContext | null;
    alterTblSpcStmt(): AlterTblSpcStmtContext | null;
    alterCompositeTypeStmt(): AlterCompositeTypeStmtContext | null;
    alterPublicationStmt(): AlterPublicationStmtContext | null;
    alterRoleSetStmt(): AlterRoleSetStmtContext | null;
    alterRoutineStmt(): AlterRoutineStmtContext | null;
    alterRoleStmt(): AlterRoleStmtContext | null;
    alterSubscriptionStmt(): AlterSubscriptionStmtContext | null;
    alterStatsStmt(): AlterStatsStmtContext | null;
    alterSearchConfigurationStmt(): AlterSearchConfigurationStmtContext | null;
    alterSearchDictionaryStmt(): AlterSearchDictionaryStmtContext | null;
    alterUserMappingStmt(): AlterUserMappingStmtContext | null;
    analyzeStmt(): AnalyzeStmtContext | null;
    callStmt(): CallStmtContext | null;
    checkPointStmt(): CheckPointStmtContext | null;
    closePortalStmt(): ClosePortalStmtContext | null;
    clusterStmt(): ClusterStmtContext | null;
    commentStmt(): CommentStmtContext | null;
    constraintsSetStmt(): ConstraintsSetStmtContext | null;
    copyStmt(): CopyStmtContext | null;
    createAccessMethodStmt(): CreateAccessMethodStmtContext | null;
    createAsStmt(): CreateAsStmtContext | null;
    createAssertionStmt(): CreateAssertionStmtContext | null;
    createCastStmt(): CreateCastStmtContext | null;
    createConversionStmt(): CreateConversionStmtContext | null;
    createDomainStmt(): CreateDomainStmtContext | null;
    createExtensionStmt(): CreateExtensionStmtContext | null;
    createFdwStmt(): CreateFdwStmtContext | null;
    createForeignServerStmt(): CreateForeignServerStmtContext | null;
    createForeignTableStmt(): CreateForeignTableStmtContext | null;
    createFunctionStmt(): CreateFunctionStmtContext | null;
    createGroupStmt(): CreateGroupStmtContext | null;
    createMaterializedViewStmt(): CreateMaterializedViewStmtContext | null;
    createOperatorClassStmt(): CreateOperatorClassStmtContext | null;
    createOperatorFamilyStmt(): CreateOperatorFamilyStmtContext | null;
    createPublicationStmt(): CreatePublicationStmtContext | null;
    alterOperatorFamilyStmt(): AlterOperatorFamilyStmtContext | null;
    createPolicyStmt(): CreatePolicyStmtContext | null;
    createProceduralLangStmt(): CreateProceduralLangStmtContext | null;
    createSchemaStmt(): CreateSchemaStmtContext | null;
    createSeqStmt(): CreateSeqStmtContext | null;
    createStmt(): CreateStmtContext | null;
    createSubscriptionStmt(): CreateSubscriptionStmtContext | null;
    createStatsStmt(): CreateStatsStmtContext | null;
    createTableSpaceStmt(): CreateTableSpaceStmtContext | null;
    createTransformStmt(): CreateTransformStmtContext | null;
    createTrigStmt(): CreateTrigStmtContext | null;
    createEventTrigStmt(): CreateEventTrigStmtContext | null;
    createRoleStmt(): CreateRoleStmtContext | null;
    createUserStmt(): CreateUserStmtContext | null;
    createUserMappingStmt(): CreateUserMappingStmtContext | null;
    createDbStmt(): CreateDbStmtContext | null;
    dealLocateStmt(): DealLocateStmtContext | null;
    declareCursorStmt(): DeclareCursorStmtContext | null;
    defineStmt(): DefineStmtContext | null;
    deleteStmt(): DeleteStmtContext | null;
    discardStmt(): DiscardStmtContext | null;
    doStmt(): DoStmtContext | null;
    dropStmt(): DropStmtContext | null;
    executeStmt(): ExecuteStmtContext | null;
    explainStmt(): ExplainStmtContext | null;
    fetchStmt(): FetchStmtContext | null;
    grantStmt(): GrantStmtContext | null;
    grantRoleStmt(): GrantRoleStmtContext | null;
    mergeStmt(): MergeStmtContext | null;
    importForeignSchemaStmt(): ImportForeignSchemaStmtContext | null;
    indexStmt(): IndexStmtContext | null;
    insertStmt(): InsertStmtContext | null;
    listenStmt(): ListenStmtContext | null;
    refreshMaterializedViewStmt(): RefreshMaterializedViewStmtContext | null;
    loadStmt(): LoadStmtContext | null;
    lockStmt(): LockStmtContext | null;
    notifyStmt(): NotifyStmtContext | null;
    prepareStmt(): PrepareStmtContext | null;
    reassignOwnedStmt(): ReassignOwnedStmtContext | null;
    reindexStmt(): ReindexStmtContext | null;
    removeAggregateStmt(): RemoveAggregateStmtContext | null;
    removeFuncStmt(): RemoveFuncStmtContext | null;
    removeOperatorStmt(): RemoveOperatorStmtContext | null;
    renameStmt(): RenameStmtContext | null;
    revokeStmt(): RevokeStmtContext | null;
    revokeRoleStmt(): RevokeRoleStmtContext | null;
    ruleStmt(): RuleStmtContext | null;
    secLabelStmt(): SecLabelStmtContext | null;
    selectStmt(): SelectStmtContext | null;
    transactionStmt(): TransactionStmtContext | null;
    truncateStmt(): TruncateStmtContext | null;
    unListenStmt(): UnListenStmtContext | null;
    updateStmt(): UpdateStmtContext | null;
    vacuumStmt(): VacuumStmtContext | null;
    variableResetStmt(): VariableResetStmtContext | null;
    variableSetStmt(): VariableSetStmtContext | null;
    variableShowStmt(): VariableShowStmtContext | null;
    viewStmt(): ViewStmtContext | null;
    MetaCommand(): antlr.TerminalNode | null;
    EndMetaCommand(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CallStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CALL(): antlr.TerminalNode;
    funcApplication(): FuncApplicationContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateRoleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_ROLE(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_WITH(): antlr.TerminalNode | null;
    createOperatorRoleElem(): CreateOperatorRoleElemContext[];
    createOperatorRoleElem(i: number): CreateOperatorRoleElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterOperatorRoleElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PASSWORD(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_ENCRYPTED(): antlr.TerminalNode | null;
    KW_UNENCRYPTED(): antlr.TerminalNode | null;
    KW_INHERIT(): antlr.TerminalNode | null;
    KW_NOINHERIT(): antlr.TerminalNode | null;
    KW_CREATEUSER(): antlr.TerminalNode | null;
    KW_NOCREATEUSER(): antlr.TerminalNode | null;
    KW_CREATEROLE(): antlr.TerminalNode | null;
    KW_NOCREATEROLE(): antlr.TerminalNode | null;
    KW_CREATEDB(): antlr.TerminalNode | null;
    KW_NOCREATEDB(): antlr.TerminalNode | null;
    KW_SUPERUSER(): antlr.TerminalNode | null;
    KW_NOSUPERUSER(): antlr.TerminalNode | null;
    KW_LOGIN(): antlr.TerminalNode | null;
    KW_NOLOGIN(): antlr.TerminalNode | null;
    KW_REPLICATION(): antlr.TerminalNode | null;
    KW_NOREPLICATION(): antlr.TerminalNode | null;
    KW_BYPASSRLS(): antlr.TerminalNode | null;
    KW_NOBYPASSRLS(): antlr.TerminalNode | null;
    KW_CONNECTION(): antlr.TerminalNode | null;
    KW_LIMIT(): antlr.TerminalNode | null;
    signedConst(): SignedConstContext | null;
    KW_VALID(): antlr.TerminalNode | null;
    KW_UNTIL(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    nameList(): NameListContext | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_ADMIN(): antlr.TerminalNode | null;
    identifier(): IdentifierContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateOperatorRoleElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    alterOperatorRoleElem(): AlterOperatorRoleElemContext | null;
    KW_SYSID(): antlr.TerminalNode | null;
    Integral(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    KW_ADMIN(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateUserStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_USER(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_WITH(): antlr.TerminalNode | null;
    createOperatorRoleElem(): CreateOperatorRoleElemContext[];
    createOperatorRoleElem(i: number): CreateOperatorRoleElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterRoleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    alterOperatorRoleElem(): AlterOperatorRoleElemContext[];
    alterOperatorRoleElem(i: number): AlterOperatorRoleElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterRoleSetStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_IN(): antlr.TerminalNode;
    KW_DATABASE(): antlr.TerminalNode;
    databaseName(): DatabaseNameContext;
    setOrResetClause(): SetOrResetClauseContext;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterRoutineStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_ROUTINE(): antlr.TerminalNode;
    routineName(): RoutineNameContext;
    alterRoutineClause(): AlterRoutineClauseContext;
    funcArgs(): FuncArgsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterRoutineClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    routineAction(): RoutineActionContext[];
    routineAction(i: number): RoutineActionContext | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    KW_RENAME(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    routineNameCreate(): RoutineNameCreateContext | null;
    KW_OWNER(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaNameCreate(): SchemaNameCreateContext | null;
    KW_DEPENDS(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoutineActionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IMMUTABLE(): antlr.TerminalNode | null;
    KW_STABLE(): antlr.TerminalNode | null;
    KW_VOLATILE(): antlr.TerminalNode | null;
    KW_LEAKPROOF(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_SECURITY(): antlr.TerminalNode | null;
    KW_INVOKER(): antlr.TerminalNode | null;
    KW_DEFINER(): antlr.TerminalNode | null;
    KW_EXTERNAL(): antlr.TerminalNode | null;
    KW_PARALLEL(): antlr.TerminalNode | null;
    KW_UNSAFE(): antlr.TerminalNode | null;
    KW_RESTRICTED(): antlr.TerminalNode | null;
    KW_SAFE(): antlr.TerminalNode | null;
    KW_COST(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    KW_ROWS(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_RESET(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateGroupStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_GROUP(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_WITH(): antlr.TerminalNode | null;
    createOperatorRoleElem(): CreateOperatorRoleElemContext[];
    createOperatorRoleElem(i: number): CreateOperatorRoleElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterGroupStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_GROUP(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_USER(): antlr.TerminalNode;
    roleList(): RoleListContext;
    KW_ADD(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateSchemaStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_SCHEMA(): antlr.TerminalNode;
    KW_AUTHORIZATION(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    schemaNameCreate(): SchemaNameCreateContext | null;
    ifNotExists(): IfNotExistsContext | null;
    schemaStmt(): SchemaStmtContext[];
    schemaStmt(i: number): SchemaStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SchemaNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SchemaStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    createStmt(): CreateStmtContext | null;
    indexStmt(): IndexStmtContext | null;
    createSeqStmt(): CreateSeqStmtContext | null;
    createTrigStmt(): CreateTrigStmtContext | null;
    grantStmt(): GrantStmtContext | null;
    viewStmt(): ViewStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VariableSetStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode;
    setRest(): SetRestContext;
    KW_LOCAL(): antlr.TerminalNode | null;
    KW_SESSION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetRestContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TRANSACTION(): antlr.TerminalNode | null;
    transactionModeList(): TransactionModeListContext | null;
    KW_SESSION(): antlr.TerminalNode | null;
    KW_CHARACTERISTICS(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    setRestMore(): SetRestMoreContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GenericSetContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALL(): antlr.TerminalNode | null;
    varName(): VarNameContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    varList(): VarListContext | null;
    KW_TO(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetRestMoreContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TIME(): antlr.TerminalNode | null;
    KW_ZONE(): antlr.TerminalNode | null;
    zoneValue(): ZoneValueContext | null;
    KW_CATALOG(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    KW_NAMES(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext | null;
    KW_SESSION(): antlr.TerminalNode | null;
    KW_AUTHORIZATION(): antlr.TerminalNode | null;
    KW_XML(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    documentOrContent(): DocumentOrContentContext | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    KW_SNAPSHOT(): antlr.TerminalNode | null;
    varName(): VarNameContext | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    genericSet(): GenericSetContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VarNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    DOT(): antlr.TerminalNode[];
    DOT(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VarListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    varValue(): VarValueContext[];
    varValue(i: number): VarValueContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VarValueContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    booleanOrString(): BooleanOrStringContext | null;
    numericOnly(): NumericOnlyContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IsoLevelContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_READ(): antlr.TerminalNode | null;
    KW_UNCOMMITTED(): antlr.TerminalNode | null;
    KW_COMMITTED(): antlr.TerminalNode | null;
    KW_REPEATABLE(): antlr.TerminalNode | null;
    KW_SERIALIZABLE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptBooleanOrStringColumnContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TRUE(): antlr.TerminalNode | null;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class BooleanOrStringContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TRUE(): antlr.TerminalNode | null;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ZoneValueContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    stringConst(): StringConstContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    identifier(): IdentifierContext | null;
    KW_INTERVAL(): antlr.TerminalNode | null;
    optInterval(): OptIntervalContext | null;
    optFloat(): OptFloatContext | null;
    numericOnly(): NumericOnlyContext | null;
    KW_LOCAL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NonReservedWordOrStringConstContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    nonReservedWord(): NonReservedWordContext | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VariableResetStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_RESET(): antlr.TerminalNode;
    resetRest(): ResetRestContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ResetRestContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TIME(): antlr.TerminalNode | null;
    KW_ZONE(): antlr.TerminalNode | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    KW_ISOLATION(): antlr.TerminalNode | null;
    KW_LEVEL(): antlr.TerminalNode | null;
    KW_SESSION(): antlr.TerminalNode | null;
    KW_AUTHORIZATION(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    varName(): VarNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetOrResetClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode | null;
    setRest(): SetRestContext | null;
    variableResetStmt(): VariableResetStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionSetOrResetClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode | null;
    setRestMore(): SetRestMoreContext | null;
    variableResetStmt(): VariableResetStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VariableShowStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SHOW(): antlr.TerminalNode;
    varName(): VarNameContext | null;
    KW_TIME(): antlr.TerminalNode | null;
    KW_ZONE(): antlr.TerminalNode | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    KW_ISOLATION(): antlr.TerminalNode | null;
    KW_LEVEL(): antlr.TerminalNode | null;
    KW_SESSION(): antlr.TerminalNode | null;
    KW_AUTHORIZATION(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConstraintsSetStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode;
    KW_CONSTRAINTS(): antlr.TerminalNode;
    KW_DEFERRED(): antlr.TerminalNode | null;
    KW_IMMEDIATE(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    qualifiedNameList(): QualifiedNameListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CheckPointStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CHECKPOINT(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DiscardStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DISCARD(): antlr.TerminalNode;
    KW_ALL(): antlr.TerminalNode | null;
    KW_TEMP(): antlr.TerminalNode | null;
    KW_TEMPORARY(): antlr.TerminalNode | null;
    KW_PLANS(): antlr.TerminalNode | null;
    KW_SEQUENCES(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTableStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_TABLE(): antlr.TerminalNode | null;
    relationExpr(): RelationExprContext | null;
    alterTableCmds(): AlterTableCmdsContext | null;
    partitionCmd(): PartitionCmdContext | null;
    ifExists(): IfExistsContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    optTableSpace(): OptTableSpaceContext[];
    optTableSpace(i: number): OptTableSpaceContext | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    tableSpaceName(): TableSpaceNameContext | null;
    KW_OWNED(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    KW_NOWAIT(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    indexPartitionCmd(): IndexPartitionCmdContext | null;
    partitionBoundSpec(): PartitionBoundSpecContext | null;
    KW_DETACH(): antlr.TerminalNode | null;
    KW_PARTITION(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    KW_FINALIZE(): antlr.TerminalNode | null;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTableCmdsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    alterTableCmd(): AlterTableCmdContext[];
    alterTableCmd(i: number): AlterTableCmdContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PartitionCmdContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    indexPartitionCmd(): IndexPartitionCmdContext | null;
    partitionBoundSpec(): PartitionBoundSpecContext | null;
    KW_DETACH(): antlr.TerminalNode | null;
    KW_PARTITION(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndexPartitionCmdContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ATTACH(): antlr.TerminalNode;
    KW_PARTITION(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTableCmdContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ADD(): antlr.TerminalNode | null;
    constraintElem(): ConstraintElemContext | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_ALTER(): antlr.TerminalNode | null;
    constraintAttributeElem(): ConstraintAttributeElemContext[];
    constraintAttributeElem(i: number): ConstraintAttributeElemContext | null;
    KW_VALIDATE(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    KW_SET(): antlr.TerminalNode[];
    KW_SET(i: number): antlr.TerminalNode | null;
    KW_WITHOUT(): antlr.TerminalNode | null;
    KW_OIDS(): antlr.TerminalNode | null;
    KW_CLUSTER(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    KW_LOGGED(): antlr.TerminalNode | null;
    KW_UNLOGGED(): antlr.TerminalNode | null;
    KW_ENABLE(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_REPLICA(): antlr.TerminalNode | null;
    KW_ALWAYS(): antlr.TerminalNode | null;
    KW_DISABLE(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_RULE(): antlr.TerminalNode | null;
    KW_INHERIT(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_OWNER(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    tableSpaceName(): TableSpaceNameContext | null;
    KW_IDENTITY(): antlr.TerminalNode | null;
    KW_NOTHING(): antlr.TerminalNode | null;
    KW_FULL(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    existingIndex(): ExistingIndexContext | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_LEVEL(): antlr.TerminalNode | null;
    KW_SECURITY(): antlr.TerminalNode | null;
    KW_FORCE(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    KW_COLUMN(): antlr.TerminalNode | null;
    column_def(): Column_defContext | null;
    ifNotExists(): IfNotExistsContext | null;
    alterColumnDefault(): AlterColumnDefaultContext | null;
    alterGenericOptions(): AlterGenericOptionsContext | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_EXPRESSION(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    signedConst(): SignedConstContext | null;
    relOptions(): RelOptionsContext | null;
    KW_RESET(): antlr.TerminalNode | null;
    KW_STORAGE(): antlr.TerminalNode | null;
    KW_GENERATED(): antlr.TerminalNode[];
    KW_GENERATED(i: number): antlr.TerminalNode | null;
    generatedWhen(): GeneratedWhenContext[];
    generatedWhen(i: number): GeneratedWhenContext | null;
    KW_AS(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    seqOptElem(): SeqOptElemContext[];
    seqOptElem(i: number): SeqOptElemContext | null;
    KW_RESTART(): antlr.TerminalNode[];
    KW_RESTART(i: number): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext[];
    numericOnly(i: number): NumericOnlyContext | null;
    KW_WITH(): antlr.TerminalNode[];
    KW_WITH(i: number): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    KW_DATA(): antlr.TerminalNode | null;
    collateClause(): CollateClauseContext | null;
    KW_USING(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterColumnDefaultContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode;
    expression(): ExpressionContext | null;
    KW_DROP(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptDropBehaviorContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CASCADE(): antlr.TerminalNode | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CollateClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_COLLATE(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RelOptionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    relOptionElem(): RelOptionElemContext[];
    relOptionElem(i: number): RelOptionElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptRelOptionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode;
    relOptions(): RelOptionsContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RelOptionElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colLabel(): ColLabelContext;
    EQUAL(): antlr.TerminalNode | null;
    defArg(): DefArgContext | null;
    DOT(): antlr.TerminalNode | null;
    defElem(): DefElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PartitionBoundSpecContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FOR(): antlr.TerminalNode | null;
    KW_VALUES(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    KW_MODULUS(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext[];
    numericOnly(i: number): NumericOnlyContext | null;
    COMMA(): antlr.TerminalNode | null;
    KW_REMAINDER(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext[];
    executeParamClause(i: number): ExecuteParamClauseContext | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterCompositeTypeStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_TYPE(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    alterTypeCmd(): AlterTypeCmdContext[];
    alterTypeCmd(i: number): AlterTypeCmdContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTypeCmdContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ADD(): antlr.TerminalNode | null;
    KW_ATTRIBUTE(): antlr.TerminalNode;
    tableFuncElement(): TableFuncElementContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    KW_DROP(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    ifExists(): IfExistsContext | null;
    KW_ALTER(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    collateClause(): CollateClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ClosePortalStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CLOSE(): antlr.TerminalNode;
    colId(): ColIdContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CopyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_COPY(): antlr.TerminalNode;
    tableName(): TableNameContext | null;
    copyOptions(): CopyOptionsContext;
    KW_FROM(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    stringConst(): StringConstContext[];
    stringConst(i: number): StringConstContext | null;
    KW_STDIN(): antlr.TerminalNode | null;
    KW_STDOUT(): antlr.TerminalNode | null;
    KW_BINARY(): antlr.TerminalNode | null;
    optColumnList(): OptColumnListContext | null;
    KW_PROGRAM(): antlr.TerminalNode | null;
    KW_DELIMITERS(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    whereClause(): WhereClauseContext | null;
    KW_USING(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    preParableStmt(): PreParableStmtContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CopyOptionsNoparensContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BINARY(): antlr.TerminalNode[];
    KW_BINARY(i: number): antlr.TerminalNode | null;
    KW_FREEZE(): antlr.TerminalNode[];
    KW_FREEZE(i: number): antlr.TerminalNode | null;
    stringConst(): StringConstContext[];
    stringConst(i: number): StringConstContext | null;
    KW_CSV(): antlr.TerminalNode[];
    KW_CSV(i: number): antlr.TerminalNode | null;
    KW_HEADER(): antlr.TerminalNode[];
    KW_HEADER(i: number): antlr.TerminalNode | null;
    KW_FORCE(): antlr.TerminalNode[];
    KW_FORCE(i: number): antlr.TerminalNode | null;
    KW_QUOTE(): antlr.TerminalNode[];
    KW_QUOTE(i: number): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode[];
    KW_NULL(i: number): antlr.TerminalNode | null;
    columnList(): ColumnListContext[];
    columnList(i: number): ColumnListContext | null;
    KW_ENCODING(): antlr.TerminalNode[];
    KW_ENCODING(i: number): antlr.TerminalNode | null;
    KW_DELIMITER(): antlr.TerminalNode[];
    KW_DELIMITER(i: number): antlr.TerminalNode | null;
    KW_ESCAPE(): antlr.TerminalNode[];
    KW_ESCAPE(i: number): antlr.TerminalNode | null;
    KW_FORCE_QUOTE(): antlr.TerminalNode[];
    KW_FORCE_QUOTE(i: number): antlr.TerminalNode | null;
    KW_FORCE_NOT_NULL(): antlr.TerminalNode[];
    KW_FORCE_NOT_NULL(i: number): antlr.TerminalNode | null;
    KW_FORCE_NULL(): antlr.TerminalNode[];
    KW_FORCE_NULL(i: number): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode[];
    STAR(i: number): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode[];
    KW_AS(i: number): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode[];
    KW_NOT(i: number): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CopyOptionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    copyOptionsNoparens(): CopyOptionsNoparensContext[];
    copyOptionsNoparens(i: number): CopyOptionsNoparensContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    copyGenericOptElem(): CopyGenericOptElemContext[];
    copyGenericOptElem(i: number): CopyGenericOptElemContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CopyGenericOptElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colLabel(): ColLabelContext;
    booleanOrString(): BooleanOrStringContext | null;
    numericOnly(): NumericOnlyContext | null;
    STAR(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    optBooleanOrStringColumn(): OptBooleanOrStringColumnContext[];
    optBooleanOrStringColumn(i: number): OptBooleanOrStringColumnContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: CreateStmtContext): void;
}
export declare class ColumnCreateTableContext extends CreateStmtContext {
    constructor(ctx: CreateStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_TABLE(): antlr.TerminalNode;
    tableNameCreate(): TableNameCreateContext;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_PARTITION(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    partitionBoundSpec(): PartitionBoundSpecContext | null;
    optTemp(): OptTempContext | null;
    ifNotExists(): IfNotExistsContext | null;
    tableElementList(): TableElementListContext | null;
    optInherit(): OptInheritContext | null;
    partitionSpec(): PartitionSpecContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    optWith(): OptWithContext | null;
    onCommitOption(): OnCommitOptionContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    optTypedTableElEmentList(): OptTypedTableElEmentListContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptTempContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TEMPORARY(): antlr.TerminalNode | null;
    KW_TEMP(): antlr.TerminalNode | null;
    KW_LOCAL(): antlr.TerminalNode | null;
    KW_GLOBAL(): antlr.TerminalNode | null;
    KW_UNLOGGED(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptTypedTableElEmentListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    typedTableElement(): TypedTableElementContext[];
    typedTableElement(i: number): TypedTableElementContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableElementListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableElement(): TableElementContext[];
    tableElement(i: number): TableElementContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableElementContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    constraintElem(): ConstraintElemContext | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    column_def(): Column_defContext | null;
    KW_LIKE(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    tableLikeOption(): TableLikeOptionContext[];
    tableLikeOption(i: number): TableLikeOptionContext | null;
    KW_INCLUDING(): antlr.TerminalNode[];
    KW_INCLUDING(i: number): antlr.TerminalNode | null;
    KW_EXCLUDING(): antlr.TerminalNode[];
    KW_EXCLUDING(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TypedTableElementContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnNameCreate(): ColumnNameCreateContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_OPTIONS(): antlr.TerminalNode | null;
    colConstraint(): ColConstraintContext[];
    colConstraint(i: number): ColConstraintContext | null;
    constraintElem(): ConstraintElemContext | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class Column_defContext extends antlr.ParserRuleContext {
    _colType?: TypenameContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnNameCreate(): ColumnNameCreateContext;
    typename(): TypenameContext;
    createGenericOptions(): CreateGenericOptionsContext | null;
    KW_STORAGE(): antlr.TerminalNode | null;
    KW_COMPRESSION(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    collateClause(): CollateClauseContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_OPTIONS(): antlr.TerminalNode | null;
    colConstraint(): ColConstraintContext[];
    colConstraint(i: number): ColConstraintContext | null;
    KW_PLAIN(): antlr.TerminalNode | null;
    KW_EXTERNAL(): antlr.TerminalNode | null;
    KW_EXTENDED(): antlr.TerminalNode | null;
    KW_MAIN(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColConstraintContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colConstraintElem(): ColConstraintElemContext;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_DEFERRABLE(): antlr.TerminalNode | null;
    KW_INITIALLY(): antlr.TerminalNode | null;
    KW_DEFERRED(): antlr.TerminalNode | null;
    KW_IMMEDIATE(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColConstraintElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NULL(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_UNIQUE(): antlr.TerminalNode | null;
    optDefinition(): OptDefinitionContext | null;
    optConstableSpace(): OptConstableSpaceContext | null;
    KW_NULLS(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    KW_INCLUDE(): antlr.TerminalNode | null;
    indexParams(): IndexParamsContext | null;
    withClause(): WithClauseContext | null;
    KW_PRIMARY(): antlr.TerminalNode | null;
    KW_KEY(): antlr.TerminalNode | null;
    KW_CHECK(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_INHERIT(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    primaryExpression(): PrimaryExpressionContext | null;
    KW_GENERATED(): antlr.TerminalNode | null;
    generatedWhen(): GeneratedWhenContext | null;
    KW_AS(): antlr.TerminalNode | null;
    KW_IDENTITY(): antlr.TerminalNode | null;
    KW_STORED(): antlr.TerminalNode | null;
    seqOptElem(): SeqOptElemContext[];
    seqOptElem(i: number): SeqOptElemContext | null;
    KW_REFERENCES(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    optColumnList(): OptColumnListContext | null;
    keyMatch(): KeyMatchContext | null;
    keyActions(): KeyActionsContext | null;
    collateClause(): CollateClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GeneratedWhenContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALWAYS(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableLikeOptionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_COMMENTS(): antlr.TerminalNode | null;
    KW_CONSTRAINTS(): antlr.TerminalNode | null;
    KW_DEFAULTS(): antlr.TerminalNode | null;
    KW_IDENTITY(): antlr.TerminalNode | null;
    KW_GENERATED(): antlr.TerminalNode | null;
    KW_INDEXES(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_STORAGE(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConstraintElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CHECK(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    constraintAttributeElem(): ConstraintAttributeElemContext[];
    constraintAttributeElem(i: number): ConstraintAttributeElemContext | null;
    KW_UNIQUE(): antlr.TerminalNode | null;
    optColumnList(): OptColumnListContext[];
    optColumnList(i: number): OptColumnListContext | null;
    existingIndex(): ExistingIndexContext | null;
    KW_PRIMARY(): antlr.TerminalNode | null;
    KW_KEY(): antlr.TerminalNode | null;
    columnListInclude(): ColumnListIncludeContext | null;
    optDefinition(): OptDefinitionContext | null;
    optConstableSpace(): OptConstableSpaceContext | null;
    KW_EXCLUDE(): antlr.TerminalNode | null;
    exclusionConstraintElem(): ExclusionConstraintElemContext[];
    exclusionConstraintElem(i: number): ExclusionConstraintElemContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_WHERE(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_REFERENCES(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    keyMatch(): KeyMatchContext | null;
    keyActions(): KeyActionsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptColumnListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    columnList(): ColumnListContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnListCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    columnNameCreate(): ColumnNameCreateContext[];
    columnNameCreate(i: number): ColumnNameCreateContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext[];
    columnName(i: number): ColumnNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnListIncludeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INCLUDE(): antlr.TerminalNode;
    optColumnList(): OptColumnListContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class KeyMatchContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_MATCH(): antlr.TerminalNode;
    KW_FULL(): antlr.TerminalNode | null;
    KW_PARTIAL(): antlr.TerminalNode | null;
    KW_SIMPLE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExclusionConstraintElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    indexElem(): IndexElemContext;
    KW_WITH(): antlr.TerminalNode;
    anyOperator(): AnyOperatorContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class KeyActionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    keyUpdate(): KeyUpdateContext | null;
    keyDelete(): KeyDeleteContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class KeyUpdateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ON(): antlr.TerminalNode;
    KW_UPDATE(): antlr.TerminalNode;
    keyAction(): KeyActionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class KeyDeleteContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ON(): antlr.TerminalNode;
    KW_DELETE(): antlr.TerminalNode;
    keyAction(): KeyActionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class KeyActionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NO(): antlr.TerminalNode | null;
    KW_ACTION(): antlr.TerminalNode | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    KW_CASCADE(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    columnList(): ColumnListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptInheritContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INHERITS(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    qualifiedNameList(): QualifiedNameListContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PartitionSpecContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PARTITION(): antlr.TerminalNode;
    KW_BY(): antlr.TerminalNode;
    colId(): ColIdContext;
    OPEN_PAREN(): antlr.TerminalNode;
    partElem(): PartElemContext[];
    partElem(i: number): PartElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PartElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext | null;
    funcExprWindowless(): FuncExprWindowlessContext | null;
    collateClause(): CollateClauseContext | null;
    anyName(): AnyNameContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableAccessMethodClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_USING(): antlr.TerminalNode;
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptWithContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode | null;
    relOptions(): RelOptionsContext | null;
    KW_OIDS(): antlr.TerminalNode | null;
    KW_WITHOUT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OnCommitOptionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ON(): antlr.TerminalNode;
    KW_COMMIT(): antlr.TerminalNode;
    KW_DROP(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_PRESERVE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptTableSpaceContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLESPACE(): antlr.TerminalNode;
    tableSpaceName(): TableSpaceNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptConstableSpaceContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_USING(): antlr.TerminalNode;
    KW_INDEX(): antlr.TerminalNode;
    optTableSpace(): OptTableSpaceContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExistingIndexContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_USING(): antlr.TerminalNode;
    KW_INDEX(): antlr.TerminalNode;
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateStatsStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_STATISTICS(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode;
    fromClause(): FromClauseContext;
    columnExpr(): ColumnExprContext[];
    columnExpr(i: number): ColumnExprContext | null;
    exprList(): ExprListContext | null;
    anyName(): AnyNameContext | null;
    optColumnList(): OptColumnListContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    ifNotExists(): IfNotExistsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterStatsStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_STATISTICS(): antlr.TerminalNode[];
    KW_STATISTICS(i: number): antlr.TerminalNode | null;
    anyName(): AnyNameContext;
    KW_SET(): antlr.TerminalNode;
    signedConst(): SignedConstContext;
    ifExists(): IfExistsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateAsStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: CreateAsStmtContext): void;
}
export declare class QueryCreateTableContext extends CreateAsStmtContext {
    constructor(ctx: CreateAsStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_TABLE(): antlr.TerminalNode;
    createAsTarget(): CreateAsTargetContext;
    KW_AS(): antlr.TerminalNode;
    selectStmt(): SelectStmtContext;
    optTemp(): OptTempContext | null;
    ifNotExists(): IfNotExistsContext | null;
    optWithData(): OptWithDataContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateAsTargetContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableNameCreate(): TableNameCreateContext;
    columnListCreate(): ColumnListCreateContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    optWith(): OptWithContext | null;
    onCommitOption(): OnCommitOptionContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptWithDataContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode;
    KW_DATA(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateMaterializedViewStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: CreateMaterializedViewStmtContext): void;
}
export declare class CreateMaterializedViewContext extends CreateMaterializedViewStmtContext {
    constructor(ctx: CreateMaterializedViewStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_MATERIALIZED(): antlr.TerminalNode;
    KW_VIEW(): antlr.TerminalNode;
    viewNameCreate(): ViewNameCreateContext;
    KW_AS(): antlr.TerminalNode;
    selectStmt(): SelectStmtContext;
    KW_UNLOGGED(): antlr.TerminalNode | null;
    ifNotExists(): IfNotExistsContext | null;
    columnListCreate(): ColumnListCreateContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    optRelOptions(): OptRelOptionsContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    optWithData(): OptWithDataContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RefreshMaterializedViewStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_REFRESH(): antlr.TerminalNode;
    KW_MATERIALIZED(): antlr.TerminalNode;
    KW_VIEW(): antlr.TerminalNode;
    viewName(): ViewNameContext;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    optWithData(): OptWithDataContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateSeqStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_SEQUENCE(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    optTemp(): OptTempContext | null;
    ifNotExists(): IfNotExistsContext | null;
    seqOptElem(): SeqOptElemContext[];
    seqOptElem(i: number): SeqOptElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterSeqStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_SEQUENCE(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    ifExists(): IfExistsContext | null;
    seqOptElem(): SeqOptElemContext[];
    seqOptElem(i: number): SeqOptElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SeqOptElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_AS(): antlr.TerminalNode | null;
    simpleTypeName(): SimpleTypeNameContext | null;
    KW_CACHE(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    KW_INCREMENT(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    KW_MAXVALUE(): antlr.TerminalNode | null;
    KW_MINVALUE(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_CYCLE(): antlr.TerminalNode | null;
    KW_OWNED(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_NAME(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_START(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_RESTART(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NumericOnlyContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Numeric(): antlr.TerminalNode | null;
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    signedConst(): SignedConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateProceduralLangStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_LANGUAGE(): antlr.TerminalNode;
    colId(): ColIdContext;
    orReplaceOpt(): OrReplaceOptContext | null;
    KW_TRUSTED(): antlr.TerminalNode | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    KW_HANDLER(): antlr.TerminalNode | null;
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    KW_INLINE(): antlr.TerminalNode | null;
    KW_VALIDATOR(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateTableSpaceStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    optTableSpace(): OptTableSpaceContext;
    KW_LOCATION(): antlr.TerminalNode;
    stringConst(): StringConstContext;
    KW_OWNER(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    optRelOptions(): OptRelOptionsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateExtensionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_EXTENSION(): antlr.TerminalNode;
    colId(): ColIdContext;
    ifNotExists(): IfNotExistsContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode[];
    KW_SCHEMA(i: number): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext[];
    schemaName(i: number): SchemaNameContext | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext[];
    nonReservedWordOrStringConst(i: number): NonReservedWordOrStringConstContext | null;
    KW_CASCADE(): antlr.TerminalNode[];
    KW_CASCADE(i: number): antlr.TerminalNode | null;
    KW_VERSION(): antlr.TerminalNode[];
    KW_VERSION(i: number): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode[];
    KW_FROM(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterExtensionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_EXTENSION(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_UPDATE(): antlr.TerminalNode;
    KW_TO(): antlr.TerminalNode[];
    KW_TO(i: number): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext[];
    nonReservedWordOrStringConst(i: number): NonReservedWordOrStringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterExtensionContentsStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_EXTENSION(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    KW_TRANSFORM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    operatorWithArgTypes(): OperatorWithArgTypesContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_CAST(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    objectTypeName(): ObjectTypeNameContext | null;
    objectTypeAnyName(): ObjectTypeAnyNameContext | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateFdwStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_DATA(): antlr.TerminalNode;
    KW_WRAPPER(): antlr.TerminalNode;
    colId(): ColIdContext;
    createGenericOptions(): CreateGenericOptionsContext | null;
    fdwOption(): FdwOptionContext[];
    fdwOption(i: number): FdwOptionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FdwOptionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_HANDLER(): antlr.TerminalNode | null;
    KW_VALIDATOR(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterFdwStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_DATA(): antlr.TerminalNode;
    KW_WRAPPER(): antlr.TerminalNode;
    colId(): ColIdContext;
    alterGenericOptions(): AlterGenericOptionsContext | null;
    fdwOption(): FdwOptionContext[];
    fdwOption(i: number): FdwOptionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateGenericOptionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OPTIONS(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    genericOptionElem(): GenericOptionElemContext[];
    genericOptionElem(i: number): GenericOptionElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterGenericOptionsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OPTIONS(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    alterGenericOptionElem(): AlterGenericOptionElemContext[];
    alterGenericOptionElem(i: number): AlterGenericOptionElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterGenericOptionElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    genericOptionElem(): GenericOptionElemContext;
    KW_SET(): antlr.TerminalNode | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GenericOptionElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colLabel(): ColLabelContext;
    stringConst(): StringConstContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateForeignServerStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_DATA(): antlr.TerminalNode;
    KW_WRAPPER(): antlr.TerminalNode;
    ifNotExists(): IfNotExistsContext | null;
    KW_TYPE(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    foreignServerVersion(): ForeignServerVersionContext | null;
    createGenericOptions(): CreateGenericOptionsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ForeignServerVersionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VERSION(): antlr.TerminalNode;
    stringConst(): StringConstContext | null;
    KW_NULL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterForeignServerStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext;
    alterGenericOptions(): AlterGenericOptionsContext | null;
    foreignServerVersion(): ForeignServerVersionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateForeignTableStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: CreateForeignTableStmtContext): void;
}
export declare class CreateForeignTableContext extends CreateForeignTableStmtContext {
    constructor(ctx: CreateForeignTableStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_TABLE(): antlr.TerminalNode;
    tableNameCreate(): TableNameCreateContext;
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext;
    ifNotExists(): IfNotExistsContext | null;
    tableElementList(): TableElementListContext | null;
    optInherit(): OptInheritContext | null;
    createGenericOptions(): CreateGenericOptionsContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreatePartitionForeignTableContext extends CreateForeignTableStmtContext {
    constructor(ctx: CreateForeignTableStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_TABLE(): antlr.TerminalNode;
    tableNameCreate(): TableNameCreateContext;
    KW_PARTITION(): antlr.TerminalNode;
    KW_OF(): antlr.TerminalNode;
    tableName(): TableNameContext;
    partitionBoundSpec(): PartitionBoundSpecContext;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext;
    ifNotExists(): IfNotExistsContext | null;
    optTypedTableElEmentList(): OptTypedTableElEmentListContext | null;
    createGenericOptions(): CreateGenericOptionsContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ImportForeignSchemaStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IMPORT(): antlr.TerminalNode;
    KW_FOREIGN(): antlr.TerminalNode;
    KW_SCHEMA(): antlr.TerminalNode;
    schemaName(): SchemaNameContext;
    KW_FROM(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_INTO(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode | null;
    relationExprList(): RelationExprListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    createGenericOptions(): CreateGenericOptionsContext | null;
    KW_LIMIT(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_EXCEPT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateUserMappingStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_USER(): antlr.TerminalNode[];
    KW_USER(i: number): antlr.TerminalNode | null;
    KW_MAPPING(): antlr.TerminalNode;
    KW_FOR(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext;
    roleSpec(): RoleSpecContext | null;
    ifNotExists(): IfNotExistsContext | null;
    createGenericOptions(): CreateGenericOptionsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterUserMappingStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_USER(): antlr.TerminalNode[];
    KW_USER(i: number): antlr.TerminalNode | null;
    KW_MAPPING(): antlr.TerminalNode;
    KW_FOR(): antlr.TerminalNode;
    KW_SERVER(): antlr.TerminalNode;
    colId(): ColIdContext;
    alterGenericOptions(): AlterGenericOptionsContext;
    roleSpec(): RoleSpecContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreatePolicyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_POLICY(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_ON(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    KW_AS(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    rowSecurityOptionalExpr(): RowSecurityOptionalExprContext | null;
    rowSecurityOptionalWithCheck(): RowSecurityOptionalWithCheckContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_SELECT(): antlr.TerminalNode | null;
    KW_INSERT(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_PERMISSIVE(): antlr.TerminalNode | null;
    KW_RESTRICTIVE(): antlr.TerminalNode | null;
    identifier(): IdentifierContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterPolicyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_POLICY(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_ON(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    KW_TO(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    rowSecurityOptionalExpr(): RowSecurityOptionalExprContext | null;
    rowSecurityOptionalWithCheck(): RowSecurityOptionalWithCheckContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterProcedureStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_PROCEDURE(): antlr.TerminalNode;
    procedureName(): ProcedureNameContext;
    procedureAction(): ProcedureActionContext[];
    procedureAction(i: number): ProcedureActionContext | null;
    KW_RENAME(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    procedureNameCreate(): ProcedureNameCreateContext | null;
    KW_OWNER(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaNameCreate(): SchemaNameCreateContext | null;
    KW_DEPENDS(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    funcArgs(): FuncArgsContext | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcedureActionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SECURITY(): antlr.TerminalNode | null;
    KW_INVOKER(): antlr.TerminalNode | null;
    KW_DEFINER(): antlr.TerminalNode | null;
    KW_EXTERNAL(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_TO(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_RESET(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RowSecurityOptionalExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_USING(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    expression(): ExpressionContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RowSecurityOptionalWithCheckContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode;
    KW_CHECK(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    expression(): ExpressionContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateAccessMethodStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_ACCESS(): antlr.TerminalNode;
    KW_METHOD(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_TYPE(): antlr.TerminalNode;
    KW_HANDLER(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateTrigStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_TRIGGER(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    triggerActionTime(): TriggerActionTimeContext;
    triggerEvents(): TriggerEventsContext;
    KW_ON(): antlr.TerminalNode;
    tableName(): TableNameContext;
    KW_EXECUTE(): antlr.TerminalNode;
    functionOrProcedure(): FunctionOrProcedureContext;
    OPEN_PAREN(): antlr.TerminalNode;
    triggerFuncArgs(): TriggerFuncArgsContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    orReplaceOpt(): OrReplaceOptContext | null;
    KW_REFERENCING(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    triggerWhen(): TriggerWhenContext | null;
    KW_ROW(): antlr.TerminalNode[];
    KW_ROW(i: number): antlr.TerminalNode | null;
    KW_STATEMENT(): antlr.TerminalNode | null;
    KW_EACH(): antlr.TerminalNode | null;
    KW_NEW(): antlr.TerminalNode[];
    KW_NEW(i: number): antlr.TerminalNode | null;
    KW_OLD(): antlr.TerminalNode[];
    KW_OLD(i: number): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode[];
    KW_TABLE(i: number): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode[];
    KW_AS(i: number): antlr.TerminalNode | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    constraintAttributeElem(): ConstraintAttributeElemContext[];
    constraintAttributeElem(i: number): ConstraintAttributeElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerActionTimeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BEFORE(): antlr.TerminalNode | null;
    KW_AFTER(): antlr.TerminalNode | null;
    KW_INSTEAD(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerEventsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    triggerOneEvent(): TriggerOneEventContext[];
    triggerOneEvent(i: number): TriggerOneEventContext | null;
    KW_OR(): antlr.TerminalNode[];
    KW_OR(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerOneEventContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INSERT(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    columnList(): ColumnListContext | null;
    KW_TRUNCATE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerWhenContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WHEN(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    expression(): ExpressionContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionOrProcedureContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionName(): FunctionNameContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureName(): ProcedureNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerFuncArgsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    triggerFuncArg(): TriggerFuncArgContext[];
    triggerFuncArg(i: number): TriggerFuncArgContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TriggerFuncArgContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Integral(): antlr.TerminalNode | null;
    Numeric(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    colLabel(): ColLabelContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConstraintAttributeElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DEFERRABLE(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_INITIALLY(): antlr.TerminalNode | null;
    KW_IMMEDIATE(): antlr.TerminalNode | null;
    KW_DEFERRED(): antlr.TerminalNode | null;
    KW_VALID(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_INHERIT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateEventTrigStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_EVENT(): antlr.TerminalNode;
    KW_TRIGGER(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_ON(): antlr.TerminalNode;
    colLabel(): ColLabelContext;
    KW_EXECUTE(): antlr.TerminalNode;
    functionOrProcedure(): FunctionOrProcedureContext;
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    KW_WHEN(): antlr.TerminalNode | null;
    eventTriggerWhenItem(): EventTriggerWhenItemContext[];
    eventTriggerWhenItem(i: number): EventTriggerWhenItemContext | null;
    KW_AND(): antlr.TerminalNode[];
    KW_AND(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class EventTriggerWhenItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    KW_IN(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    stringConst(): StringConstContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    notifyPayload(): NotifyPayloadContext[];
    notifyPayload(i: number): NotifyPayloadContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterEventTrigStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_EVENT(): antlr.TerminalNode;
    KW_TRIGGER(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_ENABLE(): antlr.TerminalNode | null;
    KW_DISABLE(): antlr.TerminalNode | null;
    KW_REPLICA(): antlr.TerminalNode | null;
    KW_ALWAYS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateAssertionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_ASSERTION(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    KW_CHECK(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    expression(): ExpressionContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    constraintAttributeElem(): ConstraintAttributeElemContext[];
    constraintAttributeElem(i: number): ConstraintAttributeElemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefineStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    functionName(): FunctionNameContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    oldAggregateElem(): OldAggregateElemContext[];
    oldAggregateElem(i: number): OldAggregateElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    orReplaceOpt(): OrReplaceOptContext | null;
    aggregateArgs(): AggregateArgsContext | null;
    definition(): DefinitionContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    anyOperator(): AnyOperatorContext | null;
    KW_TYPE(): antlr.TerminalNode | null;
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    KW_AS(): antlr.TerminalNode | null;
    KW_ENUM(): antlr.TerminalNode | null;
    tableFuncElementList(): TableFuncElementListContext | null;
    stringConst(): StringConstContext | null;
    notifyPayload(): NotifyPayloadContext[];
    notifyPayload(i: number): NotifyPayloadContext | null;
    KW_RANGE(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    ifNotExists(): IfNotExistsContext | null;
    KW_FROM(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefinitionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    defElem(): DefElemContext[];
    defElem(i: number): DefElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colLabel(): ColLabelContext;
    EQUAL(): antlr.TerminalNode | null;
    defArg(): DefArgContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefArgContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcType(): FuncTypeContext | null;
    reservedKeyword(): ReservedKeywordContext | null;
    qualAllOp(): QualAllOpContext | null;
    numericOnly(): NumericOnlyContext | null;
    stringConst(): StringConstContext | null;
    KW_NONE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OldAggregateElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext;
    EQUAL(): antlr.TerminalNode;
    defArg(): DefArgContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterEnumStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_TYPE(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    KW_ADD(): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode;
    stringConst(): StringConstContext[];
    stringConst(i: number): StringConstContext | null;
    ifNotExists(): IfNotExistsContext | null;
    KW_BEFORE(): antlr.TerminalNode | null;
    KW_AFTER(): antlr.TerminalNode | null;
    KW_RENAME(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IfNotExistsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IF(): antlr.TerminalNode;
    KW_NOT(): antlr.TerminalNode;
    KW_EXISTS(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateOperatorClassStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode;
    KW_CLASS(): antlr.TerminalNode;
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    KW_FOR(): antlr.TerminalNode;
    KW_TYPE(): antlr.TerminalNode;
    typename(): TypenameContext;
    tableAccessMethodClause(): TableAccessMethodClauseContext;
    KW_AS(): antlr.TerminalNode;
    opClassItem(): OpClassItemContext[];
    opClassItem(i: number): OpClassItemContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OpClassItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OPERATOR(): antlr.TerminalNode | null;
    Integral(): antlr.TerminalNode | null;
    anyOperator(): AnyOperatorContext | null;
    operatorArgTypes(): OperatorArgTypesContext | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_RECHECK(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_ORDER(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    prepTypeClause(): PrepTypeClauseContext | null;
    KW_STORAGE(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateOperatorFamilyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode;
    KW_FAMILY(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    tableAccessMethodClause(): TableAccessMethodClauseContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterOperatorFamilyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode;
    KW_FAMILY(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    tableAccessMethodClause(): TableAccessMethodClauseContext;
    KW_ADD(): antlr.TerminalNode | null;
    opClassItem(): OpClassItemContext[];
    opClassItem(i: number): OpClassItemContext | null;
    KW_DROP(): antlr.TerminalNode | null;
    opClassDrop(): OpClassDropContext[];
    opClassDrop(i: number): OpClassDropContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OpClassDropContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Integral(): antlr.TerminalNode;
    prepTypeClause(): PrepTypeClauseContext;
    KW_OPERATOR(): antlr.TerminalNode | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ReassignOwnedStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_REASSIGN(): antlr.TerminalNode;
    KW_OWNED(): antlr.TerminalNode;
    KW_BY(): antlr.TerminalNode;
    roleList(): RoleListContext;
    KW_TO(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DropStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DROP(): antlr.TerminalNode;
    nameList(): NameListContext | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_ACCESS(): antlr.TerminalNode | null;
    KW_METHOD(): antlr.TerminalNode | null;
    KW_EVENT(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext[];
    viewName(i: number): ViewNameContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    tableNameList(): TableNameListContext | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaNameList(): SchemaNameListContext | null;
    colId(): ColIdContext | null;
    KW_ON(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_POLICY(): antlr.TerminalNode | null;
    KW_RULE(): antlr.TerminalNode | null;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    anyNameList(): AnyNameListContext | null;
    KW_CAST(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    KW_OWNED(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    roleList(): RoleListContext | null;
    KW_SUBSCRIPTION(): antlr.TerminalNode | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    tableSpaceName(): TableSpaceNameContext | null;
    KW_TRANSFORM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode[];
    KW_USER(i: number): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    KW_MAPPING(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseName(): DatabaseNameContext | null;
    KW_FORCE(): antlr.TerminalNode[];
    KW_FORCE(i: number): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ObjectTypeAnyNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLE(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ObjectTypeNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext | null;
    KW_EVENT(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_ACCESS(): antlr.TerminalNode | null;
    KW_METHOD(): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_SUBSCRIPTION(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseName(): DatabaseNameContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnyNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnyNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    attrs(): AttrsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AttrsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    DOT(): antlr.TerminalNode[];
    DOT(i: number): antlr.TerminalNode | null;
    colLabel(): ColLabelContext[];
    colLabel(i: number): ColLabelContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TruncateStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TRUNCATE(): antlr.TerminalNode;
    truncateTable(): TruncateTableContext[];
    truncateTable(i: number): TruncateTableContext | null;
    KW_TABLE(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_IDENTITY(): antlr.TerminalNode | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    KW_CONTINUE(): antlr.TerminalNode | null;
    KW_RESTART(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TruncateTableContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableName(): TableNameContext;
    KW_ONLY(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CommentStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_COMMENT(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode[];
    KW_ON(i: number): antlr.TerminalNode | null;
    KW_IS(): antlr.TerminalNode;
    objectTypeAnyName(): ObjectTypeAnyNameContext | null;
    objectTypeName(): ObjectTypeNameContext | null;
    KW_COLUMN(): antlr.TerminalNode | null;
    DOT(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    operatorWithArgTypes(): OperatorWithArgTypesContext | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    anyName(): AnyNameContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_TRANSFORM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_LARGE(): antlr.TerminalNode | null;
    KW_OBJECT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    KW_CAST(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_POLICY(): antlr.TerminalNode | null;
    KW_RULE(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    attrs(): AttrsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SecLabelStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SECURITY(): antlr.TerminalNode;
    KW_LABEL(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode;
    KW_IS(): antlr.TerminalNode;
    typename(): TypenameContext | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    KW_COLUMN(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_LARGE(): antlr.TerminalNode | null;
    KW_OBJECT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    objectTypeAnyName(): ObjectTypeAnyNameContext | null;
    objectTypeName(): ObjectTypeNameContext | null;
    stringConst(): StringConstContext | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FetchStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    fetch_args(): Fetch_argsContext;
    KW_FETCH(): antlr.TerminalNode | null;
    KW_MOVE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class Fetch_argsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    fromIn(): FromInContext | null;
    KW_NEXT(): antlr.TerminalNode | null;
    KW_PRIOR(): antlr.TerminalNode | null;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_LAST(): antlr.TerminalNode | null;
    signedConst(): SignedConstContext | null;
    KW_ABSOLUTE(): antlr.TerminalNode | null;
    KW_RELATIVE(): antlr.TerminalNode | null;
    KW_FORWARD(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_BACKWARD(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FromInContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FROM(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GrantStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_GRANT(): antlr.TerminalNode[];
    KW_GRANT(i: number): antlr.TerminalNode | null;
    privileges(): PrivilegesContext;
    KW_ON(): antlr.TerminalNode;
    privilegeTarget(): PrivilegeTargetContext;
    KW_TO(): antlr.TerminalNode;
    granteeList(): GranteeListContext;
    KW_WITH(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RevokeStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_REVOKE(): antlr.TerminalNode;
    privileges(): PrivilegesContext;
    KW_ON(): antlr.TerminalNode;
    privilegeTarget(): PrivilegeTargetContext;
    KW_FROM(): antlr.TerminalNode;
    granteeList(): GranteeListContext;
    KW_GRANT(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrivilegesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    privilege(): PrivilegeContext[];
    privilege(i: number): PrivilegeContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_PRIVILEGES(): antlr.TerminalNode | null;
    optColumnList(): OptColumnListContext | null;
    beforePrivilegeSelect(): BeforePrivilegeSelectContext[];
    beforePrivilegeSelect(i: number): BeforePrivilegeSelectContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class BeforePrivilegeSelectContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SELECT(): antlr.TerminalNode | null;
    KW_INSERT(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_TRUNCATE(): antlr.TerminalNode | null;
    KW_PEFERENCES(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_USAGE(): antlr.TerminalNode | null;
    KW_CREATE(): antlr.TerminalNode | null;
    KW_CONNECT(): antlr.TerminalNode | null;
    KW_TEMPORARY(): antlr.TerminalNode | null;
    KW_TEMP(): antlr.TerminalNode | null;
    KW_EXECUTE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrivilegeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SELECT(): antlr.TerminalNode | null;
    KW_REFERENCES(): antlr.TerminalNode | null;
    KW_CREATE(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    optColumnList(): OptColumnListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrivilegeTargetContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLE(): antlr.TerminalNode | null;
    tableNameList(): TableNameListContext | null;
    qualifiedNameList(): QualifiedNameListContext | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    nameList(): NameListContext | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypesList(): FunctionWithArgTypesListContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypesList(): ProcedureWithArgTypesListContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypesList(): RoutineWithArgTypesListContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseNameList(): DatabaseNameListContext | null;
    anyNameList(): AnyNameListContext | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_LARGE(): antlr.TerminalNode | null;
    KW_OBJECT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext[];
    numericOnly(i: number): NumericOnlyContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaNameList(): SchemaNameListContext | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    tableSpaceNameList(): TableSpaceNameListContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_TABLES(): antlr.TerminalNode | null;
    KW_SEQUENCES(): antlr.TerminalNode | null;
    KW_FUNCTIONS(): antlr.TerminalNode | null;
    KW_PROCEDURES(): antlr.TerminalNode | null;
    KW_ROUTINES(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GranteeListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    roleSpec(): RoleSpecContext[];
    roleSpec(i: number): RoleSpecContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode[];
    KW_GROUP(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GrantRoleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_GRANT(): antlr.TerminalNode;
    privilege(): PrivilegeContext[];
    privilege(i: number): PrivilegeContext | null;
    KW_TO(): antlr.TerminalNode;
    roleList(): RoleListContext;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_ADMIN(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    KW_GRANTED(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RevokeRoleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_REVOKE(): antlr.TerminalNode;
    privilege(): PrivilegeContext[];
    privilege(i: number): PrivilegeContext | null;
    KW_FROM(): antlr.TerminalNode;
    roleList(): RoleListContext;
    KW_ADMIN(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_GRANTED(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterDefaultPrivilegesStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_DEFAULT(): antlr.TerminalNode;
    KW_PRIVILEGES(): antlr.TerminalNode;
    defaclaction(): DefaclactionContext;
    KW_IN(): antlr.TerminalNode[];
    KW_IN(i: number): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode[];
    KW_SCHEMA(i: number): antlr.TerminalNode | null;
    schemaNameList(): SchemaNameListContext[];
    schemaNameList(i: number): SchemaNameListContext | null;
    KW_FOR(): antlr.TerminalNode[];
    KW_FOR(i: number): antlr.TerminalNode | null;
    roleList(): RoleListContext[];
    roleList(i: number): RoleListContext | null;
    KW_ROLE(): antlr.TerminalNode[];
    KW_ROLE(i: number): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode[];
    KW_USER(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefaclactionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_GRANT(): antlr.TerminalNode[];
    KW_GRANT(i: number): antlr.TerminalNode | null;
    privileges(): PrivilegesContext;
    KW_ON(): antlr.TerminalNode;
    defaclPrivilegeTarget(): DefaclPrivilegeTargetContext;
    KW_TO(): antlr.TerminalNode | null;
    granteeList(): GranteeListContext;
    KW_WITH(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    KW_REVOKE(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefaclPrivilegeTargetContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLES(): antlr.TerminalNode | null;
    KW_FUNCTIONS(): antlr.TerminalNode | null;
    KW_ROUTINES(): antlr.TerminalNode | null;
    KW_SEQUENCES(): antlr.TerminalNode | null;
    KW_TYPES(): antlr.TerminalNode | null;
    KW_SCHEMAS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndexStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_INDEX(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode;
    relationExpr(): RelationExprContext;
    indexParams(): IndexParamsContext[];
    indexParams(i: number): IndexParamsContext | null;
    KW_UNIQUE(): antlr.TerminalNode | null;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    ifNotExists(): IfNotExistsContext | null;
    colId(): ColIdContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_INCLUDE(): antlr.TerminalNode | null;
    KW_NULLS(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    optRelOptions(): OptRelOptionsContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    whereClause(): WhereClauseContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndexParamsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    indexElem(): IndexElemContext[];
    indexElem(i: number): IndexElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndexElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext | null;
    funcExprWindowless(): FuncExprWindowlessContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    relOptions(): RelOptionsContext | null;
    collateClause(): CollateClauseContext | null;
    KW_NULLS(): antlr.TerminalNode | null;
    KW_ASC(): antlr.TerminalNode | null;
    KW_DESC(): antlr.TerminalNode | null;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_LAST(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateFunctionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionNameCreate(): FunctionNameCreateContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureNameCreate(): ProcedureNameCreateContext | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    orReplaceOpt(): OrReplaceOptContext | null;
    KW_RETURNS(): antlr.TerminalNode | null;
    createFuncOptItem(): CreateFuncOptItemContext[];
    createFuncOptItem(i: number): CreateFuncOptItemContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    nameList(): NameListContext | null;
    funcArgWithDefault(): FuncArgWithDefaultContext[];
    funcArgWithDefault(i: number): FuncArgWithDefaultContext | null;
    funcType(): FuncTypeContext | null;
    KW_TABLE(): antlr.TerminalNode | null;
    tableFuncColumn(): TableFuncColumnContext[];
    tableFuncColumn(i: number): TableFuncColumnContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OrReplaceOptContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OR(): antlr.TerminalNode;
    KW_REPLACE(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    funcArgsList(): FuncArgsListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgsListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcArg(): FuncArgContext[];
    funcArg(i: number): FuncArgContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoutineWithArgTypesListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    routineWithArgTypes(): RoutineWithArgTypesContext[];
    routineWithArgTypes(i: number): RoutineWithArgTypesContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoutineWithArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    routineName(): RoutineNameContext | null;
    funcArgs(): FuncArgsContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    qualifiedName(): QualifiedNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcedureWithArgTypesListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    procedureWithArgTypes(): ProcedureWithArgTypesContext[];
    procedureWithArgTypes(i: number): ProcedureWithArgTypesContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcedureWithArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    procedureName(): ProcedureNameContext | null;
    funcArgs(): FuncArgsContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    qualifiedName(): QualifiedNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionWithArgTypesListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    functionWithArgTypes(): FunctionWithArgTypesContext[];
    functionWithArgTypes(i: number): FunctionWithArgTypesContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionWithArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    functionName(): FunctionNameContext | null;
    funcArgs(): FuncArgsContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    qualifiedName(): QualifiedNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcType(): FuncTypeContext;
    argClass(): ArgClassContext | null;
    typeFunctionName(): TypeFunctionNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ArgClassContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IN(): antlr.TerminalNode | null;
    KW_OUT(): antlr.TerminalNode | null;
    KW_INOUT(): antlr.TerminalNode | null;
    KW_VARIADIC(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncTypeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typename(): TypenameContext | null;
    typeFunctionName(): TypeFunctionNameContext | null;
    attrs(): AttrsContext | null;
    PERCENT(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_SETOF(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgWithDefaultContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcArg(): FuncArgContext;
    expression(): ExpressionContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AggregateArgsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    STAR(): antlr.TerminalNode | null;
    funcArgsList(): FuncArgsListContext[];
    funcArgsList(i: number): FuncArgsListContext | null;
    KW_ORDER(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AggregateWithArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    functionName(): FunctionNameContext;
    aggregateArgs(): AggregateArgsContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CommonFuncOptItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ON(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode[];
    KW_NULL(i: number): antlr.TerminalNode | null;
    KW_INPUT(): antlr.TerminalNode | null;
    KW_RETURNS(): antlr.TerminalNode | null;
    KW_CALLED(): antlr.TerminalNode | null;
    KW_STRICT(): antlr.TerminalNode | null;
    KW_IMMUTABLE(): antlr.TerminalNode | null;
    KW_STABLE(): antlr.TerminalNode | null;
    KW_VOLATILE(): antlr.TerminalNode | null;
    KW_SECURITY(): antlr.TerminalNode | null;
    KW_DEFINER(): antlr.TerminalNode | null;
    KW_INVOKER(): antlr.TerminalNode | null;
    KW_EXTERNAL(): antlr.TerminalNode | null;
    KW_LEAKPROOF(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    KW_COST(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_SUPPORT(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_SET(): antlr.TerminalNode | null;
    setRestMore(): SetRestMoreContext | null;
    variableResetStmt(): VariableResetStmtContext | null;
    KW_PARALLEL(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateFuncOptItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_AS(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    notifyPayload(): NotifyPayloadContext | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext | null;
    KW_TRANSFORM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode[];
    KW_FOR(i: number): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode[];
    KW_TYPE(i: number): antlr.TerminalNode | null;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_WINDOW(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_TO(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    stmt(): StmtContext | null;
    commonFuncOptItem(): CommonFuncOptItemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptDefinitionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode;
    definition(): DefinitionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableFuncColumnContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext;
    funcType(): FuncTypeContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterFunctionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    commonFuncOptItem(): CommonFuncOptItemContext[];
    commonFuncOptItem(i: number): CommonFuncOptItemContext | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RemoveFuncStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DROP(): antlr.TerminalNode;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypesList(): FunctionWithArgTypesListContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypesList(): ProcedureWithArgTypesListContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypesList(): RoutineWithArgTypesListContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    ifExists(): IfExistsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RemoveAggregateStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DROP(): antlr.TerminalNode;
    KW_AGGREGATE(): antlr.TerminalNode;
    aggregateWithArgTypes(): AggregateWithArgTypesContext[];
    aggregateWithArgTypes(i: number): AggregateWithArgTypesContext | null;
    ifExists(): IfExistsContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RemoveOperatorStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DROP(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode;
    operatorWithArgTypes(): OperatorWithArgTypesContext[];
    operatorWithArgTypes(i: number): OperatorWithArgTypesContext | null;
    ifExists(): IfExistsContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OperatorArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    KW_NONE(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnyOperatorContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    allOp(): AllOpContext;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    DOT(): antlr.TerminalNode[];
    DOT(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OperatorWithArgTypesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyOperator(): AnyOperatorContext;
    operatorArgTypes(): OperatorArgTypesContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DoStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DO(): antlr.TerminalNode;
    stringConst(): StringConstContext[];
    stringConst(i: number): StringConstContext | null;
    KW_LANGUAGE(): antlr.TerminalNode[];
    KW_LANGUAGE(i: number): antlr.TerminalNode | null;
    nonReservedWordOrStringConst(): NonReservedWordOrStringConstContext[];
    nonReservedWordOrStringConst(i: number): NonReservedWordOrStringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateCastStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_CAST(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    KW_AS(): antlr.TerminalNode[];
    KW_AS(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    KW_WITHOUT(): antlr.TerminalNode | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_INOUT(): antlr.TerminalNode | null;
    KW_ASSIGNMENT(): antlr.TerminalNode | null;
    KW_IMPLICIT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IfExistsContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IF(): antlr.TerminalNode;
    KW_EXISTS(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateTransformStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_TRANSFORM(): antlr.TerminalNode;
    KW_FOR(): antlr.TerminalNode;
    typename(): TypenameContext;
    KW_LANGUAGE(): antlr.TerminalNode;
    colId(): ColIdContext;
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    KW_FROM(): antlr.TerminalNode | null;
    sqlWithFunction(): SqlWithFunctionContext[];
    sqlWithFunction(i: number): SqlWithFunctionContext | null;
    KW_TO(): antlr.TerminalNode | null;
    orReplaceOpt(): OrReplaceOptContext | null;
    COMMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SqlWithFunctionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SQL(): antlr.TerminalNode;
    KW_WITH(): antlr.TerminalNode;
    KW_FUNCTION(): antlr.TerminalNode;
    functionWithArgTypes(): FunctionWithArgTypesContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ReindexStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_REINDEX(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode | null;
    KW_VERBOSE(): antlr.TerminalNode[];
    KW_VERBOSE(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_INDEX(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_TABLE(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    KW_SYSTEM(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseName(): DatabaseNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTblSpcStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    optTableSpace(): OptTableSpaceContext;
    relOptions(): RelOptionsContext;
    KW_SET(): antlr.TerminalNode | null;
    KW_RESET(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RenameStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_RENAME(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseName(): DatabaseNameContext | null;
    databaseNameCreate(): DatabaseNameCreateContext | null;
    anyName(): AnyNameContext | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    functionNameCreate(): FunctionNameCreateContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    procedureNameCreate(): ProcedureNameCreateContext | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    schemaNameCreate(): SchemaNameCreateContext | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_INDEX(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    viewNameCreate(): ViewNameCreateContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    relationExpr(): RelationExprContext | null;
    tableNameCreate(): TableNameCreateContext | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    columnNameCreate(): ColumnNameCreateContext | null;
    KW_COLUMN(): antlr.TerminalNode | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    KW_RULE(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_POLICY(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_SUBSCRIPTION(): antlr.TerminalNode | null;
    KW_EVENT(): antlr.TerminalNode | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext[];
    roleSpec(i: number): RoleSpecContext | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    optTableSpace(): OptTableSpaceContext | null;
    tableSpaceName(): TableSpaceNameContext | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    KW_ATTRIBUTE(): antlr.TerminalNode | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterObjectDependsStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_DEPENDS(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode[];
    KW_ON(i: number): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterObjectSchemaStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_SET(): antlr.TerminalNode;
    KW_SCHEMA(): antlr.TerminalNode;
    schemaName(): SchemaNameContext;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    operatorWithArgTypes(): OperatorWithArgTypesContext | null;
    anyName(): AnyNameContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    KW_VIEW(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    KW_TABLE(): antlr.TerminalNode | null;
    relationExpr(): RelationExprContext | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterOperatorStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode;
    operatorWithArgTypes(): OperatorWithArgTypesContext;
    KW_SET(): antlr.TerminalNode;
    operatorDefList(): OperatorDefListContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OperatorDefListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    operatorDefElem(): OperatorDefElemContext[];
    operatorDefElem(i: number): OperatorDefElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OperatorDefElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colLabel(): ColLabelContext;
    EQUAL(): antlr.TerminalNode;
    KW_NONE(): antlr.TerminalNode | null;
    funcType(): FuncTypeContext | null;
    reservedKeyword(): ReservedKeywordContext | null;
    qualAllOp(): QualAllOpContext | null;
    numericOnly(): NumericOnlyContext | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterTypeStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_TYPE(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    KW_SET(): antlr.TerminalNode;
    operatorDefList(): OperatorDefListContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterOwnerStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_OPERATOR(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    KW_OWNER(): antlr.TerminalNode;
    KW_TO(): antlr.TerminalNode;
    roleSpec(): RoleSpecContext;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    aggregateWithArgTypes(): AggregateWithArgTypesContext | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    databaseName(): DatabaseNameContext | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    functionWithArgTypes(): FunctionWithArgTypesContext | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_LARGE(): antlr.TerminalNode | null;
    KW_OBJECT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    operatorWithArgTypes(): OperatorWithArgTypesContext | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    procedureWithArgTypes(): ProcedureWithArgTypesContext | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    routineWithArgTypes(): RoutineWithArgTypesContext | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    optTableSpace(): OptTableSpaceContext | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    KW_SUBSCRIPTION(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_EVENT(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreatePublicationStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_PUBLICATION(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_FOR(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    relationExprList(): RelationExprListContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_TABLES(): antlr.TerminalNode | null;
    optDefinition(): OptDefinitionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterPublicationStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_PUBLICATION(): antlr.TerminalNode;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    publicationRelationExpr(): PublicationRelationExprContext[];
    publicationRelationExpr(i: number): PublicationRelationExprContext | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    KW_OWNER(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    definition(): DefinitionContext | null;
    KW_RENAME(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateSubscriptionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_SUBSCRIPTION(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_CONNECTION(): antlr.TerminalNode;
    stringConst(): StringConstContext;
    KW_PUBLICATION(): antlr.TerminalNode;
    colLabel(): ColLabelContext[];
    colLabel(i: number): ColLabelContext | null;
    optDefinition(): OptDefinitionContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterSubscriptionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_SUBSCRIPTION(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_SET(): antlr.TerminalNode | null;
    definition(): DefinitionContext | null;
    KW_CONNECTION(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    KW_REFRESH(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    optDefinition(): OptDefinitionContext | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext[];
    colLabel(i: number): ColLabelContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_ENABLE(): antlr.TerminalNode | null;
    KW_DISABLE(): antlr.TerminalNode | null;
    KW_SKIP(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    oldAggregateElem(): OldAggregateElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_OWNER(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    roleSpec(): RoleSpecContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RuleStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_RULE(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_AS(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode;
    KW_TO(): antlr.TerminalNode;
    qualifiedName(): QualifiedNameContext;
    KW_DO(): antlr.TerminalNode;
    KW_SELECT(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_INSERT(): antlr.TerminalNode | null;
    KW_NOTHING(): antlr.TerminalNode | null;
    ruleActionStmt(): RuleActionStmtContext[];
    ruleActionStmt(i: number): RuleActionStmtContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    orReplaceOpt(): OrReplaceOptContext | null;
    whereClause(): WhereClauseContext | null;
    KW_INSTEAD(): antlr.TerminalNode | null;
    KW_ALSO(): antlr.TerminalNode | null;
    SEMI(): antlr.TerminalNode[];
    SEMI(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RuleActionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    selectStmt(): SelectStmtContext | null;
    insertStmt(): InsertStmtContext | null;
    updateStmt(): UpdateStmtContext | null;
    deleteStmt(): DeleteStmtContext | null;
    notifyStmt(): NotifyStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NotifyStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NOTIFY(): antlr.TerminalNode;
    colId(): ColIdContext;
    notifyPayload(): NotifyPayloadContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NotifyPayloadContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    COMMA(): antlr.TerminalNode;
    stringConst(): StringConstContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ListenStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_LISTEN(): antlr.TerminalNode;
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class UnListenStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_UNLISTEN(): antlr.TerminalNode;
    colId(): ColIdContext | null;
    STAR(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TransactionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BEGIN(): antlr.TerminalNode | null;
    optTransaction(): OptTransactionContext | null;
    transactionModeList(): TransactionModeListContext | null;
    KW_START(): antlr.TerminalNode | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    KW_SAVEPOINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_RELEASE(): antlr.TerminalNode | null;
    KW_PREPARE(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    KW_PREPARED(): antlr.TerminalNode | null;
    KW_COMMIT(): antlr.TerminalNode | null;
    KW_ROLLBACK(): antlr.TerminalNode | null;
    KW_ABORT(): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode | null;
    KW_AND(): antlr.TerminalNode | null;
    KW_CHAIN(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptTransactionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WORK(): antlr.TerminalNode | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TransactionModeItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ISOLATION(): antlr.TerminalNode | null;
    KW_LEVEL(): antlr.TerminalNode | null;
    isoLevel(): IsoLevelContext | null;
    KW_READ(): antlr.TerminalNode | null;
    KW_ONLY(): antlr.TerminalNode | null;
    KW_WRITE(): antlr.TerminalNode | null;
    KW_DEFERRABLE(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TransactionModeListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    transactionModeItem(): TransactionModeItemContext[];
    transactionModeItem(i: number): TransactionModeItemContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ViewStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ViewStmtContext): void;
}
export declare class CreateViewContext extends ViewStmtContext {
    constructor(ctx: ViewStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_AS(): antlr.TerminalNode;
    selectStmt(): SelectStmtContext;
    KW_VIEW(): antlr.TerminalNode | null;
    viewNameCreate(): ViewNameCreateContext | null;
    KW_RECURSIVE(): antlr.TerminalNode | null;
    optColumnList(): OptColumnListContext | null;
    KW_OR(): antlr.TerminalNode | null;
    KW_REPLACE(): antlr.TerminalNode | null;
    optTemp(): OptTempContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_CHECK(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    columnListCreate(): ColumnListCreateContext | null;
    optRelOptions(): OptRelOptionsContext | null;
    KW_CASCADED(): antlr.TerminalNode | null;
    KW_LOCAL(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LoadStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_LOAD(): antlr.TerminalNode;
    stringConst(): StringConstContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateDbStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: CreateDbStmtContext): void;
}
export declare class CreateDatabaseContext extends CreateDbStmtContext {
    constructor(ctx: CreateDbStmtContext);
    KW_CREATE(): antlr.TerminalNode;
    KW_DATABASE(): antlr.TerminalNode;
    databaseNameCreate(): DatabaseNameCreateContext;
    KW_WITH(): antlr.TerminalNode | null;
    createDbOptItem(): CreateDbOptItemContext[];
    createDbOptItem(i: number): CreateDbOptItemContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateDbOptItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CONNECTION(): antlr.TerminalNode | null;
    KW_LIMIT(): antlr.TerminalNode | null;
    KW_ENCODING(): antlr.TerminalNode | null;
    KW_LOCATION(): antlr.TerminalNode | null;
    KW_OWNER(): antlr.TerminalNode | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    identifier(): IdentifierContext | null;
    signedConst(): SignedConstContext | null;
    booleanOrString(): BooleanOrStringContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterDatabaseStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_DATABASE(): antlr.TerminalNode;
    databaseName(): DatabaseNameContext;
    KW_SET(): antlr.TerminalNode | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    tableSpaceName(): TableSpaceNameContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    createDbOptItem(): CreateDbOptItemContext[];
    createDbOptItem(i: number): CreateDbOptItemContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterDatabaseSetStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_DATABASE(): antlr.TerminalNode;
    databaseName(): DatabaseNameContext;
    setOrResetClause(): SetOrResetClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterCollationStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_COLLATION(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    KW_REFRESH(): antlr.TerminalNode;
    KW_VERSION(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterSystemStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_SYSTEM(): antlr.TerminalNode;
    genericSet(): GenericSetContext;
    KW_SET(): antlr.TerminalNode | null;
    KW_RESET(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateDomainStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_DOMAIN(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    typename(): TypenameContext;
    KW_AS(): antlr.TerminalNode | null;
    colConstraint(): ColConstraintContext[];
    colConstraint(i: number): ColConstraintContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterDomainStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_DOMAIN(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    alterColumnDefault(): AlterColumnDefaultContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_ADD(): antlr.TerminalNode | null;
    constraintElem(): ConstraintElemContext | null;
    KW_DROP(): antlr.TerminalNode | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_VALIDATE(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    optDropBehavior(): OptDropBehaviorContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterSearchDictionaryStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode;
    KW_TEXT(): antlr.TerminalNode;
    KW_SEARCH(): antlr.TerminalNode;
    KW_DICTIONARY(): antlr.TerminalNode;
    anyName(): AnyNameContext;
    definition(): DefinitionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AlterSearchConfigurationStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALTER(): antlr.TerminalNode[];
    KW_ALTER(i: number): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode;
    KW_SEARCH(): antlr.TerminalNode;
    KW_CONFIGURATION(): antlr.TerminalNode;
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    KW_MAPPING(): antlr.TerminalNode;
    KW_FOR(): antlr.TerminalNode | null;
    nameList(): NameListContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    anyNameList(): AnyNameListContext | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_REPLACE(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    ifExists(): IfExistsContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CreateConversionStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CREATE(): antlr.TerminalNode;
    KW_CONVERSION(): antlr.TerminalNode;
    anyName(): AnyNameContext[];
    anyName(i: number): AnyNameContext | null;
    KW_FOR(): antlr.TerminalNode;
    stringConst(): StringConstContext[];
    stringConst(i: number): StringConstContext | null;
    KW_TO(): antlr.TerminalNode;
    KW_FROM(): antlr.TerminalNode;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ClusterStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CLUSTER(): antlr.TerminalNode;
    optVerbose(): OptVerboseContext[];
    optVerbose(i: number): OptVerboseContext | null;
    tableName(): TableNameContext | null;
    tableAccessMethodClause(): TableAccessMethodClauseContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VacuumStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VACUUM(): antlr.TerminalNode;
    vacuumRelationList(): VacuumRelationListContext | null;
    explainOptionList(): ExplainOptionListContext | null;
    KW_FULL(): antlr.TerminalNode | null;
    KW_FREEZE(): antlr.TerminalNode | null;
    optVerbose(): OptVerboseContext | null;
    analyzeKeyword(): AnalyzeKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnalyzeStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    analyzeKeyword(): AnalyzeKeywordContext;
    OPEN_PAREN(): antlr.TerminalNode | null;
    analyzeOptionElem(): AnalyzeOptionElemContext[];
    analyzeOptionElem(i: number): AnalyzeOptionElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    vacuumRelationList(): VacuumRelationListContext | null;
    optVerbose(): OptVerboseContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnalyzeKeywordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ANALYZE(): antlr.TerminalNode | null;
    KW_ANALYSE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VacAnalyzeOptionElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    nonReservedWord(): NonReservedWordContext | null;
    analyzeKeyword(): AnalyzeKeywordContext | null;
    booleanOrString(): BooleanOrStringContext | null;
    numericOnly(): NumericOnlyContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnalyzeOptionElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SKIP_LOCKED(): antlr.TerminalNode | null;
    KW_VERBOSE(): antlr.TerminalNode | null;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_TRUE(): antlr.TerminalNode | null;
    KW_BUFFER_USAGE_LIMIT(): antlr.TerminalNode | null;
    numericOnly(): NumericOnlyContext | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptVerboseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VERBOSE(): antlr.TerminalNode;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_TRUE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VacuumRelationContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableName(): TableNameContext;
    optColumnList(): OptColumnListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class VacuumRelationListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    vacuumRelation(): VacuumRelationContext[];
    vacuumRelation(i: number): VacuumRelationContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExplainStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_EXPLAIN(): antlr.TerminalNode;
    explainableStmt(): ExplainableStmtContext;
    explainOptionList(): ExplainOptionListContext | null;
    KW_VERBOSE(): antlr.TerminalNode | null;
    analyzeKeyword(): AnalyzeKeywordContext | null;
    optVerbose(): OptVerboseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExplainableStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    selectStmt(): SelectStmtContext | null;
    insertStmt(): InsertStmtContext | null;
    updateStmt(): UpdateStmtContext | null;
    deleteStmt(): DeleteStmtContext | null;
    declareCursorStmt(): DeclareCursorStmtContext | null;
    createAsStmt(): CreateAsStmtContext | null;
    createMaterializedViewStmt(): CreateMaterializedViewStmtContext | null;
    refreshMaterializedViewStmt(): RefreshMaterializedViewStmtContext | null;
    executeStmt(): ExecuteStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExplainOptionListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    vacAnalyzeOptionElem(): VacAnalyzeOptionElemContext[];
    vacAnalyzeOptionElem(i: number): VacAnalyzeOptionElemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrepareStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PREPARE(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_AS(): antlr.TerminalNode;
    preParableStmt(): PreParableStmtContext;
    prepTypeClause(): PrepTypeClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrepTypeClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    typename(): TypenameContext[];
    typename(i: number): TypenameContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PreParableStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    selectStmt(): SelectStmtContext | null;
    insertStmt(): InsertStmtContext | null;
    updateStmt(): UpdateStmtContext | null;
    deleteStmt(): DeleteStmtContext | null;
    mergeStmt(): MergeStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExecuteStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_EXECUTE(): antlr.TerminalNode;
    colId(): ColIdContext;
    executeParamClause(): ExecuteParamClauseContext | null;
    KW_CREATE(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    createAsTarget(): CreateAsTargetContext | null;
    KW_AS(): antlr.TerminalNode | null;
    optTemp(): OptTempContext | null;
    ifNotExists(): IfNotExistsContext | null;
    optWithData(): OptWithDataContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExecuteParamClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    exprList(): ExprListContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DealLocateStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DEALLOCATE(): antlr.TerminalNode;
    colId(): ColIdContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_PREPARE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InsertStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: InsertStmtContext): void;
}
export declare class InsertStatementContext extends InsertStmtContext {
    constructor(ctx: InsertStmtContext);
    KW_INSERT(): antlr.TerminalNode;
    KW_INTO(): antlr.TerminalNode;
    tableName(): TableNameContext;
    insertRest(): InsertRestContext;
    withClause(): WithClauseContext | null;
    KW_AS(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_ON(): antlr.TerminalNode[];
    KW_ON(i: number): antlr.TerminalNode | null;
    KW_CONFLICT(): antlr.TerminalNode | null;
    KW_DO(): antlr.TerminalNode | null;
    returningClause(): ReturningClauseContext | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    setClauseList(): SetClauseListContext | null;
    KW_NOTHING(): antlr.TerminalNode | null;
    indexParams(): IndexParamsContext | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    whereClause(): WhereClauseContext[];
    whereClause(i: number): WhereClauseContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InsertRestContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    defaultValuesOrValues(): DefaultValuesOrValuesContext | null;
    selectStmt(): SelectStmtContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    insertColumnList(): InsertColumnListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_OVERRIDING(): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_SYSTEM(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InsertColumnListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    insertColumnItem(): InsertColumnItemContext[];
    insertColumnItem(i: number): InsertColumnItemContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InsertColumnItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext;
    optIndirection(): OptIndirectionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ReturningClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_RETURNING(): antlr.TerminalNode;
    targetList(): TargetListContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DeleteStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DELETE(): antlr.TerminalNode;
    KW_FROM(): antlr.TerminalNode;
    relationExprOptAlias(): RelationExprOptAliasContext;
    withClause(): WithClauseContext | null;
    KW_USING(): antlr.TerminalNode | null;
    fromList(): FromListContext | null;
    whereOrCurrentClause(): WhereOrCurrentClauseContext | null;
    returningClause(): ReturningClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LockStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_LOCK(): antlr.TerminalNode;
    relationExprList(): RelationExprListContext;
    KW_TABLE(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_MODE(): antlr.TerminalNode | null;
    KW_NOWAIT(): antlr.TerminalNode | null;
    KW_SHARE(): antlr.TerminalNode | null;
    KW_EXCLUSIVE(): antlr.TerminalNode | null;
    KW_ACCESS(): antlr.TerminalNode | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class UpdateStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_UPDATE(): antlr.TerminalNode;
    relationExprOptAlias(): RelationExprOptAliasContext;
    KW_SET(): antlr.TerminalNode;
    setClauseList(): SetClauseListContext;
    withClause(): WithClauseContext | null;
    fromClause(): FromClauseContext | null;
    whereOrCurrentClause(): WhereOrCurrentClauseContext | null;
    returningClause(): ReturningClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetClauseListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    setClause(): SetClauseContext[];
    setClause(i: number): SetClauseContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    insertColumnItem(): InsertColumnItemContext | null;
    EQUAL(): antlr.TerminalNode;
    expression(): ExpressionContext | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    insertColumnList(): InsertColumnListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    selectClause(): SelectClauseContext | null;
    KW_ROW(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DeclareCursorStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DECLARE(): antlr.TerminalNode;
    colId(): ColIdContext;
    KW_CURSOR(): antlr.TerminalNode;
    KW_FOR(): antlr.TerminalNode;
    selectStmt(): SelectStmtContext;
    KW_HOLD(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_WITHOUT(): antlr.TerminalNode | null;
    KW_BINARY(): antlr.TerminalNode[];
    KW_BINARY(i: number): antlr.TerminalNode | null;
    KW_INSENSITIVE(): antlr.TerminalNode[];
    KW_INSENSITIVE(i: number): antlr.TerminalNode | null;
    KW_SCROLL(): antlr.TerminalNode[];
    KW_SCROLL(i: number): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode[];
    KW_NO(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: SelectStmtContext): void;
}
export declare class SelectStatementContext extends SelectStmtContext {
    constructor(ctx: SelectStmtContext);
    selectNoParens(): SelectNoParensContext | null;
    selectWithParens(): SelectWithParensContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectWithParensContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    selectNoParens(): SelectNoParensContext | null;
    selectWithParens(): SelectWithParensContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectNoParensContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    selectClause(): SelectClauseContext;
    withClause(): WithClauseContext | null;
    sortClause(): SortClauseContext | null;
    forLockingClause(): ForLockingClauseContext | null;
    selectLimit(): SelectLimitContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    simpleSelect(): SimpleSelectContext | null;
    selectWithParens(): SelectWithParensContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SimpleSelectContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SELECT(): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext | null;
    valuesClause(): ValuesClauseContext | null;
    KW_TABLE(): antlr.TerminalNode | null;
    relationExpr(): RelationExprContext | null;
    selectWithParens(): SelectWithParensContext[];
    selectWithParens(i: number): SelectWithParensContext | null;
    setOperatorWithAllOrDistinct(): SetOperatorWithAllOrDistinctContext[];
    setOperatorWithAllOrDistinct(i: number): SetOperatorWithAllOrDistinctContext | null;
    simpleSelect(): SimpleSelectContext[];
    simpleSelect(i: number): SimpleSelectContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    intoClause(): IntoClauseContext | null;
    distinctClause(): DistinctClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SetOperatorWithAllOrDistinctContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_UNION(): antlr.TerminalNode | null;
    KW_INTERSECT(): antlr.TerminalNode | null;
    KW_EXCEPT(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WithClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WITH(): antlr.TerminalNode;
    commonTableExpr(): CommonTableExprContext[];
    commonTableExpr(i: number): CommonTableExprContext | null;
    KW_RECURSIVE(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CommonTableExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    KW_AS(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    preParableStmt(): PreParableStmtContext;
    CLOSE_PAREN(): antlr.TerminalNode;
    optColumnList(): OptColumnListContext | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    searchClause(): SearchClauseContext | null;
    cycleClause(): CycleClauseContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SearchClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SEARCH(): antlr.TerminalNode;
    KW_FIRST(): antlr.TerminalNode;
    KW_BY(): antlr.TerminalNode;
    columnList(): ColumnListContext;
    KW_SET(): antlr.TerminalNode;
    columnName(): ColumnNameContext;
    KW_BREADTH(): antlr.TerminalNode | null;
    KW_DEPTH(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CycleClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CYCLE(): antlr.TerminalNode;
    columnList(): ColumnListContext;
    KW_SET(): antlr.TerminalNode;
    columnName(): ColumnNameContext[];
    columnName(i: number): ColumnNameContext | null;
    KW_USING(): antlr.TerminalNode;
    KW_TO(): antlr.TerminalNode | null;
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IntoClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INTO(): antlr.TerminalNode;
    optTempTableName(): OptTempTableNameContext | null;
    exprList(): ExprListContext | null;
    KW_STRICT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptTempTableNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableNameCreate(): TableNameCreateContext;
    KW_TEMPORARY(): antlr.TerminalNode | null;
    KW_TEMP(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    KW_LOCAL(): antlr.TerminalNode | null;
    KW_GLOBAL(): antlr.TerminalNode | null;
    KW_UNLOGGED(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DistinctClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DISTINCT(): antlr.TerminalNode;
    KW_ON(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SortClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ORDER(): antlr.TerminalNode;
    KW_BY(): antlr.TerminalNode;
    sortBy(): SortByContext[];
    sortBy(i: number): SortByContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SortByContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnExprNoParen(): ColumnExprNoParenContext;
    KW_USING(): antlr.TerminalNode | null;
    qualAllOp(): QualAllOpContext | null;
    KW_NULLS(): antlr.TerminalNode | null;
    KW_ASC(): antlr.TerminalNode | null;
    KW_DESC(): antlr.TerminalNode | null;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_LAST(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectLimitContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    offsetClause(): OffsetClauseContext | null;
    fetchClause(): FetchClauseContext | null;
    limitClause(): LimitClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LimitClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_LIMIT(): antlr.TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    KW_ALL(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FetchClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FETCH(): antlr.TerminalNode;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_NEXT(): antlr.TerminalNode | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_ONLY(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_TIES(): antlr.TerminalNode | null;
    selectFetchFirstValue(): SelectFetchFirstValueContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OffsetClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OFFSET(): antlr.TerminalNode;
    selectFetchFirstValue(): SelectFetchFirstValueContext | null;
    expression(): ExpressionContext | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SelectFetchFirstValueContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    Integral(): antlr.TerminalNode | null;
    Numeric(): antlr.TerminalNode | null;
    primaryExpression(): PrimaryExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GroupClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_GROUP(): antlr.TerminalNode;
    KW_BY(): antlr.TerminalNode;
    groupByList(): GroupByListContext;
    KW_ALL(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GroupByListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    groupByItem(): GroupByItemContext[];
    groupByItem(i: number): GroupByItemContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GroupByItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnExprNoParen(): ColumnExprNoParenContext[];
    columnExprNoParen(i: number): ColumnExprNoParenContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_CUBE(): antlr.TerminalNode | null;
    KW_ROLLUP(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_GROUPING(): antlr.TerminalNode | null;
    KW_SETS(): antlr.TerminalNode | null;
    groupByList(): GroupByListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ForLockingClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FOR(): antlr.TerminalNode[];
    KW_FOR(i: number): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode[];
    KW_UPDATE(i: number): antlr.TerminalNode | null;
    KW_SHARE(): antlr.TerminalNode[];
    KW_SHARE(i: number): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode[];
    KW_OF(i: number): antlr.TerminalNode | null;
    qualifiedNameList(): QualifiedNameListContext[];
    qualifiedNameList(i: number): QualifiedNameListContext | null;
    KW_NOWAIT(): antlr.TerminalNode[];
    KW_NOWAIT(i: number): antlr.TerminalNode | null;
    KW_SKIP(): antlr.TerminalNode[];
    KW_SKIP(i: number): antlr.TerminalNode | null;
    KW_LOCKED(): antlr.TerminalNode[];
    KW_LOCKED(i: number): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode[];
    KW_NO(i: number): antlr.TerminalNode | null;
    KW_KEY(): antlr.TerminalNode[];
    KW_KEY(i: number): antlr.TerminalNode | null;
    KW_READ(): antlr.TerminalNode | null;
    KW_ONLY(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ValuesClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VALUES(): antlr.TerminalNode;
    executeParamClause(): ExecuteParamClauseContext[];
    executeParamClause(i: number): ExecuteParamClauseContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FromClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FROM(): antlr.TerminalNode;
    fromList(): FromListContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FromListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableRef(): TableRefContext[];
    tableRef(i: number): TableRefContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableRefContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode | null;
    tableRef(): TableRefContext[];
    tableRef(i: number): TableRefContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_CROSS(): antlr.TerminalNode[];
    KW_CROSS(i: number): antlr.TerminalNode | null;
    KW_JOIN(): antlr.TerminalNode[];
    KW_JOIN(i: number): antlr.TerminalNode | null;
    KW_NATURAL(): antlr.TerminalNode[];
    KW_NATURAL(i: number): antlr.TerminalNode | null;
    joinQual(): JoinQualContext[];
    joinQual(i: number): JoinQualContext | null;
    relationExpr(): RelationExprContext | null;
    xmlTable(): XmlTableContext | null;
    funcTable(): FuncTableContext | null;
    selectWithParens(): SelectWithParensContext | null;
    aliasClause(): AliasClauseContext | null;
    tableSampleClause(): TableSampleClauseContext | null;
    KW_LATERAL(): antlr.TerminalNode | null;
    viewName(): ViewNameContext | null;
    joinType(): JoinTypeContext[];
    joinType(i: number): JoinTypeContext | null;
    funcAliasClause(): FuncAliasClauseContext | null;
    KW_ONLY(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    columnList(): ColumnListContext | null;
    whereClause(): WhereClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AliasClauseContext extends antlr.ParserRuleContext {
    _alias?: ColIdContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    KW_AS(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    nameList(): NameListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncAliasClauseContext extends antlr.ParserRuleContext {
    _alias?: ColIdContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    aliasClause(): AliasClauseContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    tableFuncElementList(): TableFuncElementListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class JoinTypeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FULL(): antlr.TerminalNode | null;
    KW_LEFT(): antlr.TerminalNode | null;
    KW_RIGHT(): antlr.TerminalNode | null;
    KW_INNER(): antlr.TerminalNode | null;
    KW_OUTER(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class JoinQualContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_USING(): antlr.TerminalNode | null;
    optColumnList(): OptColumnListContext | null;
    KW_ON(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RelationExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    truncateTable(): TruncateTableContext | null;
    KW_ONLY(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    KW_CURRENT_SCHEMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PublicationRelationExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLE(): antlr.TerminalNode | null;
    truncateTable(): TruncateTableContext | null;
    optColumnList(): OptColumnListContext | null;
    whereClause(): WhereClauseContext | null;
    KW_ONLY(): antlr.TerminalNode | null;
    tableName(): TableNameContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_TABLES(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    schemaName(): SchemaNameContext | null;
    KW_CURRENT_SCHEMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RelationExprListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    relationExpr(): RelationExprContext[];
    relationExpr(i: number): RelationExprContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RelationExprOptAliasContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    relationExpr(): RelationExprContext;
    colId(): ColIdContext | null;
    KW_AS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableSampleClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TABLESAMPLE(): antlr.TerminalNode;
    functionName(): FunctionNameContext;
    executeParamClause(): ExecuteParamClauseContext;
    KW_REPEATABLE(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncTableContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcExprWindowless(): FuncExprWindowlessContext | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_ORDINALITY(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    rowsFromItem(): RowsFromItemContext[];
    rowsFromItem(i: number): RowsFromItemContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RowsFromItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcExprWindowless(): FuncExprWindowlessContext;
    KW_AS(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    tableFuncElementList(): TableFuncElementListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WhereClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WHERE(): antlr.TerminalNode;
    columnExprNoParen(): ColumnExprNoParenContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WhereOrCurrentClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WHERE(): antlr.TerminalNode;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    expression(): ExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableFuncElementListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableFuncElement(): TableFuncElementContext[];
    tableFuncElement(i: number): TableFuncElementContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableFuncElementContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    typename(): TypenameContext;
    collateClause(): CollateClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlTableContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_XMLTABLE(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    primaryExpression(): PrimaryExpressionContext | null;
    xmlExistsArgument(): XmlExistsArgumentContext | null;
    KW_COLUMNS(): antlr.TerminalNode | null;
    xmlTableColumnEl(): XmlTableColumnElContext[];
    xmlTableColumnEl(i: number): XmlTableColumnElContext | null;
    KW_XMLNAMESPACES(): antlr.TerminalNode | null;
    xmlNamespaceEle(): XmlNamespaceEleContext[];
    xmlNamespaceEle(i: number): XmlNamespaceEleContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlTableColumnElContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    typename(): TypenameContext | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_ORDINALITY(): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    KW_NULL(): antlr.TerminalNode[];
    KW_NULL(i: number): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode[];
    KW_DEFAULT(i: number): antlr.TerminalNode | null;
    identifier(): IdentifierContext[];
    identifier(i: number): IdentifierContext | null;
    KW_NOT(): antlr.TerminalNode[];
    KW_NOT(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlNamespaceEleContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    primaryExpression(): PrimaryExpressionContext;
    KW_AS(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TypenameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    simpleTypeName(): SimpleTypeNameContext | null;
    KW_ARRAY(): antlr.TerminalNode | null;
    KW_SETOF(): antlr.TerminalNode | null;
    OPEN_BRACKET(): antlr.TerminalNode[];
    OPEN_BRACKET(i: number): antlr.TerminalNode | null;
    Integral(): antlr.TerminalNode[];
    Integral(i: number): antlr.TerminalNode | null;
    CLOSE_BRACKET(): antlr.TerminalNode[];
    CLOSE_BRACKET(i: number): antlr.TerminalNode | null;
    qualifiedName(): QualifiedNameContext | null;
    PERCENT(): antlr.TerminalNode | null;
    KW_ROWTYPE(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SimpleTypeNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typeFunctionName(): TypeFunctionNameContext | null;
    attrs(): AttrsContext | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    constTypeName(): ConstTypeNameContext | null;
    KW_INTERVAL(): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    optInterval(): OptIntervalContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConstTypeNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    numeric(): NumericContext | null;
    bit(): BitContext | null;
    character(): CharacterContext | null;
    constDatetime(): ConstDatetimeContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NumericContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INT(): antlr.TerminalNode | null;
    KW_INTEGER(): antlr.TerminalNode | null;
    KW_SMALLINT(): antlr.TerminalNode | null;
    KW_BIGINT(): antlr.TerminalNode | null;
    KW_REAL(): antlr.TerminalNode | null;
    KW_FLOAT(): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    KW_DOUBLE(): antlr.TerminalNode | null;
    KW_PRECISION(): antlr.TerminalNode | null;
    KW_DECIMAL(): antlr.TerminalNode | null;
    KW_DEC(): antlr.TerminalNode | null;
    KW_NUMERIC(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    KW_BOOLEAN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptFloatContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    Integral(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class BitContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BIT(): antlr.TerminalNode;
    KW_VARYING(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CharacterContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VARCHAR(): antlr.TerminalNode | null;
    KW_NATIONAL(): antlr.TerminalNode | null;
    KW_CHARACTER(): antlr.TerminalNode | null;
    KW_CHAR(): antlr.TerminalNode | null;
    KW_NCHAR(): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    KW_VARYING(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConstDatetimeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_TIMESTAMP(): antlr.TerminalNode | null;
    KW_TIME(): antlr.TerminalNode[];
    KW_TIME(i: number): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    KW_ZONE(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    KW_WITHOUT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptIntervalContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_MONTH(): antlr.TerminalNode | null;
    intervalSecond(): IntervalSecondContext | null;
    KW_YEAR(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_DAY(): antlr.TerminalNode | null;
    KW_HOUR(): antlr.TerminalNode | null;
    KW_MINUTE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IntervalSecondContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SECOND(): antlr.TerminalNode;
    optFloat(): OptFloatContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ComparisonOperatorContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    LT(): antlr.TerminalNode | null;
    GT(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    LESS_EQUALS(): antlr.TerminalNode | null;
    GREATER_EQUALS(): antlr.TerminalNode | null;
    NOT_EQUALS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExpressionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    booleanExpression(): BooleanExpressionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class BooleanExpressionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: BooleanExpressionContext): void;
}
export declare class LogicalNotContext extends BooleanExpressionContext {
    constructor(ctx: BooleanExpressionContext);
    KW_NOT(): antlr.TerminalNode;
    booleanExpression(): BooleanExpressionContext;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PredicatedContext extends BooleanExpressionContext {
    _valueExpression?: ValueExpressionContext;
    constructor(ctx: BooleanExpressionContext);
    valueExpression(): ValueExpressionContext;
    predicate(): PredicateContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LogicalBinaryContext extends BooleanExpressionContext {
    _left?: BooleanExpressionContext;
    _operator?: Token | null;
    _right?: BooleanExpressionContext;
    constructor(ctx: BooleanExpressionContext);
    booleanExpression(): BooleanExpressionContext[];
    booleanExpression(i: number): BooleanExpressionContext | null;
    KW_AND(): antlr.TerminalNode | null;
    KW_OR(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PredicateContext extends antlr.ParserRuleContext {
    value: antlr.ParserRuleContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number, value: antlr.ParserRuleContext);
    get ruleIndex(): number;
    copyFrom(ctx: PredicateContext): void;
}
export declare class ComparisonContext extends PredicateContext {
    _right?: ValueExpressionContext;
    constructor(ctx: PredicateContext);
    comparisonOperator(): ComparisonOperatorContext;
    valueExpression(): ValueExpressionContext;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LikeContext extends PredicateContext {
    _pattern?: ValueExpressionContext;
    _escape?: ValueExpressionContext;
    constructor(ctx: PredicateContext);
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext | null;
    KW_LIKE(): antlr.TerminalNode | null;
    KW_ILIKE(): antlr.TerminalNode | null;
    KW_SIMILAR(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_BETWEEN(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_ESCAPE(): antlr.TerminalNode | null;
    KW_SYMMETRIC(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InSubqueryContext extends PredicateContext {
    constructor(ctx: PredicateContext);
    KW_IN(): antlr.TerminalNode;
    selectWithParens(): SelectWithParensContext;
    KW_NOT(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DistinctFromContext extends PredicateContext {
    _right?: ValueExpressionContext;
    constructor(ctx: PredicateContext);
    KW_IS(): antlr.TerminalNode;
    KW_DISTINCT(): antlr.TerminalNode;
    KW_FROM(): antlr.TerminalNode;
    valueExpression(): ValueExpressionContext;
    KW_NOT(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class InListContext extends PredicateContext {
    constructor(ctx: PredicateContext);
    KW_IN(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode;
    KW_NOT(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NullPredicateContext extends PredicateContext {
    constructor(ctx: PredicateContext);
    KW_IS(): antlr.TerminalNode;
    KW_NULL(): antlr.TerminalNode;
    KW_NOT(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class BetweenContext extends PredicateContext {
    _lower?: ValueExpressionContext;
    _upper?: ValueExpressionContext;
    constructor(ctx: PredicateContext);
    KW_BETWEEN(): antlr.TerminalNode;
    KW_AND(): antlr.TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class QuantifiedComparisonContext extends PredicateContext {
    constructor(ctx: PredicateContext);
    comparisonOperator(): ComparisonOperatorContext;
    subqueryOperator(): SubqueryOperatorContext;
    subType(): SubTypeContext;
    selectWithParens(): SelectWithParensContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ValueExpressionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: ValueExpressionContext): void;
}
export declare class ValueExpressionDefaultContext extends ValueExpressionContext {
    constructor(ctx: ValueExpressionContext);
    primaryExpression(): PrimaryExpressionContext;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ConcatenationContext extends ValueExpressionContext {
    _left?: ValueExpressionContext;
    _right?: ValueExpressionContext;
    constructor(ctx: ValueExpressionContext);
    CARET(): antlr.TerminalNode;
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ArithmeticBinaryContext extends ValueExpressionContext {
    _left?: ValueExpressionContext;
    _operator?: Token | null;
    _right?: ValueExpressionContext;
    constructor(ctx: ValueExpressionContext);
    valueExpression(): ValueExpressionContext[];
    valueExpression(i: number): ValueExpressionContext | null;
    STAR(): antlr.TerminalNode | null;
    SLASH(): antlr.TerminalNode | null;
    PERCENT(): antlr.TerminalNode | null;
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ArithmeticUnaryContext extends ValueExpressionContext {
    _operator?: Token | null;
    constructor(ctx: ValueExpressionContext);
    valueExpression(): ValueExpressionContext;
    MINUS(): antlr.TerminalNode | null;
    PLUS(): antlr.TerminalNode | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AtTimeZoneContext extends ValueExpressionContext {
    constructor(ctx: ValueExpressionContext);
    valueExpression(): ValueExpressionContext;
    KW_AT(): antlr.TerminalNode;
    KW_TIME(): antlr.TerminalNode;
    KW_ZONE(): antlr.TerminalNode;
    expression(): ExpressionContext;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PrimaryExpressionContext extends antlr.ParserRuleContext {
    _a_expr_in_parens?: ExpressionContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    selectWithParens(): SelectWithParensContext | null;
    KW_EXISTS(): antlr.TerminalNode | null;
    KW_UNIQUE(): antlr.TerminalNode | null;
    KW_ARRAY(): antlr.TerminalNode | null;
    arrayExpr(): ArrayExprContext | null;
    PARAM(): antlr.TerminalNode | null;
    optIndirection(): OptIndirectionContext | null;
    KW_GROUPING(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    Integral(): antlr.TerminalNode | null;
    Numeric(): antlr.TerminalNode | null;
    BinaryStringConstant(): antlr.TerminalNode | null;
    HexadecimalStringConstant(): antlr.TerminalNode | null;
    functionName(): FunctionNameContext | null;
    stringConst(): StringConstContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    funcArgList(): FuncArgListContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    sortClause(): SortClauseContext | null;
    constTypeName(): ConstTypeNameContext | null;
    KW_INTERVAL(): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    optInterval(): OptIntervalContext | null;
    KW_TRUE(): antlr.TerminalNode | null;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode | null;
    PLSQLVARIABLENAME(): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    KW_CASE(): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode | null;
    when_clause(): When_clauseContext[];
    when_clause(i: number): When_clauseContext | null;
    KW_ELSE(): antlr.TerminalNode | null;
    func_expr(): Func_exprContext | null;
    indirection(): IndirectionContext | null;
    explicitRow(): ExplicitRowContext | null;
    COMMA(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    row(): RowContext[];
    row(i: number): RowContext | null;
    KW_OVERLAPS(): antlr.TerminalNode | null;
    columnNamePath(): ColumnNamePathContext | null;
    qualifiedName(): QualifiedNameContext | null;
    primaryExpression(): PrimaryExpressionContext[];
    primaryExpression(i: number): PrimaryExpressionContext | null;
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    qualOp(): QualOpContext | null;
    mathOp(): MathOpContext | null;
    TYPECAST(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    KW_IS(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    prepTypeClause(): PrepTypeClauseContext | null;
    KW_DOCUMENT(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncApplicationContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    functionName(): FunctionNameContext;
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    funcArgList(): FuncArgListContext | null;
    KW_VARIADIC(): antlr.TerminalNode | null;
    funcArgExpr(): FuncArgExprContext | null;
    STAR(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode | null;
    sortClause(): SortClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class Func_exprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcApplication(): FuncApplicationContext | null;
    KW_WITHIN(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    sortClause(): SortClauseContext | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    KW_FILTER(): antlr.TerminalNode | null;
    KW_WHERE(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_OVER(): antlr.TerminalNode | null;
    windowSpecification(): WindowSpecificationContext | null;
    colId(): ColIdContext | null;
    funcExprCommonSubExpr(): FuncExprCommonSubExprContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncExprWindowlessContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcApplication(): FuncApplicationContext | null;
    funcExprCommonSubExpr(): FuncExprCommonSubExprContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncExprCommonSubExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    KW_CURRENT_DATE(): antlr.TerminalNode | null;
    KW_CURRENT_TIME(): antlr.TerminalNode | null;
    KW_CURRENT_TIMESTAMP(): antlr.TerminalNode | null;
    KW_LOCALTIME(): antlr.TerminalNode | null;
    KW_LOCALTIMESTAMP(): antlr.TerminalNode | null;
    optFloat(): OptFloatContext | null;
    KW_CURRENT_ROLE(): antlr.TerminalNode | null;
    KW_CURRENT_USER(): antlr.TerminalNode | null;
    KW_SESSION_USER(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_CURRENT_CATALOG(): antlr.TerminalNode | null;
    KW_CURRENT_SCHEMA(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    KW_CAST(): antlr.TerminalNode | null;
    KW_TREAT(): antlr.TerminalNode | null;
    KW_EXTRACT(): antlr.TerminalNode | null;
    extractArg(): ExtractArgContext | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_NORMALIZE(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    unicodeNormalForm(): UnicodeNormalFormContext | null;
    KW_OVERLAY(): antlr.TerminalNode | null;
    KW_PLACING(): antlr.TerminalNode | null;
    KW_POSITION(): antlr.TerminalNode | null;
    primaryExpression(): PrimaryExpressionContext[];
    primaryExpression(i: number): PrimaryExpressionContext | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_SUBSTRING(): antlr.TerminalNode | null;
    substrList(): SubstrListContext | null;
    KW_TRIM(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    KW_BOTH(): antlr.TerminalNode | null;
    KW_LEADING(): antlr.TerminalNode | null;
    KW_TRAILING(): antlr.TerminalNode | null;
    KW_NULLIF(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    KW_COALESCE(): antlr.TerminalNode | null;
    KW_GREATEST(): antlr.TerminalNode | null;
    KW_LEAST(): antlr.TerminalNode | null;
    KW_XMLCONCAT(): antlr.TerminalNode | null;
    KW_XMLELEMENT(): antlr.TerminalNode | null;
    KW_NAME(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    KW_XMLATTRIBUTES(): antlr.TerminalNode | null;
    xmlAttributeList(): XmlAttributeListContext | null;
    KW_XMLEXISTS(): antlr.TerminalNode | null;
    xmlExistsArgument(): XmlExistsArgumentContext | null;
    KW_XMLFOREST(): antlr.TerminalNode | null;
    KW_XMLPARSE(): antlr.TerminalNode | null;
    documentOrContent(): DocumentOrContentContext | null;
    KW_WHITESPACE(): antlr.TerminalNode | null;
    KW_PRESERVE(): antlr.TerminalNode | null;
    KW_STRIP(): antlr.TerminalNode | null;
    KW_XMLPI(): antlr.TerminalNode | null;
    KW_XMLROOT(): antlr.TerminalNode | null;
    KW_XML(): antlr.TerminalNode | null;
    KW_VERSION(): antlr.TerminalNode | null;
    KW_STANDALONE(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode[];
    KW_NO(i: number): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode[];
    KW_VALUE(i: number): antlr.TerminalNode | null;
    KW_YES(): antlr.TerminalNode | null;
    KW_XMLSERIALIZE(): antlr.TerminalNode | null;
    simpleTypeName(): SimpleTypeNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlAttributeListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    xmlAttributeEl(): XmlAttributeElContext[];
    xmlAttributeEl(i: number): XmlAttributeElContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlAttributeElContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    expression(): ExpressionContext;
    KW_AS(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DocumentOrContentContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_DOCUMENT(): antlr.TerminalNode | null;
    KW_CONTENT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlExistsArgumentContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PASSING(): antlr.TerminalNode;
    primaryExpression(): PrimaryExpressionContext;
    xmlPassingMech(): XmlPassingMechContext[];
    xmlPassingMech(i: number): XmlPassingMechContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class XmlPassingMechContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BY(): antlr.TerminalNode;
    KW_REF(): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WindowClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WINDOW(): antlr.TerminalNode;
    windowDefinition(): WindowDefinitionContext[];
    windowDefinition(i: number): WindowDefinitionContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class HavingClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_HAVING(): antlr.TerminalNode;
    expression(): ExpressionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WindowDefinitionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    KW_AS(): antlr.TerminalNode;
    windowSpecification(): WindowSpecificationContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class Over_clauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OVER(): antlr.TerminalNode;
    windowSpecification(): WindowSpecificationContext | null;
    colId(): ColIdContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class WindowSpecificationContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    colId(): ColIdContext | null;
    KW_PARTITION(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    sortClause(): SortClauseContext | null;
    optFrameClause(): OptFrameClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptFrameClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_RANGE(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_GROUPS(): antlr.TerminalNode | null;
    frameBound(): FrameBoundContext[];
    frameBound(i: number): FrameBoundContext | null;
    KW_EXCLUDE(): antlr.TerminalNode | null;
    KW_BETWEEN(): antlr.TerminalNode | null;
    KW_AND(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    KW_TIES(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_OTHERS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FrameBoundContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PRECEDING(): antlr.TerminalNode | null;
    KW_FOLLOWING(): antlr.TerminalNode | null;
    KW_UNBOUNDED(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_ROW(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RowContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    explicitRow(): ExplicitRowContext | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    COMMA(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExplicitRowContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ROW(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode;
    CLOSE_PAREN(): antlr.TerminalNode;
    exprList(): ExprListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SubTypeContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ANY(): antlr.TerminalNode | null;
    KW_SOME(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AllOpContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Operator(): antlr.TerminalNode | null;
    mathOp(): MathOpContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class MathOpContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    SLASH(): antlr.TerminalNode | null;
    PERCENT(): antlr.TerminalNode | null;
    CARET(): antlr.TerminalNode | null;
    LT(): antlr.TerminalNode | null;
    GT(): antlr.TerminalNode | null;
    EQUAL(): antlr.TerminalNode | null;
    LESS_EQUALS(): antlr.TerminalNode | null;
    GREATER_EQUALS(): antlr.TerminalNode | null;
    NOT_EQUALS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class QualOpContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Operator(): antlr.TerminalNode | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    anyOperator(): AnyOperatorContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class QualAllOpContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    allOp(): AllOpContext | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    anyOperator(): AnyOperatorContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SubqueryOperatorContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualAllOp(): QualAllOpContext | null;
    KW_LIKE(): antlr.TerminalNode | null;
    KW_ILIKE(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExprListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_PAREN(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    columnName(): ColumnNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnExprNoParenContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    expression(): ExpressionContext | null;
    columnName(): ColumnNameContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    funcArgExpr(): FuncArgExprContext[];
    funcArgExpr(i: number): FuncArgExprContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FuncArgExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    columnName(): ColumnNameContext | null;
    expression(): ExpressionContext | null;
    typeFunctionName(): TypeFunctionNameContext | null;
    COLON_EQUALS(): antlr.TerminalNode | null;
    EQUALS_GREATER(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ArrayExprContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    OPEN_BRACKET(): antlr.TerminalNode;
    CLOSE_BRACKET(): antlr.TerminalNode;
    exprList(): ExprListContext | null;
    arrayExpr(): ArrayExprContext[];
    arrayExpr(i: number): ArrayExprContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExtractArgContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext | null;
    KW_YEAR(): antlr.TerminalNode | null;
    KW_MONTH(): antlr.TerminalNode | null;
    KW_DAY(): antlr.TerminalNode | null;
    KW_HOUR(): antlr.TerminalNode | null;
    KW_MINUTE(): antlr.TerminalNode | null;
    KW_SECOND(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class UnicodeNormalFormContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NFC(): antlr.TerminalNode | null;
    KW_NFD(): antlr.TerminalNode | null;
    KW_NFKC(): antlr.TerminalNode | null;
    KW_NFKD(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SubstrListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_SIMILAR(): antlr.TerminalNode | null;
    KW_ESCAPE(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class When_clauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WHEN(): antlr.TerminalNode;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    KW_THEN(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndirectionElContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    DOT(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    STAR(): antlr.TerminalNode | null;
    OPEN_BRACKET(): antlr.TerminalNode | null;
    CLOSE_BRACKET(): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    COLON(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IndirectionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    indirectionEl(): IndirectionElContext[];
    indirectionEl(i: number): IndirectionElContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptIndirectionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    indirectionEl(): IndirectionElContext[];
    indirectionEl(i: number): IndirectionElContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TargetListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    targetEl(): TargetElContext[];
    targetEl(i: number): TargetElContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TargetElContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    get ruleIndex(): number;
    copyFrom(ctx: TargetElContext): void;
}
export declare class Target_labelContext extends TargetElContext {
    constructor(ctx: TargetElContext);
    columnExprNoParen(): ColumnExprNoParenContext;
    KW_AS(): antlr.TerminalNode | null;
    colLabel(): ColLabelContext | null;
    identifier(): IdentifierContext | null;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class Target_starContext extends TargetElContext {
    constructor(ctx: TargetElContext);
    STAR(): antlr.TerminalNode;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class QualifiedNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext[];
    qualifiedName(i: number): QualifiedNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableName(): TableNameContext[];
    tableName(i: number): TableNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SchemaNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    schemaName(): SchemaNameContext[];
    schemaName(i: number): SchemaNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DatabaseNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    databaseName(): DatabaseNameContext[];
    databaseName(i: number): DatabaseNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableSpaceNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableSpaceNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ViewNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    qualifiedName(): QualifiedNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ViewNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class QualifiedNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    indirection(): IndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TableSpaceNameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableSpaceName(): TableSpaceNameContext[];
    tableSpaceName(i: number): TableSpaceNameContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NameListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext[];
    colId(i: number): ColIdContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DatabaseNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DatabaseNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SchemaNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoutineNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoutineNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcedureNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typeFunctionName(): TypeFunctionNameContext | null;
    colId(): ColIdContext | null;
    indirection(): IndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcedureNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typeFunctionName(): TypeFunctionNameContext | null;
    colId(): ColIdContext | null;
    indirection(): IndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext | null;
    optIndirection(): OptIndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnNamePathContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    optIndirection(): OptIndirectionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColumnNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionNameCreateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typeFunctionName(): TypeFunctionNameContext | null;
    colId(): ColIdContext | null;
    indirection(): IndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class FunctionNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    typeFunctionName(): TypeFunctionNameContext | null;
    colId(): ColIdContext | null;
    indirection(): IndirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StringConstContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anysconst(): AnysconstContext[];
    anysconst(i: number): AnysconstContext | null;
    KW_UESCAPE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnysconstContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    StringConstant(): antlr.TerminalNode | null;
    UnicodeEscapeStringConstant(): antlr.TerminalNode | null;
    BeginDollarStringConstant(): antlr.TerminalNode | null;
    EndDollarStringConstant(): antlr.TerminalNode | null;
    DollarText(): antlr.TerminalNode[];
    DollarText(i: number): antlr.TerminalNode | null;
    EscapeStringConstant(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SignedConstContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Integral(): antlr.TerminalNode;
    PLUS(): antlr.TerminalNode | null;
    MINUS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoleSpecContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    nonReservedWord(): NonReservedWordContext | null;
    KW_CURRENT_USER(): antlr.TerminalNode | null;
    KW_CURRENT_ROLE(): antlr.TerminalNode | null;
    KW_SESSION_USER(): antlr.TerminalNode | null;
    KW_PUBLIC(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class RoleListContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    roleSpec(): RoleSpecContext[];
    roleSpec(i: number): RoleSpecContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColIdContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext | null;
    colNameKeyword(): ColNameKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TypeFunctionNameContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class NonReservedWordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext | null;
    colNameKeyword(): ColNameKeywordContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColLabelContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext | null;
    colNameKeyword(): ColNameKeywordContext | null;
    typeFuncNameKeyword(): TypeFuncNameKeywordContext | null;
    reservedKeyword(): ReservedKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class IdentifierContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    Identifier(): antlr.TerminalNode | null;
    KW_UESCAPE(): antlr.TerminalNode | null;
    anysconst(): AnysconstContext | null;
    stringConst(): StringConstContext | null;
    QuotedIdentifier(): antlr.TerminalNode | null;
    UnicodeQuotedIdentifier(): antlr.TerminalNode | null;
    PLSQLVARIABLENAME(): antlr.TerminalNode | null;
    PLSQLIDENTIFIER(): antlr.TerminalNode | null;
    unreservedKeyword(): UnreservedKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class UnreservedKeywordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ABORT(): antlr.TerminalNode | null;
    KW_ABSOLUTE(): antlr.TerminalNode | null;
    KW_ACCESS(): antlr.TerminalNode | null;
    KW_ACTION(): antlr.TerminalNode | null;
    KW_ADD(): antlr.TerminalNode | null;
    KW_ADMIN(): antlr.TerminalNode | null;
    KW_AFTER(): antlr.TerminalNode | null;
    KW_AGGREGATE(): antlr.TerminalNode | null;
    KW_ALSO(): antlr.TerminalNode | null;
    KW_ALTER(): antlr.TerminalNode | null;
    KW_ALWAYS(): antlr.TerminalNode | null;
    KW_ASSERTION(): antlr.TerminalNode | null;
    KW_ASSIGNMENT(): antlr.TerminalNode | null;
    KW_AT(): antlr.TerminalNode | null;
    KW_ATTACH(): antlr.TerminalNode | null;
    KW_ATTRIBUTE(): antlr.TerminalNode | null;
    KW_BACKWARD(): antlr.TerminalNode | null;
    KW_BEFORE(): antlr.TerminalNode | null;
    KW_BEGIN(): antlr.TerminalNode | null;
    KW_BUFFER_USAGE_LIMIT(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    KW_CACHE(): antlr.TerminalNode | null;
    KW_CALL(): antlr.TerminalNode | null;
    KW_CALLED(): antlr.TerminalNode | null;
    KW_CASCADE(): antlr.TerminalNode | null;
    KW_CASCADED(): antlr.TerminalNode | null;
    KW_CATALOG(): antlr.TerminalNode | null;
    KW_CHAIN(): antlr.TerminalNode | null;
    KW_CHARACTERISTICS(): antlr.TerminalNode | null;
    KW_CHECKPOINT(): antlr.TerminalNode | null;
    KW_CLASS(): antlr.TerminalNode | null;
    KW_CLOSE(): antlr.TerminalNode | null;
    KW_CLUSTER(): antlr.TerminalNode | null;
    KW_COLUMNS(): antlr.TerminalNode | null;
    KW_COMMENT(): antlr.TerminalNode | null;
    KW_COMMENTS(): antlr.TerminalNode | null;
    KW_COMMIT(): antlr.TerminalNode | null;
    KW_COMMITTED(): antlr.TerminalNode | null;
    KW_CONFIGURATION(): antlr.TerminalNode | null;
    KW_CONFLICT(): antlr.TerminalNode | null;
    KW_CONNECTION(): antlr.TerminalNode | null;
    KW_CONSTRAINTS(): antlr.TerminalNode | null;
    KW_CONTENT(): antlr.TerminalNode | null;
    KW_CONTINUE(): antlr.TerminalNode | null;
    KW_CONVERSION(): antlr.TerminalNode | null;
    KW_COPY(): antlr.TerminalNode | null;
    KW_COST(): antlr.TerminalNode | null;
    KW_CSV(): antlr.TerminalNode | null;
    KW_CUBE(): antlr.TerminalNode | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_CURSOR(): antlr.TerminalNode | null;
    KW_CYCLE(): antlr.TerminalNode | null;
    KW_DATA(): antlr.TerminalNode | null;
    KW_DATABASE(): antlr.TerminalNode | null;
    KW_DAY(): antlr.TerminalNode | null;
    KW_DEALLOCATE(): antlr.TerminalNode | null;
    KW_DECLARE(): antlr.TerminalNode | null;
    KW_DEFAULTS(): antlr.TerminalNode | null;
    KW_DEFERRED(): antlr.TerminalNode | null;
    KW_DEFINER(): antlr.TerminalNode | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_DELIMITER(): antlr.TerminalNode | null;
    KW_DELIMITERS(): antlr.TerminalNode | null;
    KW_DEPENDS(): antlr.TerminalNode | null;
    KW_DETACH(): antlr.TerminalNode | null;
    KW_DICTIONARY(): antlr.TerminalNode | null;
    KW_DISABLE(): antlr.TerminalNode | null;
    KW_DISCARD(): antlr.TerminalNode | null;
    KW_DOCUMENT(): antlr.TerminalNode | null;
    KW_DOMAIN(): antlr.TerminalNode | null;
    KW_DOUBLE(): antlr.TerminalNode | null;
    KW_DROP(): antlr.TerminalNode | null;
    KW_EACH(): antlr.TerminalNode | null;
    KW_ENABLE(): antlr.TerminalNode | null;
    KW_ENCODING(): antlr.TerminalNode | null;
    KW_ENCRYPTED(): antlr.TerminalNode | null;
    KW_ENUM(): antlr.TerminalNode | null;
    KW_ESCAPE(): antlr.TerminalNode | null;
    KW_EVENT(): antlr.TerminalNode | null;
    KW_EXCLUDE(): antlr.TerminalNode | null;
    KW_EXCLUDING(): antlr.TerminalNode | null;
    KW_EXCLUSIVE(): antlr.TerminalNode | null;
    KW_EXECUTE(): antlr.TerminalNode | null;
    KW_EXPLAIN(): antlr.TerminalNode | null;
    KW_EXPRESSION(): antlr.TerminalNode | null;
    KW_EXTENSION(): antlr.TerminalNode | null;
    KW_EXTERNAL(): antlr.TerminalNode | null;
    KW_FAMILY(): antlr.TerminalNode | null;
    KW_FILTER(): antlr.TerminalNode | null;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_FOLLOWING(): antlr.TerminalNode | null;
    KW_FORCE(): antlr.TerminalNode | null;
    KW_FORWARD(): antlr.TerminalNode | null;
    KW_FUNCTION(): antlr.TerminalNode | null;
    KW_FUNCTIONS(): antlr.TerminalNode | null;
    KW_GENERATED(): antlr.TerminalNode | null;
    KW_GLOBAL(): antlr.TerminalNode | null;
    KW_GRANTED(): antlr.TerminalNode | null;
    KW_GROUPS(): antlr.TerminalNode | null;
    KW_HANDLER(): antlr.TerminalNode | null;
    KW_HEADER(): antlr.TerminalNode | null;
    KW_HOLD(): antlr.TerminalNode | null;
    KW_HOUR(): antlr.TerminalNode | null;
    KW_IDENTITY(): antlr.TerminalNode | null;
    KW_IF(): antlr.TerminalNode | null;
    KW_IMMEDIATE(): antlr.TerminalNode | null;
    KW_IMMUTABLE(): antlr.TerminalNode | null;
    KW_IMPLICIT(): antlr.TerminalNode | null;
    KW_IMPORT(): antlr.TerminalNode | null;
    KW_INCLUDE(): antlr.TerminalNode | null;
    KW_INCLUDING(): antlr.TerminalNode | null;
    KW_INCREMENT(): antlr.TerminalNode | null;
    KW_INDEX(): antlr.TerminalNode | null;
    KW_INDEXES(): antlr.TerminalNode | null;
    KW_INHERIT(): antlr.TerminalNode | null;
    KW_INHERITS(): antlr.TerminalNode | null;
    KW_INLINE(): antlr.TerminalNode | null;
    KW_INPUT(): antlr.TerminalNode | null;
    KW_INSENSITIVE(): antlr.TerminalNode | null;
    KW_INSERT(): antlr.TerminalNode | null;
    KW_INSTEAD(): antlr.TerminalNode | null;
    KW_INVOKER(): antlr.TerminalNode | null;
    KW_ISOLATION(): antlr.TerminalNode | null;
    KW_KEY(): antlr.TerminalNode | null;
    KW_LABEL(): antlr.TerminalNode | null;
    KW_LANGUAGE(): antlr.TerminalNode | null;
    KW_LARGE(): antlr.TerminalNode | null;
    KW_LAST(): antlr.TerminalNode | null;
    KW_LEAKPROOF(): antlr.TerminalNode | null;
    KW_LEVEL(): antlr.TerminalNode | null;
    KW_LISTEN(): antlr.TerminalNode | null;
    KW_LOAD(): antlr.TerminalNode | null;
    KW_LOCAL(): antlr.TerminalNode | null;
    KW_LOCATION(): antlr.TerminalNode | null;
    KW_LOCK(): antlr.TerminalNode | null;
    KW_LOCKED(): antlr.TerminalNode | null;
    KW_LOGGED(): antlr.TerminalNode | null;
    KW_MAPPING(): antlr.TerminalNode | null;
    KW_MATCH(): antlr.TerminalNode | null;
    KW_MATERIALIZED(): antlr.TerminalNode | null;
    KW_MAXVALUE(): antlr.TerminalNode | null;
    KW_METHOD(): antlr.TerminalNode | null;
    KW_MINUTE(): antlr.TerminalNode | null;
    KW_MINVALUE(): antlr.TerminalNode | null;
    KW_MODE(): antlr.TerminalNode | null;
    KW_MONTH(): antlr.TerminalNode | null;
    KW_MOVE(): antlr.TerminalNode | null;
    KW_NAME(): antlr.TerminalNode | null;
    KW_NAMES(): antlr.TerminalNode | null;
    KW_NEW(): antlr.TerminalNode | null;
    KW_NEXT(): antlr.TerminalNode | null;
    KW_NFC(): antlr.TerminalNode | null;
    KW_NFD(): antlr.TerminalNode | null;
    KW_NFKC(): antlr.TerminalNode | null;
    KW_NFKD(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    KW_NORMALIZED(): antlr.TerminalNode | null;
    KW_NOTHING(): antlr.TerminalNode | null;
    KW_NOTIFY(): antlr.TerminalNode | null;
    KW_NOWAIT(): antlr.TerminalNode | null;
    KW_NULLS(): antlr.TerminalNode | null;
    KW_OBJECT(): antlr.TerminalNode | null;
    KW_OF(): antlr.TerminalNode | null;
    KW_OFF(): antlr.TerminalNode | null;
    KW_OIDS(): antlr.TerminalNode | null;
    KW_OLD(): antlr.TerminalNode | null;
    KW_OPERATOR(): antlr.TerminalNode | null;
    KW_OPTION(): antlr.TerminalNode | null;
    KW_OPTIONS(): antlr.TerminalNode | null;
    KW_ORDINALITY(): antlr.TerminalNode | null;
    KW_OTHERS(): antlr.TerminalNode | null;
    KW_OVER(): antlr.TerminalNode | null;
    KW_OVERRIDING(): antlr.TerminalNode | null;
    KW_OWNED(): antlr.TerminalNode | null;
    KW_OWNER(): antlr.TerminalNode | null;
    KW_PARALLEL(): antlr.TerminalNode | null;
    KW_PARSER(): antlr.TerminalNode | null;
    KW_PARTIAL(): antlr.TerminalNode | null;
    KW_PARTITION(): antlr.TerminalNode | null;
    KW_PASSING(): antlr.TerminalNode | null;
    KW_PASSWORD(): antlr.TerminalNode | null;
    KW_PLANS(): antlr.TerminalNode | null;
    KW_POLICY(): antlr.TerminalNode | null;
    KW_PRECEDING(): antlr.TerminalNode | null;
    KW_PREPARE(): antlr.TerminalNode | null;
    KW_PREPARED(): antlr.TerminalNode | null;
    KW_PRESERVE(): antlr.TerminalNode | null;
    KW_PRIOR(): antlr.TerminalNode | null;
    KW_PRIVILEGES(): antlr.TerminalNode | null;
    KW_PROCEDURAL(): antlr.TerminalNode | null;
    KW_PROCEDURE(): antlr.TerminalNode | null;
    KW_PROCEDURES(): antlr.TerminalNode | null;
    KW_PROGRAM(): antlr.TerminalNode | null;
    KW_PUBLICATION(): antlr.TerminalNode | null;
    KW_QUOTE(): antlr.TerminalNode | null;
    KW_RANGE(): antlr.TerminalNode | null;
    KW_READ(): antlr.TerminalNode | null;
    KW_REASSIGN(): antlr.TerminalNode | null;
    KW_RECHECK(): antlr.TerminalNode | null;
    KW_RECURSIVE(): antlr.TerminalNode | null;
    KW_REF(): antlr.TerminalNode | null;
    KW_REFERENCING(): antlr.TerminalNode | null;
    KW_REFRESH(): antlr.TerminalNode | null;
    KW_REINDEX(): antlr.TerminalNode | null;
    KW_RELATIVE(): antlr.TerminalNode | null;
    KW_RELEASE(): antlr.TerminalNode | null;
    KW_RENAME(): antlr.TerminalNode | null;
    KW_REPEATABLE(): antlr.TerminalNode | null;
    KW_REPLACE(): antlr.TerminalNode | null;
    KW_REPLICA(): antlr.TerminalNode | null;
    KW_RESET(): antlr.TerminalNode | null;
    KW_RESTART(): antlr.TerminalNode | null;
    KW_RESTRICT(): antlr.TerminalNode | null;
    KW_RETURNS(): antlr.TerminalNode | null;
    KW_REVOKE(): antlr.TerminalNode | null;
    KW_ROLE(): antlr.TerminalNode | null;
    KW_ROLLBACK(): antlr.TerminalNode | null;
    KW_ROLLUP(): antlr.TerminalNode | null;
    KW_ROUTINE(): antlr.TerminalNode | null;
    KW_ROUTINES(): antlr.TerminalNode | null;
    KW_ROWS(): antlr.TerminalNode | null;
    KW_RULE(): antlr.TerminalNode | null;
    KW_SAVEPOINT(): antlr.TerminalNode | null;
    KW_SCHEMA(): antlr.TerminalNode | null;
    KW_SCHEMAS(): antlr.TerminalNode | null;
    KW_SCROLL(): antlr.TerminalNode | null;
    KW_SEARCH(): antlr.TerminalNode | null;
    KW_SECOND(): antlr.TerminalNode | null;
    KW_SECURITY(): antlr.TerminalNode | null;
    KW_SEQUENCE(): antlr.TerminalNode | null;
    KW_SEQUENCES(): antlr.TerminalNode | null;
    KW_SERIALIZABLE(): antlr.TerminalNode | null;
    KW_SERVER(): antlr.TerminalNode | null;
    KW_SESSION(): antlr.TerminalNode | null;
    KW_SET(): antlr.TerminalNode | null;
    KW_SETS(): antlr.TerminalNode | null;
    KW_SHARE(): antlr.TerminalNode | null;
    KW_SHOW(): antlr.TerminalNode | null;
    KW_SIMPLE(): antlr.TerminalNode | null;
    KW_SKIP(): antlr.TerminalNode | null;
    KW_SKIP_LOCKED(): antlr.TerminalNode | null;
    KW_SNAPSHOT(): antlr.TerminalNode | null;
    KW_SQL(): antlr.TerminalNode | null;
    KW_STABLE(): antlr.TerminalNode | null;
    KW_STANDALONE(): antlr.TerminalNode | null;
    KW_START(): antlr.TerminalNode | null;
    KW_STATEMENT(): antlr.TerminalNode | null;
    KW_STATISTICS(): antlr.TerminalNode | null;
    KW_STDIN(): antlr.TerminalNode | null;
    KW_STDOUT(): antlr.TerminalNode | null;
    KW_STORAGE(): antlr.TerminalNode | null;
    KW_STORED(): antlr.TerminalNode | null;
    KW_STRICT(): antlr.TerminalNode | null;
    KW_STRIP(): antlr.TerminalNode | null;
    KW_SUBSCRIPTION(): antlr.TerminalNode | null;
    KW_SUPPORT(): antlr.TerminalNode | null;
    KW_SYSID(): antlr.TerminalNode | null;
    KW_SYSTEM(): antlr.TerminalNode | null;
    KW_TABLES(): antlr.TerminalNode | null;
    KW_TABLESPACE(): antlr.TerminalNode | null;
    KW_TEMP(): antlr.TerminalNode | null;
    KW_TEMPLATE(): antlr.TerminalNode | null;
    KW_TEMPORARY(): antlr.TerminalNode | null;
    KW_TEXT(): antlr.TerminalNode | null;
    KW_TIES(): antlr.TerminalNode | null;
    KW_TRANSACTION(): antlr.TerminalNode | null;
    KW_TRANSFORM(): antlr.TerminalNode | null;
    KW_TRIGGER(): antlr.TerminalNode | null;
    KW_TRUNCATE(): antlr.TerminalNode | null;
    KW_TRUSTED(): antlr.TerminalNode | null;
    KW_TYPE(): antlr.TerminalNode | null;
    KW_TYPES(): antlr.TerminalNode | null;
    KW_UESCAPE(): antlr.TerminalNode | null;
    KW_UNBOUNDED(): antlr.TerminalNode | null;
    KW_UNCOMMITTED(): antlr.TerminalNode | null;
    KW_UNENCRYPTED(): antlr.TerminalNode | null;
    KW_UNKNOWN(): antlr.TerminalNode | null;
    KW_UNLISTEN(): antlr.TerminalNode | null;
    KW_UNLOGGED(): antlr.TerminalNode | null;
    KW_UNTIL(): antlr.TerminalNode | null;
    KW_UPDATE(): antlr.TerminalNode | null;
    KW_VACUUM(): antlr.TerminalNode | null;
    KW_VALID(): antlr.TerminalNode | null;
    KW_VALIDATE(): antlr.TerminalNode | null;
    KW_VALIDATOR(): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode | null;
    KW_VARYING(): antlr.TerminalNode | null;
    KW_VERSION(): antlr.TerminalNode | null;
    KW_VIEW(): antlr.TerminalNode | null;
    KW_VIEWS(): antlr.TerminalNode | null;
    KW_VOLATILE(): antlr.TerminalNode | null;
    KW_WHITESPACE(): antlr.TerminalNode | null;
    KW_WITHIN(): antlr.TerminalNode | null;
    KW_WITHOUT(): antlr.TerminalNode | null;
    KW_WORK(): antlr.TerminalNode | null;
    KW_WRAPPER(): antlr.TerminalNode | null;
    KW_WRITE(): antlr.TerminalNode | null;
    KW_XML(): antlr.TerminalNode | null;
    KW_YEAR(): antlr.TerminalNode | null;
    KW_YES(): antlr.TerminalNode | null;
    KW_ZONE(): antlr.TerminalNode | null;
    KW_ALIAS(): antlr.TerminalNode | null;
    KW_ASSERT(): antlr.TerminalNode | null;
    KW_CONSTANT(): antlr.TerminalNode | null;
    KW_DEBUG(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_DIAGNOSTICS(): antlr.TerminalNode | null;
    KW_DUMP(): antlr.TerminalNode | null;
    KW_ELSIF(): antlr.TerminalNode | null;
    KW_ERROR(): antlr.TerminalNode | null;
    KW_EXCEPTION(): antlr.TerminalNode | null;
    KW_EXIT(): antlr.TerminalNode | null;
    KW_GET(): antlr.TerminalNode | null;
    KW_INFO(): antlr.TerminalNode | null;
    KW_IS(): antlr.TerminalNode | null;
    KW_LOG(): antlr.TerminalNode | null;
    KW_NOTICE(): antlr.TerminalNode | null;
    KW_OPEN(): antlr.TerminalNode | null;
    KW_PUBLIC(): antlr.TerminalNode | null;
    KW_PERFORM(): antlr.TerminalNode | null;
    KW_PRINT_STRICT_PARAMS(): antlr.TerminalNode | null;
    KW_QUERY(): antlr.TerminalNode | null;
    KW_RAISE(): antlr.TerminalNode | null;
    KW_RETURN(): antlr.TerminalNode | null;
    KW_REVERSE(): antlr.TerminalNode | null;
    KW_ROWTYPE(): antlr.TerminalNode | null;
    KW_SLICE(): antlr.TerminalNode | null;
    KW_SQLSTATE(): antlr.TerminalNode | null;
    KW_STACKED(): antlr.TerminalNode | null;
    KW_USE_COLUMN(): antlr.TerminalNode | null;
    KW_USE_VARIABLE(): antlr.TerminalNode | null;
    KW_VARIABLE_CONFLICT(): antlr.TerminalNode | null;
    KW_WARNING(): antlr.TerminalNode | null;
    KW_OUTER(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ColNameKeywordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BETWEEN(): antlr.TerminalNode | null;
    KW_BIGINT(): antlr.TerminalNode | null;
    bit(): BitContext | null;
    KW_BOOLEAN(): antlr.TerminalNode | null;
    KW_CHAR(): antlr.TerminalNode | null;
    character(): CharacterContext | null;
    KW_COALESCE(): antlr.TerminalNode | null;
    KW_DEC(): antlr.TerminalNode | null;
    KW_DECIMAL(): antlr.TerminalNode | null;
    KW_EXISTS(): antlr.TerminalNode | null;
    KW_EXTRACT(): antlr.TerminalNode | null;
    KW_FLOAT(): antlr.TerminalNode | null;
    KW_GREATEST(): antlr.TerminalNode | null;
    KW_GROUPING(): antlr.TerminalNode | null;
    KW_INOUT(): antlr.TerminalNode | null;
    KW_INT(): antlr.TerminalNode | null;
    KW_INTEGER(): antlr.TerminalNode | null;
    KW_INTERVAL(): antlr.TerminalNode | null;
    KW_LEAST(): antlr.TerminalNode | null;
    KW_NATIONAL(): antlr.TerminalNode | null;
    KW_NCHAR(): antlr.TerminalNode | null;
    KW_NONE(): antlr.TerminalNode | null;
    KW_NORMALIZE(): antlr.TerminalNode | null;
    KW_NULLIF(): antlr.TerminalNode | null;
    numeric(): NumericContext | null;
    KW_OUT(): antlr.TerminalNode | null;
    KW_OVERLAY(): antlr.TerminalNode | null;
    KW_POSITION(): antlr.TerminalNode | null;
    KW_PRECISION(): antlr.TerminalNode | null;
    KW_REAL(): antlr.TerminalNode | null;
    KW_ROW(): antlr.TerminalNode | null;
    KW_SETOF(): antlr.TerminalNode | null;
    KW_SMALLINT(): antlr.TerminalNode | null;
    KW_SUBSTRING(): antlr.TerminalNode | null;
    KW_TIME(): antlr.TerminalNode | null;
    KW_TIMESTAMP(): antlr.TerminalNode | null;
    KW_TREAT(): antlr.TerminalNode | null;
    KW_TRIM(): antlr.TerminalNode | null;
    KW_VALUES(): antlr.TerminalNode | null;
    KW_VARCHAR(): antlr.TerminalNode | null;
    KW_XMLATTRIBUTES(): antlr.TerminalNode | null;
    KW_XMLCONCAT(): antlr.TerminalNode | null;
    KW_XMLELEMENT(): antlr.TerminalNode | null;
    KW_XMLEXISTS(): antlr.TerminalNode | null;
    KW_XMLFOREST(): antlr.TerminalNode | null;
    KW_XMLNAMESPACES(): antlr.TerminalNode | null;
    KW_XMLPARSE(): antlr.TerminalNode | null;
    KW_XMLPI(): antlr.TerminalNode | null;
    KW_XMLROOT(): antlr.TerminalNode | null;
    KW_XMLSERIALIZE(): antlr.TerminalNode | null;
    KW_XMLTABLE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class TypeFuncNameKeywordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_AUTHORIZATION(): antlr.TerminalNode | null;
    KW_BINARY(): antlr.TerminalNode | null;
    KW_COLLATION(): antlr.TerminalNode | null;
    KW_CONCURRENTLY(): antlr.TerminalNode | null;
    KW_CROSS(): antlr.TerminalNode | null;
    KW_CURRENT_SCHEMA(): antlr.TerminalNode | null;
    KW_FREEZE(): antlr.TerminalNode | null;
    KW_FULL(): antlr.TerminalNode | null;
    KW_ILIKE(): antlr.TerminalNode | null;
    KW_INNER(): antlr.TerminalNode | null;
    KW_IS(): antlr.TerminalNode | null;
    KW_ISNULL(): antlr.TerminalNode | null;
    KW_JOIN(): antlr.TerminalNode | null;
    KW_LEFT(): antlr.TerminalNode | null;
    KW_LIKE(): antlr.TerminalNode | null;
    KW_NATURAL(): antlr.TerminalNode | null;
    KW_NOTNULL(): antlr.TerminalNode | null;
    KW_OUTER(): antlr.TerminalNode | null;
    KW_OVERLAPS(): antlr.TerminalNode | null;
    KW_RIGHT(): antlr.TerminalNode | null;
    KW_SIMILAR(): antlr.TerminalNode | null;
    KW_TABLESAMPLE(): antlr.TerminalNode | null;
    KW_VERBOSE(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ReservedKeywordContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ALL(): antlr.TerminalNode | null;
    KW_ANALYSE(): antlr.TerminalNode | null;
    KW_ANALYZE(): antlr.TerminalNode | null;
    KW_AND(): antlr.TerminalNode | null;
    KW_ANY(): antlr.TerminalNode | null;
    KW_ARRAY(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    KW_ASC(): antlr.TerminalNode | null;
    KW_ASYMMETRIC(): antlr.TerminalNode | null;
    KW_BOTH(): antlr.TerminalNode | null;
    KW_CASE(): antlr.TerminalNode | null;
    KW_CAST(): antlr.TerminalNode | null;
    KW_CHECK(): antlr.TerminalNode | null;
    KW_COLLATE(): antlr.TerminalNode | null;
    KW_COLUMN(): antlr.TerminalNode | null;
    KW_CONSTRAINT(): antlr.TerminalNode | null;
    KW_CREATE(): antlr.TerminalNode | null;
    KW_CURRENT_CATALOG(): antlr.TerminalNode | null;
    KW_CURRENT_DATE(): antlr.TerminalNode | null;
    KW_CURRENT_ROLE(): antlr.TerminalNode | null;
    KW_CURRENT_TIME(): antlr.TerminalNode | null;
    KW_CURRENT_TIMESTAMP(): antlr.TerminalNode | null;
    KW_CURRENT_USER(): antlr.TerminalNode | null;
    KW_DEFERRABLE(): antlr.TerminalNode | null;
    KW_DESC(): antlr.TerminalNode | null;
    KW_DISTINCT(): antlr.TerminalNode | null;
    KW_DO(): antlr.TerminalNode | null;
    KW_ELSE(): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode | null;
    KW_EXCEPT(): antlr.TerminalNode | null;
    KW_FALSE(): antlr.TerminalNode | null;
    KW_FETCH(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    KW_FOREIGN(): antlr.TerminalNode | null;
    KW_FROM(): antlr.TerminalNode | null;
    KW_GRANT(): antlr.TerminalNode | null;
    KW_GROUP(): antlr.TerminalNode | null;
    KW_HAVING(): antlr.TerminalNode | null;
    KW_IN(): antlr.TerminalNode | null;
    KW_INITIALLY(): antlr.TerminalNode | null;
    KW_INTERSECT(): antlr.TerminalNode | null;
    KW_LATERAL(): antlr.TerminalNode | null;
    KW_LEADING(): antlr.TerminalNode | null;
    KW_LIMIT(): antlr.TerminalNode | null;
    KW_LOCALTIME(): antlr.TerminalNode | null;
    KW_LOCALTIMESTAMP(): antlr.TerminalNode | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode | null;
    KW_OFFSET(): antlr.TerminalNode | null;
    KW_ON(): antlr.TerminalNode | null;
    KW_ONLY(): antlr.TerminalNode | null;
    KW_OR(): antlr.TerminalNode | null;
    KW_ORDER(): antlr.TerminalNode | null;
    KW_PLACING(): antlr.TerminalNode | null;
    KW_PRIMARY(): antlr.TerminalNode | null;
    KW_REFERENCES(): antlr.TerminalNode | null;
    KW_RETURNING(): antlr.TerminalNode | null;
    KW_SELECT(): antlr.TerminalNode | null;
    KW_SESSION_USER(): antlr.TerminalNode | null;
    KW_SOME(): antlr.TerminalNode | null;
    KW_SYMMETRIC(): antlr.TerminalNode | null;
    KW_TABLE(): antlr.TerminalNode | null;
    KW_THEN(): antlr.TerminalNode | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_TRAILING(): antlr.TerminalNode | null;
    KW_TRUE(): antlr.TerminalNode | null;
    KW_UNION(): antlr.TerminalNode | null;
    KW_UNIQUE(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    KW_USING(): antlr.TerminalNode | null;
    KW_VARIADIC(): antlr.TerminalNode | null;
    KW_WHEN(): antlr.TerminalNode | null;
    KW_WHERE(): antlr.TerminalNode | null;
    KW_WINDOW(): antlr.TerminalNode | null;
    KW_WITH(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class PlBlockContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_BEGIN(): antlr.TerminalNode;
    KW_END(): antlr.TerminalNode;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    exceptionSect(): ExceptionSectContext | null;
    anyIdentifier(): AnyIdentifierContext | null;
    labelDecl(): LabelDeclContext[];
    labelDecl(i: number): LabelDeclContext | null;
    KW_DECLARE(): antlr.TerminalNode[];
    KW_DECLARE(i: number): antlr.TerminalNode | null;
    declStatement(): DeclStatementContext[];
    declStatement(i: number): DeclStatementContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LabelDeclContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    LESS_LESS(): antlr.TerminalNode;
    anyIdentifier(): AnyIdentifierContext;
    GREATER_GREATER(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DeclStatementContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyIdentifier(): AnyIdentifierContext;
    SEMI(): antlr.TerminalNode;
    KW_ALIAS(): antlr.TerminalNode | null;
    KW_FOR(): antlr.TerminalNode | null;
    typename(): TypenameContext | null;
    KW_CURSOR(): antlr.TerminalNode | null;
    selectStmt(): SelectStmtContext | null;
    KW_IS(): antlr.TerminalNode | null;
    PARAM(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    KW_CONSTANT(): antlr.TerminalNode | null;
    collateClause(): CollateClauseContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    KW_NULL(): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext | null;
    KW_SCROLL(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    declCursorArg(): DeclCursorArgContext[];
    declCursorArg(i: number): DeclCursorArgContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    assignOperator(): AssignOperatorContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DeclCursorArgContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyIdentifier(): AnyIdentifierContext;
    typename(): TypenameContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AssignOperatorContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    EQUAL(): antlr.TerminalNode | null;
    COLON_EQUALS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    plBlock(): PlBlockContext | null;
    SEMI(): antlr.TerminalNode | null;
    stmtReturn(): StmtReturnContext | null;
    stmtRaise(): StmtRaiseContext | null;
    stmtAssign(): StmtAssignContext | null;
    stmtIf(): StmtIfContext | null;
    stmtCase(): StmtCaseContext | null;
    stmtLoopWhileFor(): StmtLoopWhileForContext | null;
    stmtForeach(): StmtForeachContext | null;
    stmtExit(): StmtExitContext | null;
    stmtAssert(): StmtAssertContext | null;
    stmtExecsql(): StmtExecsqlContext | null;
    stmtDynexecute(): StmtDynexecuteContext | null;
    stmtPerform(): StmtPerformContext | null;
    stmtCall(): StmtCallContext | null;
    stmtGetdiag(): StmtGetdiagContext | null;
    stmtOpen(): StmtOpenContext | null;
    stmtFetch(): StmtFetchContext | null;
    stmtMove(): StmtMoveContext | null;
    stmtClose(): StmtCloseContext | null;
    stmtNull(): StmtNullContext | null;
    stmtCommitOrRollback(): StmtCommitOrRollbackContext | null;
    stmtSet(): StmtSetContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtPerformContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_PERFORM(): antlr.TerminalNode;
    sqlExpression(): SqlExpressionContext;
    SEMI(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtCallContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CALL(): antlr.TerminalNode | null;
    anyIdentifier(): AnyIdentifierContext;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    SEMI(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    KW_DO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtAssignContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    assignVar(): AssignVarContext;
    assignOperator(): AssignOperatorContext;
    sqlExpression(): SqlExpressionContext;
    SEMI(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtGetdiagContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_GET(): antlr.TerminalNode;
    KW_DIAGNOSTICS(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    getdiagListItem(): GetdiagListItemContext[];
    getdiagListItem(i: number): GetdiagListItemContext | null;
    KW_CURRENT(): antlr.TerminalNode | null;
    KW_STACKED(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class GetdiagListItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    assignVar(): AssignVarContext;
    assignOperator(): AssignOperatorContext;
    colId(): ColIdContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AssignVarContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyName(): AnyNameContext | null;
    PARAM(): antlr.TerminalNode | null;
    OPEN_BRACKET(): antlr.TerminalNode[];
    OPEN_BRACKET(i: number): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    CLOSE_BRACKET(): antlr.TerminalNode[];
    CLOSE_BRACKET(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtIfContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_IF(): antlr.TerminalNode[];
    KW_IF(i: number): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext;
    KW_THEN(): antlr.TerminalNode[];
    KW_THEN(i: number): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    stmtElse(): StmtElseContext | null;
    KW_ELSIF(): antlr.TerminalNode[];
    KW_ELSIF(i: number): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtElseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ELSE(): antlr.TerminalNode;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtCaseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CASE(): antlr.TerminalNode[];
    KW_CASE(i: number): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    sqlExpression(): SqlExpressionContext | null;
    KW_WHEN(): antlr.TerminalNode[];
    KW_WHEN(i: number): antlr.TerminalNode | null;
    exprList(): ExprListContext[];
    exprList(i: number): ExprListContext | null;
    KW_THEN(): antlr.TerminalNode[];
    KW_THEN(i: number): antlr.TerminalNode | null;
    stmtElse(): StmtElseContext | null;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtLoopWhileForContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    loopBody(): LoopBodyContext;
    labelDecl(): LabelDeclContext | null;
    KW_WHILE(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_FOR(): antlr.TerminalNode | null;
    forControl(): ForControlContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ForControlContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyNameList(): AnyNameListContext;
    KW_IN(): antlr.TerminalNode;
    colId(): ColIdContext | null;
    selectStmt(): SelectStmtContext | null;
    explainStmt(): ExplainStmtContext | null;
    KW_EXECUTE(): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    DOT_DOT(): antlr.TerminalNode | null;
    executeParamClause(): ExecuteParamClauseContext | null;
    KW_USING(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    KW_REVERSE(): antlr.TerminalNode | null;
    KW_BY(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtForeachContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FOREACH(): antlr.TerminalNode;
    anyNameList(): AnyNameListContext;
    KW_IN(): antlr.TerminalNode;
    KW_ARRAY(): antlr.TerminalNode;
    expression(): ExpressionContext;
    loopBody(): LoopBodyContext;
    labelDecl(): LabelDeclContext | null;
    KW_SLICE(): antlr.TerminalNode | null;
    Integral(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtExitContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    SEMI(): antlr.TerminalNode;
    KW_EXIT(): antlr.TerminalNode | null;
    KW_CONTINUE(): antlr.TerminalNode | null;
    anyIdentifier(): AnyIdentifierContext | null;
    KW_WHEN(): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtReturnContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_RETURN(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    KW_NEXT(): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext | null;
    KW_QUERY(): antlr.TerminalNode | null;
    KW_EXECUTE(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_USING(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    selectStmt(): SelectStmtContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtRaiseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_RAISE(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode | null;
    identifier(): IdentifierContext | null;
    KW_USING(): antlr.TerminalNode | null;
    KW_DEBUG(): antlr.TerminalNode | null;
    KW_LOG(): antlr.TerminalNode | null;
    KW_INFO(): antlr.TerminalNode | null;
    KW_NOTICE(): antlr.TerminalNode | null;
    KW_WARNING(): antlr.TerminalNode | null;
    KW_EXCEPTION(): antlr.TerminalNode | null;
    KW_SQLSTATE(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    optRaiseUsingElem(): OptRaiseUsingElemContext[];
    optRaiseUsingElem(i: number): OptRaiseUsingElemContext | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    expression(): ExpressionContext[];
    expression(i: number): ExpressionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptRaiseUsingElemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    identifier(): IdentifierContext;
    EQUAL(): antlr.TerminalNode;
    expression(): ExpressionContext;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtAssertContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_ASSERT(): antlr.TerminalNode;
    sqlExpression(): SqlExpressionContext[];
    sqlExpression(i: number): SqlExpressionContext | null;
    SEMI(): antlr.TerminalNode;
    COMMA(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class LoopBodyContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_LOOP(): antlr.TerminalNode[];
    KW_LOOP(i: number): antlr.TerminalNode | null;
    KW_END(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    anyIdentifier(): AnyIdentifierContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtExecsqlContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    stmt(): StmtContext;
    SEMI(): antlr.TerminalNode;
    optExecuteInto(): OptExecuteIntoContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtDynexecuteContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_EXECUTE(): antlr.TerminalNode;
    expression(): ExpressionContext;
    SEMI(): antlr.TerminalNode;
    optExecuteInto(): OptExecuteIntoContext | null;
    KW_USING(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptExecuteIntoContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INTO(): antlr.TerminalNode;
    exprList(): ExprListContext;
    KW_STRICT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtOpenContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_OPEN(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    cursorVariable(): CursorVariableContext | null;
    KW_FOR(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    selectStmt(): SelectStmtContext | null;
    KW_EXECUTE(): antlr.TerminalNode | null;
    sqlExpression(): SqlExpressionContext | null;
    KW_SCROLL(): antlr.TerminalNode | null;
    OPEN_PAREN(): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    KW_USING(): antlr.TerminalNode | null;
    exprList(): ExprListContext | null;
    optOpenBoundListItem(): OptOpenBoundListItemContext[];
    optOpenBoundListItem(i: number): OptOpenBoundListItemContext | null;
    KW_NO(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptOpenBoundListItemContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    expression(): ExpressionContext;
    colId(): ColIdContext | null;
    COLON_EQUALS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtFetchContext extends antlr.ParserRuleContext {
    _direction?: OptFetchFirectionContext;
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_FETCH(): antlr.TerminalNode;
    cursorVariable(): CursorVariableContext;
    KW_INTO(): antlr.TerminalNode;
    exprList(): ExprListContext;
    SEMI(): antlr.TerminalNode;
    fromIn(): FromInContext | null;
    optFetchFirection(): OptFetchFirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class OptFetchFirectionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NEXT(): antlr.TerminalNode | null;
    KW_PRIOR(): antlr.TerminalNode | null;
    KW_FIRST(): antlr.TerminalNode | null;
    KW_LAST(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_ABSOLUTE(): antlr.TerminalNode | null;
    KW_RELATIVE(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    KW_FORWARD(): antlr.TerminalNode | null;
    KW_BACKWARD(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtMoveContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_MOVE(): antlr.TerminalNode;
    cursorVariable(): CursorVariableContext;
    SEMI(): antlr.TerminalNode;
    optFetchFirection(): OptFetchFirectionContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class MergeStmtContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_MERGE(): antlr.TerminalNode;
    KW_INTO(): antlr.TerminalNode;
    tableName(): TableNameContext;
    KW_USING(): antlr.TerminalNode;
    dataSource(): DataSourceContext;
    KW_ON(): antlr.TerminalNode;
    expression(): ExpressionContext;
    withClause(): WithClauseContext | null;
    KW_ONLY(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    colId(): ColIdContext | null;
    mergeWhenClause(): MergeWhenClauseContext[];
    mergeWhenClause(i: number): MergeWhenClauseContext | null;
    returningClause(): ReturningClauseContext | null;
    KW_AS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DataSourceContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    tableName(): TableNameContext | null;
    colId(): ColIdContext | null;
    selectNoParens(): SelectNoParensContext | null;
    valuesClause(): ValuesClauseContext | null;
    KW_ONLY(): antlr.TerminalNode | null;
    STAR(): antlr.TerminalNode | null;
    KW_AS(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class MergeWhenClauseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_WHEN(): antlr.TerminalNode;
    KW_MATCHED(): antlr.TerminalNode;
    KW_THEN(): antlr.TerminalNode;
    mergeUpdate(): MergeUpdateContext | null;
    KW_DELETE(): antlr.TerminalNode | null;
    KW_DO(): antlr.TerminalNode | null;
    KW_NOTHING(): antlr.TerminalNode | null;
    KW_AND(): antlr.TerminalNode | null;
    expression(): ExpressionContext | null;
    KW_NOT(): antlr.TerminalNode | null;
    mergeInsert(): MergeInsertContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class MergeInsertContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_INSERT(): antlr.TerminalNode;
    defaultValuesOrValues(): DefaultValuesOrValuesContext;
    optColumnList(): OptColumnListContext | null;
    KW_OVERRIDING(): antlr.TerminalNode | null;
    KW_VALUE(): antlr.TerminalNode | null;
    KW_SYSTEM(): antlr.TerminalNode | null;
    KW_USER(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class MergeUpdateContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_UPDATE(): antlr.TerminalNode;
    KW_SET(): antlr.TerminalNode;
    columnName(): ColumnNameContext[];
    columnName(i: number): ColumnNameContext | null;
    EQUAL(): antlr.TerminalNode[];
    EQUAL(i: number): antlr.TerminalNode | null;
    exprofdefault(): ExprofdefaultContext[];
    exprofdefault(i: number): ExprofdefaultContext | null;
    optColumnList(): OptColumnListContext[];
    optColumnList(i: number): OptColumnListContext | null;
    OPEN_PAREN(): antlr.TerminalNode[];
    OPEN_PAREN(i: number): antlr.TerminalNode | null;
    CLOSE_PAREN(): antlr.TerminalNode[];
    CLOSE_PAREN(i: number): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class DefaultValuesOrValuesContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_VALUES(): antlr.TerminalNode;
    OPEN_PAREN(): antlr.TerminalNode | null;
    exprofdefault(): ExprofdefaultContext[];
    exprofdefault(i: number): ExprofdefaultContext | null;
    CLOSE_PAREN(): antlr.TerminalNode | null;
    COMMA(): antlr.TerminalNode[];
    COMMA(i: number): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExprofdefaultContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    sortBy(): SortByContext | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtCloseContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_CLOSE(): antlr.TerminalNode;
    cursorVariable(): CursorVariableContext;
    SEMI(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtNullContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_NULL(): antlr.TerminalNode;
    SEMI(): antlr.TerminalNode;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtCommitOrRollbackContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    SEMI(): antlr.TerminalNode;
    KW_COMMIT(): antlr.TerminalNode | null;
    KW_ROLLBACK(): antlr.TerminalNode | null;
    KW_AND(): antlr.TerminalNode | null;
    KW_CHAIN(): antlr.TerminalNode | null;
    KW_NO(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class StmtSetContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_SET(): antlr.TerminalNode | null;
    anyName(): AnyNameContext | null;
    KW_TO(): antlr.TerminalNode | null;
    KW_DEFAULT(): antlr.TerminalNode | null;
    SEMI(): antlr.TerminalNode;
    KW_RESET(): antlr.TerminalNode | null;
    KW_ALL(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class CursorVariableContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext | null;
    PARAM(): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ExceptionSectContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    KW_EXCEPTION(): antlr.TerminalNode;
    KW_WHEN(): antlr.TerminalNode[];
    KW_WHEN(i: number): antlr.TerminalNode | null;
    KW_THEN(): antlr.TerminalNode[];
    KW_THEN(i: number): antlr.TerminalNode | null;
    procCondition(): ProcConditionContext[];
    procCondition(i: number): ProcConditionContext | null;
    procStmt(): ProcStmtContext[];
    procStmt(i: number): ProcStmtContext | null;
    KW_OR(): antlr.TerminalNode[];
    KW_OR(i: number): antlr.TerminalNode | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class ProcConditionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    anyIdentifier(): AnyIdentifierContext | null;
    KW_SQLSTATE(): antlr.TerminalNode | null;
    stringConst(): StringConstContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class AnyIdentifierContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    colId(): ColIdContext | null;
    unreservedKeyword(): UnreservedKeywordContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
export declare class SqlExpressionContext extends antlr.ParserRuleContext {
    constructor(parent: antlr.ParserRuleContext | null, invokingState: number);
    targetList(): TargetListContext | null;
    intoClause(): IntoClauseContext | null;
    fromClause(): FromClauseContext | null;
    whereClause(): WhereClauseContext | null;
    groupClause(): GroupClauseContext | null;
    havingClause(): HavingClauseContext | null;
    windowClause(): WindowClauseContext | null;
    get ruleIndex(): number;
    enterRule(listener: PostgreSqlParserListener): void;
    exitRule(listener: PostgreSqlParserListener): void;
    accept<Result>(visitor: PostgreSqlParserVisitor<Result>): Result | null;
}
